/******************************************************************************/
/*                                                                            */
/*    Copyright (c)The 3Delight Developers.                                   */
/*    All Rights Reserved.                                                    */
/*                                                                            */
/******************************************************************************/

// ===========================================================================
// = LIBRARY
//     3DeLight
// = FILENAME
//     dlDSO.h
// = AUTHOR(S)
//     Patrick Fournier
// = VERSION
//     $Revision$
// = DATE RELEASED
//     $Date: 2007-01-15 16:40:52 -0500 (Mon, 15 Jan 2007) $
// = RCSID
//     $Id: dlDSO.h 9700 2007-01-15 21:40:52Z olivier $
// = COPYRIGHT
//     Copyright  1999-2000 The 3Delight Developers.
//     All Rights Reserved.
// ===========================================================================
#ifndef __dlDSO_H
#define __dlDSO_H

#include "dlInterface.h"

#if defined(_WIN32)

/* ignored on windows but required for compatibility */
#define RTLD_LAZY	0x1
#define RTLD_NOW	0x2
#define RTLD_LOCAL	0x4
#define RTLD_GLOBAL	0x8

#elif defined(DARWIN)

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <stdarg.h>
#include <limits.h>
#include <mach-o/dyld.h>
#include "dlfcn.h"

#define RTLD_LAZY	0x1
#define RTLD_NOW	0x2
#define RTLD_LOCAL	0x4
#define RTLD_GLOBAL	0x8

#else

#include <dlfcn.h>

#endif

#ifdef __cplusplus
extern "C" {
#endif

typedef void* DlDSO;

DL_INTERFACE DlDSO DlOpenDSO( const char* i_fullName, int mode );
DL_INTERFACE void* DlGetDSOSymbol( DlDSO i_dso, const char* i_name );
DL_INTERFACE void DlCloseDSO( DlDSO i_dso );
DL_INTERFACE const char* DlDSOError( void );

#ifdef __cplusplus
}
#endif

#endif
