/******************************************************************************/
/*                                                                            */
/*    Copyright (c)The 3Delight Developers.                                   */
/*    All Rights Reserved.                                                    */
/*                                                                            */
/******************************************************************************/

// ===========================================================================
// = LIBRARY
//		 3delight
// = FILENAME
//		 dlStopAndBool.h
// = AUTHOR(S)
//		 Marco Jacques
// = VERSION
//		 $Revision$
// = DATE RELEASED
//		 $Date: 2000-11-03 19:38:43 -0500 (Fri, 03 Nov 2000) $
// = RCSID
//		 $Id: dlStopAndBool.h 1157 2000-11-04 00:38:43Z marco $
// = COPYRIGHT
//     Copyright  1999-2000 The 3Delight Developers.
//     All Rights Reserved.
// ===========================================================================

#ifndef __dlStopAndBool
#define __dlStopAndBool

////////////////////////////////////////////////////////////////////////////////
// DlStopAndBool
//
// Type that defines a flag that is used during SIMD calculations.
// The flag can have 4 values.
//
// - false         : a boolean test that is false
// - true          : a boolean test that is true
////////////////////////////////////////////////////////////////////////////////

#define DL_SB_FALSE			0
#define DL_SB_TRUE			1

typedef unsigned int DlStopAndBool;

#define BOOL_IS_TRUE(B)               ((B))

#define BOOL_IS_FALSE(B)              (!(B))

#define SET_BOOL(B, C)                ((B) = (C))

#define IS_VAR_BOOL_FLAG_SET(B, i)    ((B)[i])

#endif

