// outputs an AVI given a series of bitmap bits

#pragma once
#include "resource.h"       // main symbols
#include <vfw.h>

class CAVIFile
{
public:
	CAVIFile();
	~CAVIFile();

    HRESULT ChooseCodec(HWND hwnd);
    HRESULT CreateFile(CStringA filename, int framerate);    
    HRESULT AddFrame(int width, int height, LPVOID pBits, int bpp);

    CStringA GetLastErrorMessage() { return m_errorMsg; }

private:
    HDC m_hAVIDC;
	LONG m_frameIndex;
	PAVIFILE m_pAVIFile;
	PAVISTREAM m_pAVIStream;
	PAVISTREAM m_pAVICompressedStream;
	AVISTREAMINFO m_AVIStreamInfo;
	AVICOMPRESSOPTIONS m_AVICompressOptions;
	DWORD m_frameRate;
	DWORD m_fccHandler;
	CStringA m_fileName;
	CStringA m_errorMsg;
    
	HRESULT InitMovie(int width, int height, int bpp);
	void ReleaseMemory();
    void SetErrorMessage(CStringA err) { m_errorMsg = err; }

    
};
