/////////////////////////////////////////////////////////////////////////////
//
// NexgenIPL - Next Generation Image Processing Library
// Copyright (c) 1999-2001 Binary Technologies
// All Rights Reserved.
//
// This code may be used in compiled form in any way you desire. This
// file may be redistributed unmodified by any means PROVIDING it is 
// not sold for profit without the authors written consent, and 
// providing that this notice and the authors name is included. If 
// the source code in this file is used in any commercial application 
// then a simple email would be nice.
//
// THIS SOFTWARE IS PROVIDED BY BINARY TECHNOLOGIES ``AS IS'' AND ANY
// EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
// IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
// PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL BINARY TECHNOLOGIES OR
// CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
// EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
// PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
// PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
// OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
// USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
// DAMAGE.
//
// Binary Technologies
// http://www.binary-technologies.com
// info@binary-technologies.com
//
/////////////////////////////////////////////////////////////////////////////

#ifndef BTCCOLOR_INCLUDED
#define BTCCOLOR_INCLUDED

#pragma once

#include "BTNexgenIPL.h"
#include "BTDefines.h"

typedef struct tagBTHLS
{
	double Hue;
	double Lightness;
	double Saturation;
} BTHLS;

typedef struct tagBTHSB
{
	double Hue;
	double Saturation;
	double Brightness;
} BTHSB;

class BTNEXGENIPL_CLASS_EXPORT BTCColor
{
public:
	BTCColor();
	virtual ~BTCColor();

	static BTHSB      RGB2HSB(BTCOLORREF col);
	static BTCOLORREF HSB2RGB(const BTHSB& hsb);
	static BTCOLORREF HSB2RGB(double H, double S, double B);

	static BTHLS      RGB2HLS(BTCOLORREF col);
	static BTCOLORREF HLS2RGB(const BTHLS& hls);
	static BTCOLORREF HLS2RGB(double H, double L, double S);

	static double GetHLSValue(double m1, double m2, double hue);
	static double GetHue(BTCOLORREF col);
	static double GetLightness(BTCOLORREF col);
	static double GetSaturation(BTCOLORREF col);
	static double GetBrightness(BTCOLORREF col);
	static double GetLuminance(BTCOLORREF col);
	static double GetIntensity(BTCOLORREF col);
};

#endif // BTCCOLOR_INCLUDED