// EnviroTab.cpp : implementation file
//

#include "stdafx.h"
#include "dribble.h"
#include "EnviroTab.h"


// CEnviroTab dialog

IMPLEMENT_DYNAMIC(CEnviroTab, CDialog)

CEnviroTab::CEnviroTab(CWnd* pParent /*=NULL*/)
	: CDialog(CEnviroTab::IDD, pParent)
{

}

CEnviroTab::~CEnviroTab()
{
}

void CEnviroTab::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);

	DDX_Control(pDX, IDC_ENV_SHOW_BACKGROUND, m_envShowBackground);
	DDX_Control(pDX, IDC_ENV_SHOW_REFLECTIONS, m_envShowReflections);
	
	DDX_Control(pDX, IDC_ENV_EXPOSURE, m_envExposure);
	DDX_Control(pDX, IDC_ENV_SIZE, m_envSize);

	DDX_Control(pDX, IDC_ENVLIGHT_INTENSITY, m_envLightIntensity);
	DDX_Control(pDX, IDC_ENVLIGHT_SHADOWS, m_envLightShadows);
	DDX_Control(pDX, IDC_ENVLIGHT_SAMPLES, m_envLightSamples);
	DDX_Control(pDX, IDC_ENVLIGHT_EXPOSURE, m_envLightExposure);
}


BEGIN_MESSAGE_MAP(CEnviroTab, CDialog)
	ON_MESSAGE( WM_CTLCOLORDLG, OnDlgBGColor )
	ON_MESSAGE( WM_CTLCOLORSTATIC, OnDlgBGColor )
	ON_MESSAGE( WM_CHECKBOXCHANGED, OnCheckBoxChanged )	
END_MESSAGE_MAP()


// CEnviroTab message handlers

LRESULT CEnviroTab::OnDlgBGColor( WPARAM wParam, LPARAM lParam )
{
	HDC hdcStatic = (HDC)wParam;
    SetTextColor(hdcStatic, RGB(0, 0, 0));
    SetBkMode(hdcStatic, TRANSPARENT);
	return (LONG)theApp.g_hbrBackground;
}

// Called when the value of a checkbox is changed
LRESULT CEnviroTab::OnCheckBoxChanged(WPARAM wParam, LPARAM lParam)
{
	// We know that *one* of the controls triggered this message,
	// let's see if it's the one we want
	
	/*if (wParam == m_current.GetDlgCtrlID())
	{
		if (m_current.Checked == TRUE)
		{
			m_all.SetChecked(FALSE);
			m_range.SetChecked(FALSE);
		}
	}

	if (wParam == m_all.GetDlgCtrlID())
	{
		if (m_all.Checked == TRUE)
		{
			m_current.SetChecked(FALSE);
			m_range.SetChecked(FALSE);
		}
	}

	if (wParam == m_range.GetDlgCtrlID())
	{
		if (m_range.Checked == TRUE)
		{
			m_all.SetChecked(FALSE);
			m_current.SetChecked(FALSE);
		}
	}*/

	
	return 0L;
}


void CEnviroTab::OnFilename() 
{
	// pop up a file dialog and get the filename
	CFileDialog dlg( TRUE, _T("*.hdr"), _T("*.hdr"),
	                 OFN_EXPLORER,
	                 _T("High dynamic range light probes (*.hdr)|*.rib|All files|*.*|"));

	
	if( dlg.DoModal()==IDOK )
	{
		m_strFilename = dlg.GetPathName();

		m_envFilename.SetCaption( (char*)((LPCSTR)m_strFilename) );
	}
}
