// MainDlg.cpp : implementation file
//

#include "stdafx.h"
#include "dribble.h"
#include "MainDlg.h"

#include "wfmmshaders.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


#include "wfmmshaders.h"

#include "XMLSettings.h"

CXMLSettings xml;

#ifndef _DEBUG
CString CaptionText = "dribble 1.04wip080808";
#else
CString CaptionText = "dribble 1.04wip080808 DEBUG";
#endif

const int ROLLUP_HEIGHT = 35;

short OrigMouseX;
short OrigMouseY;
short LastX, LastY, OldX, OldY;

extern int g_tsxid;

/////////////////////////////////////////////////////////////////////////////
// CMainDlg dialog


CMainDlg::CMainDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMainDlg::IDD, pParent)
{
	theApp.VLFilename = "i:\\vltests\\output";
	theApp.VLightPath = "h:\\vl\\bin\\vlight.exe";

	//{{AFX_DATA_INIT(CMainDlg)
	//}}AFX_DATA_INIT
}


void CMainDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMainDlg)
	DDX_Control(pDX, IDC_SAVESETTINGS, m_savesettings);
	DDX_Control(pDX, IDC_LOADSETTINGS, m_loadsettings);
	DDX_Control(pDX, IDC_TABCTRL, m_tabctrl);
	DDX_Control(pDX, IDC_ROLLUPBTN, m_RollupButton);
	DDX_Control(pDX, IDC_CLOSEBTN, m_CloseButton);
	DDX_Control(pDX, IDC_RENDERSCENE_BTN, m_btnRenderScene);
	DDX_Control(pDX, IDC_RENDERFILE_BTN, m_btnRenderFile);
	DDX_Control(pDX, IDC_EXPORT_BTN, m_ExportBtn );
	DDX_Control(pDX, IDC_AREARENDER_BTN, m_btnRenderArea);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMainDlg, CDialog)
	//{{AFX_MSG_MAP(CMainDlg)
	ON_WM_PAINT()
	ON_WM_NCHITTEST()
	ON_BN_CLICKED(IDC_GO_BTN, OnGoBtn)
	ON_BN_CLICKED(IDC_EXPORT_BTN, OnExportBtn )
	ON_BN_CLICKED(IDC_RENDERFILE_BTN, OnRenderFileBtn )
	ON_BN_CLICKED(IDC_AREARENDER_BTN, OnAreaRenderBtn )
	ON_BN_CLICKED(IDC_CLOSEBTN, OnCloseBtn)
	ON_BN_CLICKED(IDC_ROLLUPBTN, OnRollup)
	ON_BN_CLICKED(IDC_LOADSETTINGS, OnLoadsettings)
	ON_BN_CLICKED(IDC_SAVESETTINGS, OnSavesettings)
	ON_WM_CLOSE()
	ON_MESSAGE( WM_CHECKBOXCHANGED, OnCheckBoxChanged )
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMainDlg message handlers

void CMainDlg::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here

	CRect myRect;
	GetClientRect(myRect);
	
	CPen myPen;

	// fill the background
	dc.FillSolidRect(myRect, RGB(192,192,192));

	// draw the caption bar
	CRect CaptionRect;
	CaptionRect.left = 0;
	CaptionRect.top = 1;
	CaptionRect.right = myRect.right-1;
	CaptionRect.bottom = 12;
	CFont CaptionFont;
	CaptionFont.CreateFont(-9,0,0,0,FW_NORMAL,FALSE,FALSE,
		0,ANSI_CHARSET,OUT_TT_PRECIS,
		CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,
		FF_SWISS,"Arial");
	CFont* oldfont = dc.SelectObject(&CaptionFont);
	dc.FillSolidRect(CaptionRect, GetSysColor(COLOR_ACTIVECAPTION));
	dc.SetTextColor(GetSysColor(COLOR_CAPTIONTEXT));
	dc.DrawText(CaptionText, -1, CaptionRect, DT_CENTER);
	dc.SelectObject(oldfont);
	CaptionFont.DeleteObject();

	
	
	// draw the black line
	myPen.CreatePen(PS_SOLID, 1, RGB(0,0,0));
	CPen* oldpen = dc.SelectObject(&myPen);
	dc.MoveTo(0, 12);
	dc.LineTo(myRect.right-1, 12);
	dc.SelectObject(oldpen);
	myPen.DeleteObject();

	// draw the outside border
	myPen.CreatePen(PS_SOLID, 1, RGB(255,255,255));
	oldpen = dc.SelectObject(&myPen);
	dc.MoveTo(0, myRect.bottom-1);
	dc.LineTo(0,0);
	dc.LineTo(myRect.right-1, 0);
	dc.SelectObject(oldpen);
	myPen.DeleteObject();
	myPen.CreatePen(PS_SOLID, 1, RGB(0,0,0));
	oldpen = dc.SelectObject(&myPen);
	if ( Rolled )
	{
		dc.LineTo(myRect.right-1, ROLLUP_HEIGHT);
		dc.LineTo(0, ROLLUP_HEIGHT);
	}
	else
	{
		dc.LineTo(myRect.right-1,myRect.bottom-1);
		dc.LineTo(0, myRect.bottom-1);
	}
	dc.SelectObject(oldpen);
	myPen.DeleteObject();

}


// Override the hittest to allow dragging from anywhere on the dialog
LRESULT CMainDlg::OnNcHitTest(CPoint point) 
{
	return HTCAPTION;
}

// this is called when the dialog needs to be destroyed
void CMainDlg::PostNcDestroy() 
{
	m_pOutputTab->DestroyWindow();
	m_pLightsTab->DestroyWindow();
	m_pGITab->DestroyWindow();
	//m_pCamTab->DestroyWindow();
	m_pEnviroTab->DestroyWindow();
	
	delete m_pOutputTab;
	delete m_pLightsTab;
	delete m_pGITab;
	//delete m_pCamTab;
	delete m_pEnviroTab;
	
	m_pMainDialog = NULL;
	delete this;
}

// this is called when the dialog is to be closed
void CMainDlg::OnCloseBtn() 
{
	this->DestroyWindow();
}


void CMainDlg::OnRollup() 
{
	CRect TheRect;
	if (Rolled == FALSE)
	{
		Rolled = TRUE;
		// Store old size
		GetWindowRect(TheRect);
		OldHeight = TheRect.Height();
		MoveWindow(TheRect.left, TheRect.top, TheRect.Width(), ROLLUP_HEIGHT);
		Invalidate();
	}
	else
	{
		Rolled = FALSE;
		GetWindowRect(TheRect);
		MoveWindow(TheRect.left, TheRect.top, TheRect.Width(), OldHeight);
		Invalidate();
	}
}

BOOL CMainDlg::DestroyWindow() 
{
	CRect TheRect;
	GetWindowRect(TheRect);
	// write window position to the system registry
	AfxGetApp()->WriteProfileInt("MainPanel","PanelX", TheRect.left);
	AfxGetApp()->WriteProfileInt("MainPanel","PanelY", TheRect.top);

	AfxGetApp()->WriteProfileString("Settings","VLightPath", theApp.VLightPath);
	AfxGetApp()->WriteProfileString("Settings","Filename", theApp.VLFilename);

	return CDialog::DestroyWindow();
}

/////////////////////////////////////////////////////////////////////////////

void CMainDlg::Export( bool file )
{	
	UpdateUI( false );

	long DPWidth, DPHeight;
	tsxAViewGetDrawportSize( &DPWidth, &DPHeight );
	theApp.g_Exporter.FormatWidth = DPWidth;
	theApp.g_Exporter.FormatHeight = DPHeight;
	
	if ( OrigMouseX > -1 )
	{
		theApp.g_Exporter.m_SubRect.left = OrigMouseX;
		theApp.g_Exporter.m_SubRect.top = OrigMouseY;
		theApp.g_Exporter.m_SubRect.right = LastX;
		theApp.g_Exporter.m_SubRect.bottom = LastY;		
	}
	else
		theApp.g_Exporter.m_SubRect.SetRectEmpty();
	

	theApp.g_Exporter.m_useMotionBlur = false;
	theApp.g_Exporter.FirstFrame = tsxAnimGetActiveTime();
	theApp.g_Exporter.LastFrame = theApp.g_Exporter.FirstFrame;

	//theApp.g_Exporter.FormatWidth = m_pCamTab->m_camwidth.Position;
	//theApp.g_Exporter.FormatHeight = m_pCamTab->m_camheight.Position;
	//theApp.g_Exporter.FormatAspect = m_pCamTab->m_camaspect.Position;
	

	theApp.g_Exporter.m_cacheOverride = m_pOutputTab->m_cacheOverride.Checked;

	
	theApp.g_Exporter.m_doRaytraceDisplacements = true;
	theApp.g_Exporter.m_doRaytraceMotionBlur = true;

	

	// TODO: this is unreliable so we'll have to make it user-specifiable :(
	/*char* scnpath = tsxGetTSDir(e_tsxPATH_SCENE);
	
	char drive[_MAX_PATH];
	char dir[_MAX_PATH];
	char fname[_MAX_PATH];
	char ext[_MAX_PATH];

	
	_splitpath( scnpath, drive, dir, fname, ext );


	theApp.g_Exporter.ShadmapDirectory.Format( "%s%s", drive, dir );
	theApp.g_Exporter.TextureDirectory = theApp.g_Exporter.ShadmapDirectory;
	theApp.g_Exporter.RIBDirectory = theApp.g_Exporter.ShadmapDirectory;
	theApp.g_Exporter.Filename.Format( "%s.rib", fname );
	theApp.g_Exporter.ImageName.Format( "%s", fname );*/

	theApp.g_Exporter.ShadmapDirectory.Format( "%s\\workingdata\\", theApp.g_BaseDir );
	theApp.g_Exporter.TextureDirectory = theApp.g_Exporter.ShadmapDirectory;
	theApp.g_Exporter.RIBDirectory = theApp.g_Exporter.ShadmapDirectory;
	theApp.g_Exporter.Filename.Format( "output.rib" );
	theApp.g_Exporter.ImageName.Format( "output" );


	theApp.g_Exporter.ReadtSRenderOptions();

	theApp.g_Exporter.m_refreshShadmaps = ( theApp.g_refreshShadmaps || theApp.g_Exporter.m_cacheOverride );

	theApp.g_Exporter.PSDOutput = false;

	// pop up dialog box to get .rib filename
	// this is awful coding
	if ( file )
	{
		CFileDialog dlg( FALSE,_T("rib"),_T("*.rib"),
	                 OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,
	                 _T("RenderMan Interface Bytestreams (*.rib)|*.rib|All files|*.*|"));

		if ( dlg.DoModal() == IDOK )
		{
			char drive[_MAX_PATH];
			char dir[_MAX_PATH];
			char fname[_MAX_PATH];
			char ext[_MAX_PATH];

			
			_splitpath( dlg.GetPathName(), drive, dir, fname, ext );
			
			theApp.g_Exporter.RIBDirectory.Format( "%s%s", drive, dir );
			theApp.g_Exporter.Filename.Format( "%s%s", fname, ext );
		}
	}

	theApp.g_Exporter.ExportScene( file );

	theApp.g_refreshShadmaps = false;


}


// this function is called when the user presses the go button
void CMainDlg::OnGoBtn()
{
	/*if (!FileExists(theApp.VLightPath.GetBuffer(theApp.VLightPath.GetLength())))
	{
		MessageBox("The path to VirtuaLight is not correctly set in the Output tab");
		return;
	}*/
	Export( false );
	
	return;
}

void CMainDlg::OnExportBtn()
{
	Export( true );
}

void CMainDlg::OnRenderFileBtn()
{
	UpdateUI( false );

	theApp.g_Exporter.m_cacheOverride = m_pOutputTab->m_cacheOverride.Checked;
	theApp.g_Exporter.m_doRaytraceDisplacements = true;
	theApp.g_Exporter.ShadmapDirectory.Format( "%s\\workingdata\\", theApp.g_BaseDir );
	theApp.g_Exporter.TextureDirectory = theApp.g_Exporter.ShadmapDirectory;
	theApp.g_Exporter.RIBDirectory = theApp.g_Exporter.ShadmapDirectory;
	theApp.g_Exporter.Filename.Format( "output.rib" );
	theApp.g_Exporter.ImageName.Format( "output" );
	theApp.g_Exporter.m_SubRect.SetRectEmpty();


	theApp.g_Exporter.ReadtSRenderOptions();

	theApp.g_Exporter.m_refreshShadmaps = ( theApp.g_refreshShadmaps || theApp.g_Exporter.m_cacheOverride );

	theApp.RenderToFile();

	theApp.g_refreshShadmaps = false;
}



BOOL SelectMtoolMsg(tsxMousetool *mt,short msg,short x,short y,short data)
{
	if ( msg == tsxMTM_CHECKCURSOR )
	{
		if ( OrigMouseX > -1 )
		{		
			HWND hwnd = tsxAViewGetHwnd();
			//tsxAViewRefresh();
			

			HDC hdc = GetDC( hwnd );
			
			HPEN linePen = CreatePen( PS_DASH, 1, RGB(255, 255, 200) );
			HBRUSH rectBrush = (HBRUSH)GetStockObject( NULL_BRUSH );
			HGDIOBJ oldPen = SelectObject( hdc, linePen );
			HGDIOBJ oldBrush = SelectObject( hdc, rectBrush );


			RECT rect;

			rect.left = OrigMouseX+1;

			if ( x >= OldX )
				rect.right = OldX-1;
			else
				rect.right = OldX+1;

			rect.top = OrigMouseY+1;

			if ( y >= OldY )
				rect.bottom = OldY-1;
			else
				rect.bottom = OldY+1;

			InvalidateRect( hwnd, &rect, true );
			
			Rectangle( hdc, OrigMouseX, OrigMouseY, x, y );

			//InvalidateRect( hwnd, &rect, true );
			
			SelectObject( hdc, oldBrush );
			SelectObject( hdc, oldPen );
			SetROP2( hdc, R2_COPYPEN );
			DeleteObject( rectBrush );
			DeleteObject( linePen );
			
			
			ReleaseDC( hwnd, hdc );

		}

		if ( x != -1 )
		{
			OldX = LastX;
			OldY = LastY;

			LastX = x;
			LastY = y;
		}

	}
	return TRUE;
}

// Callback type for mouse events
BOOL SelectMtoolClick(tsxMousetool *mt,short x,short y,short flags)
{	
	if ( (flags & tsxMTF_LEFT) == tsxMTF_LEFT)
	{
		if ( OrigMouseX == -1 )
		{
			OrigMouseX = x;
			OrigMouseY = y;
		}
		else
		// second click, launch the render
		{
			tsxMtoolRemove( g_tsxid );
			m_pMainDialog->Export( false );
			OrigMouseX = -1;
		}
	}
	/*OrigMouseX = x;
	OrigMouseY = y;
	tsxMtoolRectangleSelection(mt, x, y, flags, tsxSELECT_VERTEX|tsxSELECT_ADD);
	tsxMtoolRemove( g_tsxid );*/
	
	return TRUE;
}



void CMainDlg::OnAreaRenderBtn()
{
	OrigMouseX = -1;
	OrigMouseY = -1;
	tsxMtoolInstall( g_tsxid, SelectMtoolMsg, SelectMtoolClick );
}

BOOL CMainDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	HBRUSH m_BGBrush = CreateSolidBrush(RGB(255, 0, 255));

	//retrieve the window size and position settings from the system registry
	int iHoriz = AfxGetApp()->GetProfileInt("MainPanel","PanelX",170);
	int iVert = AfxGetApp()->GetProfileInt("MainPanel","PanelY",50);

	theApp.VLightPath = AfxGetApp()->GetProfileString("Settings","VLightPath","h:\\vl\\bin\\vlight.exe");
	theApp.VLFilename = AfxGetApp()->GetProfileString("Settings","Filename","i:\\vltests\\output");

	// if this is the first run, write the key to auto update numberspinners
	// on focus change
	if (AfxGetApp()->GetProfileInt("Spinners","UpdateOnFocus",-1) == -1)
		AfxGetApp()->WriteProfileInt("Spinners","UpdateOnFocus", 1);
		
	// adjust the window position
	SetWindowPos(NULL,iHoriz,iVert,NULL,NULL, SWP_NOSIZE);

	m_CloseButton.m_hUpBitmap = LoadBitmap(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDB_CLOSE));
	m_CloseButton.m_hDownBitmap = LoadBitmap(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDB_DOCLOSE));
	m_CloseButton.DrawBorders = FALSE;
	
	//m_RollupButton.m_hUpBitmap = LoadBitmap(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDB_ROLLUP));
	//m_RollupButton.m_hDownBitmap = LoadBitmap(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDB_DOROLLUP));
	//m_RollupButton.DrawBorders = FALSE;

	CRect myRect;
	GetClientRect(myRect);
	m_CloseButton.MoveWindow(myRect.right-12, 1, 11, 11, TRUE);
	
	
	Rolled = FALSE;

	m_btnRenderScene.m_hUpBitmap = LoadBitmap(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDB_RENDERSCENE));
	m_btnRenderScene.m_hDownBitmap = m_btnRenderScene.m_hUpBitmap;
	m_btnRenderFile.m_hUpBitmap = LoadBitmap(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDB_RENDERFILE));
	m_btnRenderFile.m_hDownBitmap = m_btnRenderFile.m_hUpBitmap;
	m_btnRenderArea.m_hUpBitmap = LoadBitmap(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDB_RENDERAREA));
	m_btnRenderArea.m_hDownBitmap = m_btnRenderArea.m_hUpBitmap;
	m_btnRenderScene.MoveWindow( 0, 13, 30, 22, TRUE );
	m_btnRenderFile.MoveWindow( 30, 13, 30, 22, TRUE );
	m_btnRenderArea.MoveWindow( 60, 13, 30, 22, TRUE );
	m_RollupButton.MoveWindow( 120, 13, myRect.right - 120, 22, TRUE);
	m_ExportBtn.m_hUpBitmap = LoadBitmap(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDB_EXPORT));
	m_ExportBtn.m_hDownBitmap = m_ExportBtn.m_hUpBitmap;
	m_ExportBtn.MoveWindow( 90, 13, 30, 22, TRUE );
	

	m_pOutputTab = new COutputTab;
	m_pOutputTab->Create(COutputTab::IDD, &m_tabctrl);
	m_tabctrl.AddTab(m_pOutputTab, "output", 0);
		
	m_pLightsTab = new CLightsTab;
	m_pLightsTab->Create(CLightsTab::IDD, &m_tabctrl);
	m_tabctrl.AddTab(m_pLightsTab, "lights", 0);

	m_pGITab = new CGITab;
	m_pGITab->Create(CGITab::IDD, &m_tabctrl);
	m_tabctrl.AddTab(m_pGITab, "gi", 0);

	//m_pCamTab = new CCamTab;
	//m_pCamTab->Create(CCamTab::IDD, &m_tabctrl);
	//m_tabctrl.AddTab(m_pCamTab, "camera", 0);

	m_pEnviroTab = new CEnviroTab;
	m_pEnviroTab->Create(CEnviroTab::IDD, &m_tabctrl);
	m_tabctrl.AddTab( m_pEnviroTab, "enviro.", 0 );
	
		

	m_pOutputTab->m_cacheOverride.SetChecked( false );

	m_pOutputTab->m_shadingrate.SetMin(0.0f);
	m_pOutputTab->m_shadingrate.SetMax(32.0f);
	m_pOutputTab->m_shadingrate.Step = 0.01f;
	


	// camera
	
	
	// lights
	m_pLightsTab->m_skysamples.SetMin(1);
	m_pLightsTab->m_skysamples.SetMax(9999);
	m_pLightsTab->m_skysamples.Step = 1;
	
	m_pLightsTab->m_shadowbias.SetMin(-1.0f);
	m_pLightsTab->m_shadowbias.SetMax(1.0f);
	m_pLightsTab->m_shadowbias.Step = 0.01f;
	

	// gi
	m_pGITab->m_nbrphotons.SetMin(0);
	m_pGITab->m_nbrphotons.SetMax(9999);
	m_pGITab->m_nbrphotons.Step = 1;
	
	m_pGITab->m_irradiancesamples.SetMin(0);
	m_pGITab->m_irradiancesamples.SetMax(9999);
	m_pGITab->m_irradiancesamples.Step = 1;
	
	m_pGITab->m_irradianceintensity.SetMin(0.01f);
	m_pGITab->m_irradianceintensity.SetMax(10.0f);
	m_pGITab->m_irradianceintensity.Step = 0.01f;
	
	m_pGITab->m_irradianceshadingrate.SetMin(0.01);
	m_pGITab->m_irradianceshadingrate.SetMax(256.0f);
	m_pGITab->m_irradianceshadingrate.Step = 0.01;	
	
	
	// environment tab
	m_pEnviroTab->m_envBlur.SetMin(0.0f);
	m_pEnviroTab->m_envBlur.SetMax(1.0f);
	m_pEnviroTab->m_envBlur.Step = 0.01f;

	m_pEnviroTab->m_envExposure.SetMin(-10.0f);
	m_pEnviroTab->m_envExposure.SetMax(10.0f);
	m_pEnviroTab->m_envExposure.Step = 0.01f;

	m_pEnviroTab->m_envSize.SetMin(0.0f);
	m_pEnviroTab->m_envSize.SetMax(1000.0f);
	m_pEnviroTab->m_envSize.Step = 0.01f;

	m_pEnviroTab->m_envLightIntensity.SetMin(0.0f);
	m_pEnviroTab->m_envLightIntensity.SetMax(100.0f);
	m_pEnviroTab->m_envLightIntensity.Step = 0.01f;

	m_pEnviroTab->m_envLightExposure.SetMin(-10.0f);
	m_pEnviroTab->m_envLightExposure.SetMax(10.0f);
	m_pEnviroTab->m_envLightExposure.Step = 0.01f;

	m_pEnviroTab->m_envLightSamples.SetMin(-1.0f);
	m_pEnviroTab->m_envLightSamples.SetMax(4096.0f);
	m_pEnviroTab->m_envLightSamples.Step = 1.0f;





	// look for initial parameter file
	char PluginName[_MAX_PATH];

	GetModuleFileName(AfxGetInstanceHandle(), PluginName, _MAX_PATH);

	char *drive, *dir, *fname, *ext;

	drive = (char*) malloc(255 * sizeof(char));
	dir = (char*) malloc(255 * sizeof(char));
	fname = (char*) malloc(255 * sizeof(char));
	ext = (char*) malloc(255 * sizeof(char));

	_splitpath(PluginName, drive, dir, fname, ext);

	// save the base directory
	theApp.g_BaseDir.Format( "%s%s", drive, dir );

	CString paramfilename;
	paramfilename.Format("%s\\default.drb", theApp.g_BaseDir );

	free(drive);
	free(dir);
	free(fname);
	free(ext);

	
	DoLoadSettings(paramfilename);
	
	
	// start rolled up
	OnRollup();
	

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}




void CMainDlg::OnLoadsettings() 
{
	CFileDialog dlg( TRUE,_T("drb"),_T("*.drb"),
	                 OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,
	                 _T("dribble settings files (*.drb)|*.drb|All files|*.*|"));

	if (dlg.DoModal() == IDOK)
	{
		DoLoadSettings(dlg.GetFileName());
	}
}

void CMainDlg::OnSavesettings() 
{
	CFileDialog dlg( FALSE,_T("drb"),_T("*.drb"),
	                 OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,
	                 _T("dribble settings files (*.drb)|*.drb|All files|*.*|"));

	if (dlg.DoModal() == IDOK)
	{
		DoSaveSettings(dlg.GetFileName());
	}

}

void CMainDlg::DoLoadSettings(CString filename)
{
	xml.SetSettingsFile( filename );

	float fval = 0.0f;
	int ival = 0;
	CString strval = "";

	/*xml.read("rib\\output", "nurbstopolys", ival, 0); 
	m_pOutputTab->m_nurbstopolys.SetChecked(ival);
	xml.read( "rib\\output", "triangulate", ival, 0 );
	m_pOutputTab->m_triangulate.SetChecked( ival );
	xml.read( "rib\\output", "individualfaces", ival, 0 );
	m_pOutputTab->m_individualfaces.SetChecked( ival );
	xml.read( "rib\\output", "targetrenderer", ival, 0 );
	m_pOutputTab->m_renderercb.SetCurSel( ival );
	xml.read("rib\\output\\textures", "width", ival, 256); 
	m_pOutputTab->m_texwidth.SetPosition(ival);
	xml.read("rib\\output\\textures", "height", ival, 256); 
	m_pOutputTab->m_texheight.SetPosition(ival);
	xml.read("rib\\output\\textures", "filter", ival, 1); 
	m_pOutputTab->m_texfilter.SetChecked(ival);
	xml.read("rib\\output\\textures", "onefile", ival, 0); 
	m_pOutputTab->m_onetexfile.SetChecked(ival);
	xml.read("rib\\output", "binary", ival, 1); 
	m_pOutputTab->m_isbinary.SetChecked(ival);
	xml.read("rib\\output\\aa", "aalevel", ival, 0); 
	//m_pOutputTab->m_aalevel.SetPosition(ival);
	xml.read("rib\\output\\aa", "undersampling", ival, 0); 
	//m_pOutputTab->m_undersampling.SetPosition(ival);
	xml.read("rib\\output\\aa", "depth", ival, 1); 
	//m_pOutputTab->m_adaptiveaadepth.SetPosition(ival);
	xml.read("rib\\output", "usubdivisions", ival, 16); 
	//m_pOutputTab->m_usubdivisions.SetPosition(ival);
	xml.read("rib\\output", "vsubdivisions", ival, 16); 
	//m_pOutputTab->m_vsubdivisions.SetPosition(ival);



	xml.read("rib\\camera\\format", "width", ival, 320);
	m_pCamTab->m_camwidth.SetPosition(ival);
	xml.read("rib\\camera\\format", "height", ival, 240); 
	m_pCamTab->m_camheight.SetPosition(ival);
	xml.read("rib\\camera\\format", "aspect", fval, 1.0f); 
	m_pCamTab->m_camaspect.SetPosition(fval);
	xml.read("rib\\camera\\dof", "size", fval, 3.5f); 
	m_pCamTab->m_dofsize.SetPosition(fval);
	xml.read("rib\\camera\\dof", "distance", fval, 3.5f); 
	m_pCamTab->m_dofdistance.SetPosition(fval);
	xml.read("rib\\camera\\dof", "enable", ival, 0); 
	m_pCamTab->m_usedof.SetChecked(ival);
	xml.read("rib\\camera\\exposure", "gain", fval, 0.0f); 
	m_pCamTab->m_camgain.SetPosition(fval);
	xml.read("rib\\camera\\exposure", "gamma", fval, 0.0f); 
	m_pCamTab->m_camgamma.SetPosition(fval);
	xml.read("rib\\camera", "lensmodel", ival, 0); 
	m_pCamTab->m_lensmodelcb.SetCurSel(ival);
	xml.read("rib\\camera", "fov", fval, 45.0f); 
	m_pCamTab->m_fieldofview.SetPosition(fval);
	xml.read("rib\\camera\\pixelfilter", "type", ival, 3); 
	m_pCamTab->m_pixelfiltercb.SetCurSel(ival);
	xml.read("rib\\camera\\pixelfilter", "xwidth", fval, 2.0f); 
	m_pCamTab->m_pixelfilterxwidth.SetPosition(fval);
	xml.read("rib\\camera\\pixelfilter", "ywidth", fval, 2.0f); 
	m_pCamTab->m_pixelfilterywidth.SetPosition(fval);
	xml.read("rib\\camera\\pixelsamples", "x", fval, 2.0f); 
	m_pCamTab->m_pixelsamplesx.SetPosition(fval);
	xml.read("rib\\camera\\pixelsamples", "y", fval, 2.0f); 
	m_pCamTab->m_pixelsamplesy.SetPosition(fval);
	

	
	xml.read("rib\\lights", "multiplier", fval, 1.0f); 
	m_pLightsTab->m_lightmultiplier.SetPosition(fval);
	xml.read("rib\\lights\\area", "jitter", fval, 0.1f); 
	m_pLightsTab->m_areajitter.SetPosition(fval);
	xml.read("rib\\lights\\area", "samples", ival, 0); 
	m_pLightsTab->m_areasamples.SetPosition(ival);
	xml.read("rib\\lights\\shadows", "softshadowsamples", ival, 16); 
	m_pLightsTab->m_softshadowsamples.SetPosition(ival);
	xml.read("rib\\lights\\shadows", "bias", fval, 0.001f); 
	m_pLightsTab->m_shadowbias.SetPosition(fval);
	xml.read("rib\\lights", "skysamples", ival, 32); 
	m_pLightsTab->m_skysamples.SetPosition(ival);
	
	

	
	

	xml.read("rib\\gi\\irradiance", "enable", ival, 0); 
	m_pGITab->m_doirradiance.SetChecked(ival);
	xml.read("rib\\gi\\photons", "enable", ival, 0); 
	m_pGITab->m_docaustics.SetChecked(ival);
	xml.read("rib\\gi\\photons", "number", ival, 30); 
	m_pGITab->m_nbrphotons.SetPosition(ival);
	xml.read("rib\\gi\\irradiance", "gridsize", ival, 16); 
	//m_pGITab->m_gridsize.SetPosition(ival);
	xml.read("rib\\gi\\irradiance", "samples", ival, 16); 
	m_pGITab->m_irradiancesamples.SetPosition(ival);
	xml.read("rib\\gi\\photons", "media", ival, 0); 
	//m_pGITab->m_mediaphotons.SetPosition(ival);
	xml.read("rib\\gi\\photons", "volume", fval, 0.0f); 
	//m_pGITab->m_photonsvolume.SetPosition(fval);
	xml.read("rib\\gi\\irradiance", "intensity", fval, 1.0f); 
	m_pGITab->m_irradianceintensity.SetPosition(fval);
	xml.read("rib\\gi\\irradiance", "maxerror", fval, 0.9f); 
	m_pGITab->m_irradiancemaxerror.SetPosition(fval);
	xml.read("rib\\gi\\irradiance", "distribution", ival, 5); 
	//m_pGITab->m_irradiancedistributioncb.SetCurSel(ival);
	xml.read("rib\\gi\\irradiance", "loadcache", ival, 0); 
	//m_pGITab->m_loadirradiancecache.SetChecked(ival);
	xml.read("rib\\gi\\irradiance", "savecache", ival, 0); 
	//m_pGITab->m_saveirradiancecache.SetChecked(ival);
	xml.read("rib\\gi\\irradiance", "onecache", ival, 0); 
	//m_pGITab->m_oneirradiancecache.SetChecked(ival);
	xml.read("rib\\gi\\photons", "loadmap", ival, 0); 
	//m_pGITab->m_loadphotonmap.SetChecked(ival);
	xml.read("rib\\gi\\photons", "savemap", ival, 0); 
	//m_pGITab->m_savephotonmap.SetChecked(ival);
	xml.read("rib\\gi\\photons", "onemap", ival, 0); 
	//m_pGITab->m_onephotonmap.SetChecked(ival);
	xml.read("rib\\gi\\photons\\gather", "min", ival, 40); 
	//m_pGITab->m_photonsgatherrangemin.SetPosition(ival);
	xml.read("rib\\gi\\photons\\gather", "max", ival, 100); 
	//m_pGITab->m_photonsgatherrangemax.SetPosition(ival);
	xml.read("rib\\gi\\rays", "maxraylevel", ival, 6); 
	m_pGITab->m_maxraylevel.SetPosition(ival);
	xml.read("rib\\gi\\rays", "maxblurlevel", ival, 3); 
	m_pGITab->m_maxblurlevel.SetPosition(ival);
	xml.read("rib\\gi\\rays", "maxblursamples", ival, 4); 
	m_pGITab->m_maxblursamples.SetPosition(ival);
	xml.read("rib\\gi\\irradiance\\photons", "enable", ival, 0); 
	//m_pGITab->m_irradiancephotons.SetChecked(ival);
	xml.read("rib\\gi\\irradiance\\photons", "fromlights", ival, 50); 
	//m_pGITab->m_irradiancephotonsfromlights.SetPosition(ival);
	xml.read("rib\\gi\\irradiance\\photons", "perray", ival, 5); 
	//m_pGITab->m_irradiancephotonsperray.SetPosition(ival);
	xml.read("rib\\gi\\irradiance", "blendingarea", fval, 0.85f); 
	//m_pGITab->m_irradianceblendingarea.SetPosition(fval);
	xml.read("rib\\gi\\irradiance", "maxdistance", fval, 0.0f); 
	m_pGITab->m_irradiancemaxdistance.SetPosition(fval);
	xml.read("rib\\gi\\accelerate", "caustics", fval, 0.5f); 
	//m_pGITab->m_accelcaustics.SetPosition(fval);
	xml.read("rib\\gi\\accelerate", "media", fval, 0.2f); 
	//m_pGITab->m_accelmedia.SetPosition(fval);
	xml.read("rib\\gi\\accelerate", "irradiance", fval, 0.5f); 
	//m_pGITab->m_accelirradiance.SetPosition(fval);
	
	xml.read( "rib\\environment", "filename", strval, "..." );
	m_pEnviroTab->m_strFilename = strval;
	m_pEnviroTab->m_envFilename.SetCaption( (char*)((LPCSTR)strval) );

	xml.read( "rib\\environment", "show background", ival, 0 );
	m_pEnviroTab->m_envShowBackground.SetChecked( ival );

	xml.read( "rib\\environment", "show reflections", ival, 0 );
	m_pEnviroTab->m_envShowReflections.SetChecked( ival );
	
	xml.read( "rib\\environment", "blur", fval, 0.0f );
	m_pEnviroTab->m_envBlur.SetPosition( fval );

	xml.read( "rib\\environment", "exposure", fval, 0.0f );
	m_pEnviroTab->m_envExposure.SetPosition( fval );
	
	xml.read( "rib\\environment", "size", fval, 100.0f );
	m_pEnviroTab->m_envSize.SetPosition( fval );

	xml.read( "rib\\environment", "light intensity", fval, 0.0f );
	m_pEnviroTab->m_envLightIntensity.SetPosition( fval );

	xml.read( "rib\\environment", "light exposure", fval, 0.0f );
	m_pEnviroTab->m_envLightExposure.SetPosition( fval );
	
	xml.read( "rib\\environment", "light samples", ival, 32 );
	m_pEnviroTab->m_envLightSamples.SetPosition( ival );
	
	xml.read( "rib\\environment", "light shadows", ival, 1 );
	m_pEnviroTab->m_envLightShadows.SetChecked( (bool)ival );*/

	xml.SetSettingsFile( filename );
	
	xml.read( "rib\\camera\\format", "width", theApp.g_Exporter.FormatWidth, 640 );
	xml.read("rib\\camera\\format", "height", theApp.g_Exporter.FormatHeight, 480 );
	xml.read("rib\\camera\\format", "aspect", theApp.g_Exporter.FormatAspect, 1.0f );
	
	//xml.write("rib\\camera\\exposure", "gain", m_pCamTab->m_camgain.Position);
	//xml.write("rib\\camera\\exposure", "gamma", m_pCamTab->m_camgamma.Position);
	//xml.write("rib\\camera", "lensmodel", m_pCamTab->m_lensmodelcb.GetCurSel());
	//xml.write("rib\\camera", "fov", m_pCamTab->m_fieldofview.Position);
	
	xml.read("rib\\camera\\pixelfilter", "type", theApp.g_Exporter.PixFilter, PixFilter_Gaussian );
	xml.read("rib\\camera\\pixelfilter", "xwidth", theApp.g_Exporter.PixelFilterWidthX, 2 );
	xml.read("rib\\camera\\pixelfilter", "ywidth", theApp.g_Exporter.PixelFilterWidthY, 2 );
	xml.read("rib\\camera\\pixelsamples", "x", theApp.g_Exporter.PixelSamplesX, 2 );
	xml.read("rib\\camera\\pixelsamples", "y", theApp.g_Exporter.PixelSamplesY, 2 );
	
	xml.read("rib\\lights", "multiplier", theApp.g_Exporter.LightMultiplier, 1.0f );
	//xml.write("rib\\lights\\area", "jitter", m_pLightsTab->m_areajitter.Position);
	//xml.write("rib\\lights\\area", "samples", m_pLightsTab->m_areasamples.Position);
	//xml.write("rib\\lights\\shadows", "softshadowsamples", m_pLightsTab->m_softshadowsamples.Position);
	xml.read("rib\\lights\\shadows", "bias", theApp.g_Exporter.ShadowBias, 0.0001f );
	xml.read("rib\\lights", "skysamples", theApp.g_Exporter.m_skySamples, 32 );
	xml.read( "rib\\lights\\shadows", "always ray", theApp.g_Exporter.m_alwaysRayShadows, false );
	
	

	

	xml.read("rib\\gi\\irradiance", "enable", theApp.g_Exporter.m_bUseGI, false );
	xml.read("rib\\gi\\irradiance", "use occlusion", theApp.g_Exporter.m_bUseGIOcclusion, false );
	xml.read("rib\\gi\\caustics", "enable", theApp.g_Exporter.m_bUseCaustics, false );
	xml.read("rib\\gi\\photons", "number", theApp.g_Exporter.m_iPhotons, 30 );
	xml.read("rib\\gi\\photons", "irradiance", theApp.g_Exporter.m_bUseIrradiancePhotons, false );
	//xml.write("rib\\gi\\irradiance", "gridsize", m_pGITab->m_gridsize.Position);
	xml.read("rib\\gi\\irradiance", "samples", theApp.g_Exporter.m_fGISamples, 16 );
	//xml.write("rib\\gi\\photons", "media", m_pGITab->m_mediaphotons.Position);
	//xml.write("rib\\gi\\photons", "volume", m_pGITab->m_photonsvolume.Position);
	xml.read("rib\\gi\\irradiance", "intensity", theApp.g_Exporter.m_fGIIntensity, 1.0f );
	xml.read("rib\\gi\\irradiance", "maxerror", theApp.g_Exporter.m_fGIMaxError, 0.9f );
	xml.read("rib\\gi\\irradiance", "shading rate", theApp.g_Exporter.m_fGIShadingRate, 1.0f );
//	xml.write("rib\\gi\\irradiance", "distribution", m_pGITab->m_irradiancedistributioncb.GetCurSel());
	//xml.write("rib\\gi\\irradiance", "loadcache", m_pGITab->m_loadirradiancecache.Checked);
	//xml.write("rib\\gi\\irradiance", "savecache", m_pGITab->m_saveirradiancecache.Checked);
	//xml.write("rib\\gi\\irradiance", "onecache", m_pGITab->m_oneirradiancecache.Checked);
	//xml.write("rib\\gi\\photons", "loadmap", m_pGITab->m_loadphotonmap.Checked);
	//xml.write("rib\\gi\\photons", "savemap", m_pGITab->m_savephotonmap.Checked);
	//xml.write("rib\\gi\\photons", "savemap", m_pGITab->m_onephotonmap.Checked);
	//xml.write("rib\\gi\\photons\\gather", "min", m_pGITab->m_photonsgatherrangemin.Position);
	//xml.write("rib\\gi\\photons\\gather", "max", m_pGITab->m_photonsgatherrangemax.Position);
	//xml.write("rib\\gi\\rays", "maxraylevel", m_pGITab->m_maxraylevel.Position);
	//xml.write("rib\\gi\\rays", "maxblurlevel", m_pGITab->m_maxblurlevel.Position);
	//xml.write("rib\\gi\\rays", "maxblursamples", m_pGITab->m_maxblursamples.Position);
	//xml.write("rib\\gi\\irradiance\\photons", "enable", m_pGITab->m_irradiancephotons.Checked);
	//xml.write("rib\\gi\\irradiance\\photons", "fromlights", m_pGITab->m_irradiancephotonsfromlights.Position);
	//xml.write("rib\\gi\\irradiance\\photons", "perray", m_pGITab->m_irradiancephotonsperray.Position);
	//xml.write("rib\\gi\\irradiance", "blendingarea", m_pGITab->m_irradianceblendingarea.Position);
	//xml.write("rib\\gi\\irradiance", "maxdistance", m_pGITab->m_irradiancemaxdistance.Position);
	//xml.write("rib\\gi\\accelerate", "caustics", m_pGITab->m_accelcaustics.Position);
	//xml.write("rib\\gi\\accelerate", "media", m_pGITab->m_accelmedia.Position);
	//xml.write("rib\\gi\\accelerate", "irradiance", m_pGITab->m_accelirradiance.Position);
	xml.read("rib\\gi\\irradiance", "high quality", theApp.g_Exporter.m_bHighQualityGI, false );

	xml.read( "rib\\output", "nurbstopolys", theApp.g_Exporter.PatchPoly, false );
	xml.read( "rib\\output", "triangulate", theApp.g_Exporter.m_doTriangulate, true );
	xml.read( "rib\\output", "individualfaces", theApp.g_Exporter.IndividualFaces, true );
	xml.read( "rib\\output", "targetrenderer", (int)theApp.g_Exporter.Renderer, 0  );
	xml.read("rib\\output\\textures", "width", theApp.g_Exporter.TexWidth, 256 );
	xml.read("rib\\output\\textures", "height", theApp.g_Exporter.TexHeight, 256 );
	//xml.write("rib\\output\\textures", "filter", m_pOutputTab->m_texfilter.Checked);
	//xml.write("rib\\output\\textures", "onefile", m_pOutputTab->m_onetexfile.Checked);
	xml.read("rib\\output", "binary", theApp.g_Exporter.Binary, false );
	//xml.write("rib\\output\\aa\\aalevel", m_pOutputTab->m_aalevel.Position);
	//xml.write("rib\\output\\aa\\undersampling", m_pOutputTab->m_undersampling.Position);
	//xml.write("rib\\output\\aa\\depth", m_pOutputTab->m_adaptiveaadepth.Position);
	//xml.write("rib\\output\\usubdivisions", m_pOutputTab->m_usubdivisions.Position);
	//xml.write("rib\\output\\vsubdivisions", m_pOutputTab->m_vsubdivisions.Position);

	xml.read( "rib\\output", "shading rate", theApp.g_Exporter.ShadingRate, 1.0f );
	xml.read( "rib\\output", "raytrace hider", theApp.g_Exporter.m_useRaytraceHider, false );
	xml.read( "rib\\output", "blur multiplier", theApp.g_Exporter.m_blurMultiplier, 4 );


	xml.read( "rib\\environment", "show background", theApp.g_Exporter.m_environmentShowBG, false );
	xml.read( "rib\\environment", "show reflections", theApp.g_Exporter.m_environmentShowReflections, false );

	xml.read( "rib\\environment", "filename", theApp.g_Exporter.m_environmentName, "..." );
	
	xml.read( "rib\\environment", "blur", theApp.g_Exporter.m_environmentBlur, 0.0f );

	xml.read( "rib\\environment", "exposure", theApp.g_Exporter.m_environmentExposure, 0.0f );

	xml.read( "rib\\environment", "size", theApp.g_Exporter.m_environmentSize, 100 );
	
	

	xml.read( "rib\\environment", "light intensity", theApp.g_Exporter.m_environmentLightIntensity, 0.0f );

	xml.read( "rib\\environment", "light exposure", theApp.g_Exporter.m_environmentLightExposure, 0.0f );
	
	xml.read( "rib\\environment", "light samples", theApp.g_Exporter.m_environmentLightSamples, 32 );
	
	xml.read( "rib\\environment", "light shadows", theApp.g_Exporter.m_environmentLightShadows, true  );

	

	UpdateUI( true );

}


void CMainDlg::DoSaveSettings(CString filename)
{
	UpdateUI( false );

	xml.SetSettingsFile( filename );
	xml.write("rib\\camera\\format", "width", theApp.g_Exporter.FormatWidth );
	xml.write("rib\\camera\\format", "height", theApp.g_Exporter.FormatHeight );
	xml.write("rib\\camera\\format", "aspect", theApp.g_Exporter.FormatAspect );
	xml.write("rib\\camera\\dof", "size", theApp.g_Exporter.DOF_FStop);
	xml.write("rib\\camera\\dof", "distance", theApp.g_Exporter.DOF_FocalLength );
	xml.write("rib\\camera\\dof", "enable", theApp.g_Exporter.UseDOF);
	//xml.write("rib\\camera\\exposure", "gain", m_pCamTab->m_camgain.Position);
	//xml.write("rib\\camera\\exposure", "gamma", m_pCamTab->m_camgamma.Position);
	//xml.write("rib\\camera", "lensmodel", m_pCamTab->m_lensmodelcb.GetCurSel());
	//xml.write("rib\\camera", "fov", m_pCamTab->m_fieldofview.Position);
	xml.write("rib\\camera\\pixelfilter", "type", theApp.g_Exporter.PixFilter );
	xml.write("rib\\camera\\pixelfilter", "xwidth", theApp.g_Exporter.PixelFilterWidthX );
	xml.write("rib\\camera\\pixelfilter", "ywidth", theApp.g_Exporter.PixelFilterWidthY );
	xml.write("rib\\camera\\pixelsamples", "x", theApp.g_Exporter.PixelSamplesX );
	xml.write("rib\\camera\\pixelsamples", "y", theApp.g_Exporter.PixelSamplesY );
	
	xml.write("rib\\lights", "multiplier", theApp.g_Exporter.LightMultiplier );
	//xml.write("rib\\lights\\area", "jitter", m_pLightsTab->m_areajitter.Position);
	//xml.write("rib\\lights\\area", "samples", m_pLightsTab->m_areasamples.Position);
	//xml.write("rib\\lights\\shadows", "softshadowsamples", m_pLightsTab->m_softshadowsamples.Position);
	xml.write("rib\\lights\\shadows", "bias", theApp.g_Exporter.ShadowBias );
	xml.write("rib\\lights", "skysamples", theApp.g_Exporter.m_skySamples );
	xml.write( "rib\\lights\\shadows", "always ray", theApp.g_Exporter.m_alwaysRayShadows );
	
	

	

	xml.write("rib\\gi\\irradiance", "enable", theApp.g_Exporter.m_bUseGI );
	xml.write("rib\\gi\\irradiance", "use occlusion", theApp.g_Exporter.m_bUseGIOcclusion );
	xml.write("rib\\gi\\caustics", "enable", theApp.g_Exporter.m_bUseCaustics );
	xml.write("rib\\gi\\photons", "number", theApp.g_Exporter.m_iPhotons );
	xml.write("rib\\gi\\photons", "irradiance", theApp.g_Exporter.m_bUseIrradiancePhotons );
	//xml.write("rib\\gi\\irradiance", "gridsize", m_pGITab->m_gridsize.Position);
	xml.write("rib\\gi\\irradiance", "samples", theApp.g_Exporter.m_fGISamples );
	//xml.write("rib\\gi\\photons", "media", m_pGITab->m_mediaphotons.Position);
	//xml.write("rib\\gi\\photons", "volume", m_pGITab->m_photonsvolume.Position);
	xml.write("rib\\gi\\irradiance", "intensity", theApp.g_Exporter.m_fGIIntensity );
	xml.write("rib\\gi\\irradiance", "maxerror", theApp.g_Exporter.m_fGIMaxError );
	xml.write("rib\\gi\\irradiance", "shading rate", theApp.g_Exporter.m_fGIShadingRate );
//	xml.write("rib\\gi\\irradiance", "distribution", m_pGITab->m_irradiancedistributioncb.GetCurSel());
	//xml.write("rib\\gi\\irradiance", "loadcache", m_pGITab->m_loadirradiancecache.Checked);
	//xml.write("rib\\gi\\irradiance", "savecache", m_pGITab->m_saveirradiancecache.Checked);
	//xml.write("rib\\gi\\irradiance", "onecache", m_pGITab->m_oneirradiancecache.Checked);
	//xml.write("rib\\gi\\photons", "loadmap", m_pGITab->m_loadphotonmap.Checked);
	//xml.write("rib\\gi\\photons", "savemap", m_pGITab->m_savephotonmap.Checked);
	//xml.write("rib\\gi\\photons", "savemap", m_pGITab->m_onephotonmap.Checked);
	//xml.write("rib\\gi\\photons\\gather", "min", m_pGITab->m_photonsgatherrangemin.Position);
	//xml.write("rib\\gi\\photons\\gather", "max", m_pGITab->m_photonsgatherrangemax.Position);
	//xml.write("rib\\gi\\rays", "maxraylevel", m_pGITab->m_maxraylevel.Position);
	//xml.write("rib\\gi\\rays", "maxblurlevel", m_pGITab->m_maxblurlevel.Position);
	//xml.write("rib\\gi\\rays", "maxblursamples", m_pGITab->m_maxblursamples.Position);
	//xml.write("rib\\gi\\irradiance\\photons", "enable", m_pGITab->m_irradiancephotons.Checked);
	//xml.write("rib\\gi\\irradiance\\photons", "fromlights", m_pGITab->m_irradiancephotonsfromlights.Position);
	//xml.write("rib\\gi\\irradiance\\photons", "perray", m_pGITab->m_irradiancephotonsperray.Position);
	//xml.write("rib\\gi\\irradiance", "blendingarea", m_pGITab->m_irradianceblendingarea.Position);
	//xml.write("rib\\gi\\irradiance", "maxdistance", m_pGITab->m_irradiancemaxdistance.Position);
	//xml.write("rib\\gi\\accelerate", "caustics", m_pGITab->m_accelcaustics.Position);
	//xml.write("rib\\gi\\accelerate", "media", m_pGITab->m_accelmedia.Position);
	//xml.write("rib\\gi\\accelerate", "irradiance", m_pGITab->m_accelirradiance.Position);
	xml.write("rib\\gi\\irradiance", "high quality", theApp.g_Exporter.m_bHighQualityGI );

	xml.write( "rib\\output", "nurbstopolys", theApp.g_Exporter.PatchPoly );
	xml.write( "rib\\output", "triangulate", theApp.g_Exporter.m_doTriangulate );
	xml.write( "rib\\output", "individualfaces", theApp.g_Exporter.IndividualFaces );
	xml.write( "rib\\output", "targetrenderer", theApp.g_Exporter.Renderer );
	xml.write("rib\\output\\textures", "width", theApp.g_Exporter.TexWidth );
	xml.write("rib\\output\\textures", "height", theApp.g_Exporter.TexHeight );
	//xml.write("rib\\output\\textures", "filter", m_pOutputTab->m_texfilter.Checked);
	//xml.write("rib\\output\\textures", "onefile", m_pOutputTab->m_onetexfile.Checked);
	xml.write("rib\\output", "binary", theApp.g_Exporter.Binary );
	//xml.write("rib\\output\\aa\\aalevel", m_pOutputTab->m_aalevel.Position);
	//xml.write("rib\\output\\aa\\undersampling", m_pOutputTab->m_undersampling.Position);
	//xml.write("rib\\output\\aa\\depth", m_pOutputTab->m_adaptiveaadepth.Position);
	//xml.write("rib\\output\\usubdivisions", m_pOutputTab->m_usubdivisions.Position);
	//xml.write("rib\\output\\vsubdivisions", m_pOutputTab->m_vsubdivisions.Position);
	xml.write( "rib\\output", "shading rate", theApp.g_Exporter.ShadingRate );
	xml.write( "rib\\output", "raytrace hider", theApp.g_Exporter.m_useRaytraceHider );
	xml.write( "rib\\output", "blur multiplier", theApp.g_Exporter.m_blurMultiplier );


	xml.write( "rib\\environment", "show background", theApp.g_Exporter.m_environmentShowBG );
	xml.write( "rib\\environment", "show reflections", theApp.g_Exporter.m_environmentShowReflections );

	xml.write( "rib\\environment", "filename", theApp.g_Exporter.m_environmentName );
	
	xml.write( "rib\\environment", "blur", theApp.g_Exporter.m_environmentBlur );

	xml.write( "rib\\environment", "exposure", theApp.g_Exporter.m_environmentExposure );
	
	xml.write( "rib\\environment", "size", theApp.g_Exporter.m_environmentSize );

	xml.write( "rib\\environment", "light intensity", theApp.g_Exporter.m_environmentLightIntensity );

	xml.write( "rib\\environment", "light exposure", theApp.g_Exporter.m_environmentLightExposure );
	
	xml.write( "rib\\environment", "light samples", theApp.g_Exporter.m_environmentLightSamples );
	
	xml.write( "rib\\environment", "light shadows", theApp.g_Exporter.m_environmentLightShadows );

}


bool CMainDlg::CheckOutputDir()
{
	char *drive, *dir, *fname, *ext;

	drive = (char*) malloc(255 * sizeof(char));
	dir = (char*) malloc(255 * sizeof(char));
	fname = (char*) malloc(255 * sizeof(char));
	ext = (char*) malloc(255 * sizeof(char));

	_splitpath(theApp.VLFilename, drive, dir, fname, ext);

	CString dirname;
	dirname.Format("%s\\%s", drive, dir);

	// strip off trailing slash
	dirname = dirname.Left(dirname.GetLength()-1);


	free(drive);
	free(dir);
	free(fname);
	free(ext);

	if (FileExists(dirname.GetBuffer(dirname.GetLength())))
		return true;

	return false;
}


// Called when the value of a checkbox is changed
LRESULT CMainDlg::OnCheckBoxChanged(WPARAM wParam, LPARAM lParam)
{
	return 0L;
}
void CMainDlg::OnBnClickedGoBtn()
{
	// TODO: Add your control notification handler code here
}

///////////////////////////////////////////////////////////////////////////////

// reads the info from the export class and updates the UI
void CMainDlg::UpdateUI( bool read )
{	
	if ( read )
	{
		
		
		
		// lights
		m_pLightsTab->m_skysamples.SetPosition( theApp.g_Exporter.m_skySamples );
		m_pLightsTab->m_alwaysRayShadows.SetChecked( theApp.g_Exporter.m_alwaysRayShadows );
		m_pLightsTab->m_shadowbias.SetPosition( theApp.g_Exporter.ShadowBias );
		

		// gi
		m_pGITab->m_doirradiance.SetChecked( theApp.g_Exporter.m_bUseGI );
		m_pGITab->m_doirradianceocc.SetChecked( theApp.g_Exporter.m_bUseGIOcclusion );
		m_pGITab->m_irradiancephotons.SetChecked( theApp.g_Exporter.m_bUseIrradiancePhotons );
		m_pGITab->m_nbrphotons.SetPosition( theApp.g_Exporter.m_iPhotons );
		m_pGITab->m_irradiancesamples.SetPosition( theApp.g_Exporter.m_fGISamples );
		m_pGITab->m_irradianceintensity.SetPosition( theApp.g_Exporter.m_fGIIntensity );
		m_pGITab->m_irradianceshadingrate.SetPosition( theApp.g_Exporter.m_fGIShadingRate );
		m_pGITab->m_docaustics.SetChecked( theApp.g_Exporter.m_bUseCaustics );
		m_pGITab->m_highquality.SetChecked( theApp.g_Exporter.m_bHighQualityGI );
		
		
		// output
		m_pOutputTab->m_cacheOverride.SetChecked( theApp.g_Exporter.m_cacheOverride );
		m_pOutputTab->m_shadingrate.SetPosition( theApp.g_Exporter.ShadingRate );

		
		// environment
		m_pEnviroTab->m_strFilename = theApp.g_Exporter.m_environmentName;
		
		m_pEnviroTab->m_envShowBackground.SetChecked( theApp.g_Exporter.m_environmentShowBG );
		m_pEnviroTab->m_envShowReflections.SetChecked( theApp.g_Exporter.m_environmentShowReflections );
		m_pEnviroTab->m_envExposure.SetPosition( theApp.g_Exporter.m_environmentExposure );
		m_pEnviroTab->m_envLightExposure.SetPosition( theApp.g_Exporter.m_environmentLightExposure );
		m_pEnviroTab->m_envLightIntensity.SetPosition( theApp.g_Exporter.m_environmentLightIntensity );
		m_pEnviroTab->m_envLightSamples.SetPosition( theApp.g_Exporter.m_environmentLightSamples );
		m_pEnviroTab->m_envLightShadows.SetChecked( theApp.g_Exporter.m_environmentLightShadows );
		m_pEnviroTab->m_envSize.SetPosition( theApp.g_Exporter.m_environmentSize );
	}
	else
	{
		
		
		// lights
		theApp.g_Exporter.m_skySamples = m_pLightsTab->m_skysamples.Position;
		theApp.g_Exporter.m_alwaysRayShadows = m_pLightsTab->m_alwaysRayShadows.Checked;
		theApp.g_Exporter.ShadowBias = m_pLightsTab->m_shadowbias.Position;
		

		// gi
		theApp.g_Exporter.m_bUseGI = m_pGITab->m_doirradiance.Checked;
		theApp.g_Exporter.m_bUseGIOcclusion = m_pGITab->m_doirradianceocc.Checked;
		theApp.g_Exporter.m_bUseIrradiancePhotons = m_pGITab->m_irradiancephotons.Checked;
		theApp.g_Exporter.m_iPhotons = m_pGITab->m_nbrphotons.Position;
		theApp.g_Exporter.m_fGISamples = m_pGITab->m_irradiancesamples.Position;
		theApp.g_Exporter.m_fGIIntensity = m_pGITab->m_irradianceintensity.Position;
		theApp.g_Exporter.m_fGIShadingRate = m_pGITab->m_irradianceshadingrate.Position;
		theApp.g_Exporter.m_bUseCaustics = m_pGITab->m_docaustics.Checked;
		theApp.g_Exporter.m_bHighQualityGI = m_pGITab->m_highquality.Checked;
		
		
		// output
		theApp.g_Exporter.m_cacheOverride = m_pOutputTab->m_cacheOverride.Checked;
		theApp.g_Exporter.ShadingRate = m_pOutputTab->m_shadingrate.Position;

		
		// environment
		theApp.g_Exporter.m_environmentName = m_pEnviroTab->m_strFilename;
		
		theApp.g_Exporter.m_environmentShowBG = m_pEnviroTab->m_envShowBackground.Checked;
		theApp.g_Exporter.m_environmentShowReflections = m_pEnviroTab->m_envShowReflections.Checked;
		theApp.g_Exporter.m_environmentExposure = m_pEnviroTab->m_envExposure.Position;
		theApp.g_Exporter.m_environmentLightExposure = m_pEnviroTab->m_envLightExposure.Position;
		theApp.g_Exporter.m_environmentLightIntensity = m_pEnviroTab->m_envLightIntensity.Position;
		theApp.g_Exporter.m_environmentLightSamples = m_pEnviroTab->m_envLightSamples.Position;
		theApp.g_Exporter.m_environmentLightShadows = m_pEnviroTab->m_envLightShadows.Checked;
		theApp.g_Exporter.m_environmentSize = m_pEnviroTab->m_envSize.Position;
	}
}
