// OutputTab.cpp : implementation file
//

#include "stdafx.h"
#include "dribble.h"
#include "OutputTab.h".

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COutputTab dialog


COutputTab::COutputTab(CWnd* pParent /*=NULL*/)
	: CDialog(COutputTab::IDD, pParent)
{
	//{{AFX_DATA_INIT(COutputTab)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void COutputTab::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COutputTab)
	DDX_Control(pDX, IDC_CACHEOVERRIDE, m_cacheOverride);
	DDX_Control(pDX, IDC_SHADINGRATE, m_shadingrate);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(COutputTab, CDialog)
	//{{AFX_MSG_MAP(COutputTab)
	ON_MESSAGE( WM_CHECKBOXCHANGED, OnCheckBoxChanged )
	ON_BN_CLICKED(IDC_VLIGHTPATH, OnVlightpath)
	ON_BN_CLICKED(IDC_OUTFILENAME, OnFilename)
	ON_BN_CLICKED(IDC_EXPORTTEXNOW, OnExporttexnow)
	ON_MESSAGE( WM_CTLCOLORDLG, OnDlgBGColor )
	ON_MESSAGE( WM_CTLCOLORSTATIC, OnDlgBGColor )
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COutputTab message handlers

// Called when the value of a checkbox is changed
LRESULT COutputTab::OnCheckBoxChanged(WPARAM wParam, LPARAM lParam)
{
	// We know that *one* of the controls triggered this message,
	// let's see if it's the one we want
	
	

	
	return 0L;
}


void COutputTab::OnFilename() 
{
	// pop up a file dialog and get the filename
	CFileDialog dlg( FALSE, _T("*.rib"), _T("*.rib"),
	                 OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,
	                 _T("Renderman Interface Bytestreams (*.rib)|*.rib|All files|*.*|"));

	// set existing filename
	strcpy(dlg.m_ofn.lpstrFile, theApp.VLFilename);
	
	if( dlg.DoModal()==IDOK )
	{

		char *drive, *dir, *fname, *ext;

		drive = (char*) malloc(255 * sizeof(char));
		dir = (char*) malloc(255 * sizeof(char));
		fname = (char*) malloc(255 * sizeof(char));
		ext = (char*) malloc(255 * sizeof(char));

		_splitpath(dlg.GetPathName(), drive, dir, fname, ext);

		theApp.VLFilename.Format("%s%s%s", drive, dir, fname);

		free(drive);
		free(dir);
		free(fname);
		free(ext);

		m_filename.SetCaption(theApp.VLFilename.GetBuffer(theApp.VLFilename.GetLength()));
	}
}

void COutputTab::OnVlightpath() 
{
	// pop up a file dialog and get the filename
	CFileDialog dlg( TRUE,NULL,_T("vlight.exe"),
	                 OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,
	                 _T("Virtualight Executable (vlight.exe)|vlight.exe|All files|*.*|"));
	
	if( dlg.DoModal()==IDOK )
	{
		theApp.VLightPath = dlg.GetPathName();
		m_vlightpath.SetCaption(theApp.VLightPath.GetBuffer(theApp.VLightPath.GetLength()));
	}
}


void COutputTab::OnExporttexnow() 
{
	/*CFileDialog dlg( FALSE,NULL,_T("*.tga"),
	                 OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,
	                 _T("Targa image files (*.tga)|*.tga|All files|*.*|"));

	if (dlg.DoModal() == IDOK)
	{

		int width = (int)m_texwidth.Position;
		int height = (int)m_texheight.Position;
		tsxImage TextureImg;
		tsxImageCreateData(&TextureImg, width, height, e_tsxIMAGE_RGBA);

		// generate texture
		tsxMATERIAL *pMaterial;
		tsxMaterialCreateCopyActive(&pMaterial);
		tsxMaterialGetTextureFromProceduralColor(pMaterial, &TextureImg);

		CtsxColor *texture = (CtsxColor*)TextureImg.data;
		
		if (!texture)
			return;

		


		if (texture)
			tsxImageDestroyData(&TextureImg);

		tsxMaterialDestroy(pMaterial);
	}*/
}
LRESULT COutputTab::OnDlgBGColor( WPARAM wParam, LPARAM lParam )
{
	HDC hdcStatic = (HDC)wParam;
    SetTextColor(hdcStatic, RGB(0, 0, 0));
    SetBkMode(hdcStatic, TRANSPARENT);
	return (LONG)theApp.g_hbrBackground;
}
