// functions for rendering files
// equivalents

#include "stdafx.h"
#include "dribble.h"
#include "AVIFile.h"
#include "BTCImageObject.h"

#define DLGITEM_FILETYPE 1136
#define DLGITEM_FILENAME 1152

#define RENDER_RES_720x480	0
#define RENDER_RES_720x486  1
#define RENDER_RES_720x576	2
#define RENDER_RES_768x576	3
#define RENDER_RES_320x200	4
#define RENDER_RES_320x240	5
#define RENDER_RES_352x240	6
#define RENDER_RES_352x288	7
#define RENDER_RES_384x288	8
#define RENDER_RES_640x480	9
#define RENDER_RES_704x480	10
#define RENDER_RES_704x576	11
#define RENDER_RES_736x398	12
#define RENDER_RES_1280x720 13
#define RENDER_RES_1920x1080 14

#define FPS_NTSC		0
#define FPS_NTSC_HALF	1
#define FPS_PAL			2
#define FPS_PAL_HALF	3
#define FPS_FILM		4
#define FPS_FILM_HALF	5


UINT starttime;
UINT endtime;
UINT rangestart;
UINT rangeend;
bool dlgRenderAll;
bool dlgRenderSingle;

long DPWidth, DPHeight;		
int	RenderWidth, RenderHeight;
float AspectRatio;

float StartFrame, EndFrame;

bool MoBlur;

int FrameRate;

float GetDlgItemFloat(HWND hWnd,int nCtrlID)
{
	HWND hControl = ::GetDlgItem(hWnd,nCtrlID);
	float fValue = 0.00;
	char szText[256];
	::GetWindowTextA(hControl,szText,sizeof(szText));
	::sscanf(szText,"%f",&fValue);
	return fValue;
}

BOOL SetDlgItemFloat(HWND hWnd,int nCtrlID,float fValue)
{
	HWND hControl = ::GetDlgItem(hWnd,nCtrlID);
	char szText[256];
	::sprintf(szText,"%.2f",fValue);
	return ::SetWindowTextA(hControl,szText);
}


UINT APIENTRY RFileDialogProcedure(HWND hDlg, UINT uiMsg, WPARAM wParam, LPARAM lParam)
{

	//cannot use immediate flag in elements
    HWND hfileDialogBox;
	NMHDR *pnmh;

//	OFNOTIFY *lpon;
//	OPENFILENAME *lpofn;
//	int filterIndex;
//	char defaultName[512];
//	char buttonTitle[32];

//    char buf[512];
    switch (uiMsg) {
    case WM_INITDIALOG:
		hfileDialogBox = GetParent(hDlg);
        
		tsxAnimGetPlayRanges( &StartFrame, &EndFrame );

        SetDlgItemInt(hDlg, RFILE_FRAME_FROM, (UINT)StartFrame, TRUE);
        SetDlgItemInt(hDlg, RFILE_FRAME_TO, (UINT)EndFrame, TRUE);
        CheckDlgButton(hDlg, RFILE_FRAME_SINGLE, 1);

        char buf[255];
		
		sprintf(buf,"%d-%d",(LONG)StartFrame,(LONG)EndFrame);
        SetDlgItemText(hDlg, RFILE_FRAME_WHICHALL, buf);

		tsxAViewGetDrawportSize( &DPWidth, &DPHeight );
		sprintf( buf, "%dx%d", DPWidth, DPHeight );
		SetDlgItemText( hDlg, RFILE_RES_WINDOWSIZE_TEXT, buf );

		SetDlgItemFloat( hDlg, RFILE_ASPECT, 1.0f );

		SendDlgItemMessage( hDlg, RFILE_RES_PRESETS, CB_ADDSTRING, 0, (LPARAM)"720x480 NTSC" );
		SendDlgItemMessage( hDlg, RFILE_RES_PRESETS, CB_ADDSTRING, 0, (LPARAM)"720x486 NTSC" );
		SendDlgItemMessage( hDlg, RFILE_RES_PRESETS, CB_ADDSTRING, 0, (LPARAM)"720x576 PAL" );
		SendDlgItemMessage( hDlg, RFILE_RES_PRESETS, CB_ADDSTRING, 0, (LPARAM)"768x576 PAL" );
		SendDlgItemMessage( hDlg, RFILE_RES_PRESETS, CB_ADDSTRING, 0, (LPARAM)"320x200" );
		SendDlgItemMessage( hDlg, RFILE_RES_PRESETS, CB_ADDSTRING, 0, (LPARAM)"320x240" );
		SendDlgItemMessage( hDlg, RFILE_RES_PRESETS, CB_ADDSTRING, 0, (LPARAM)"352x240 NTSC MPEG1" );
		SendDlgItemMessage( hDlg, RFILE_RES_PRESETS, CB_ADDSTRING, 0, (LPARAM)"352x288 PAL  MPEG1" );
		SendDlgItemMessage( hDlg, RFILE_RES_PRESETS, CB_ADDSTRING, 0, (LPARAM)"384x288 PAL  MPEG1" );
		SendDlgItemMessage( hDlg, RFILE_RES_PRESETS, CB_ADDSTRING, 0, (LPARAM)"640x480" );
		SendDlgItemMessage( hDlg, RFILE_RES_PRESETS, CB_ADDSTRING, 0, (LPARAM)"704x480 NTSC MPEG2" );
		SendDlgItemMessage( hDlg, RFILE_RES_PRESETS, CB_ADDSTRING, 0, (LPARAM)"704x576 PAL  MPEG2" );
		SendDlgItemMessage( hDlg, RFILE_RES_PRESETS, CB_ADDSTRING, 0, (LPARAM)"736x398 LTRBOX" );
		SendDlgItemMessage( hDlg, RFILE_RES_PRESETS, CB_ADDSTRING, 0, (LPARAM)"1280x720p" );
		SendDlgItemMessage( hDlg, RFILE_RES_PRESETS, CB_ADDSTRING, 0, (LPARAM)"1920x1080i/p" );
		SendDlgItemMessage( hDlg, RFILE_RES_PRESETS, CB_SETCURSEL, 9, 0);
        
		SetDlgItemInt( hDlg, RFILE_RES_WIDTH, 640, false );
		SetDlgItemInt( hDlg, RFILE_RES_HEIGHT, 480, false );

		CheckDlgButton( hDlg, RFILE_RES_CUSTOM, 1 );

		CheckDlgButton( hDlg, RFILE_MOBLUR, !MoBlur );

		//CheckDlgButton( hDlg, RFILE_RATE_30, 1 );
		SendDlgItemMessage( hDlg, RFILE_FPS_PRESETS, CB_ADDSTRING, 0, (LPARAM)"NTSC (30fps)" );
		SendDlgItemMessage( hDlg, RFILE_FPS_PRESETS, CB_ADDSTRING, 0, (LPARAM)"NTSC (15fps)" );
		SendDlgItemMessage( hDlg, RFILE_FPS_PRESETS, CB_ADDSTRING, 0, (LPARAM)"PAL (25fps)" );
		SendDlgItemMessage( hDlg, RFILE_FPS_PRESETS, CB_ADDSTRING, 0, (LPARAM)"PAL (12.5fps)" );
		SendDlgItemMessage( hDlg, RFILE_FPS_PRESETS, CB_ADDSTRING, 0, (LPARAM)"Film (24fps)" );
		SendDlgItemMessage( hDlg, RFILE_FPS_PRESETS, CB_ADDSTRING, 0, (LPARAM)"Film (12fps)" );
		SendDlgItemMessage( hDlg, RFILE_FPS_PRESETS, CB_SETCURSEL, 0, 0);

        return TRUE;
	case WM_COMMAND:
		break;
	case WM_NOTIFY:
		{
			pnmh = (LPNMHDR)lParam;
			BOOL trans;
                    

			switch (pnmh->code) {
			case CDN_INITDONE:
				{
					hfileDialogBox = GetParent(hDlg);
					SetWindowPos(hfileDialogBox, NULL, 300, 70, 0, 0, SWP_NOSIZE);
					//fileSelectionOccurred = 0;
				}
				break;
			case CDN_FILEOK:
				{
					// get dialog info
					if ( IsDlgButtonChecked( hDlg, RFILE_FRAME_SINGLE ) == 1 )
					{						
						starttime = endtime = tsxAnimGetActiveTime();
						dlgRenderSingle = true;
					}
					else if (IsDlgButtonChecked( hDlg, RFILE_FRAME_ALL ) == 1 )
					{
						starttime = StartFrame;
						endtime = EndFrame;
						dlgRenderAll = true;
					}
					else
					{
						starttime = GetDlgItemInt( hDlg, RFILE_FRAME_FROM, &trans, false );
						endtime = GetDlgItemInt( hDlg, RFILE_FRAME_TO, &trans, false );
					}
						 

                    
					// get render res
					if ( IsDlgButtonChecked( hDlg, RFILE_RES_WINDOW ) == 1 )
					{
						RenderWidth = DPWidth;
						RenderHeight = DPHeight;
					}
					else if ( IsDlgButtonChecked( hDlg, RFILE_RES_PRESET ) == 1 )
					{
						int selected = SendDlgItemMessage( hDlg, RFILE_RES_PRESETS, CB_GETCURSEL, 0, 0);
						switch ( selected )
						{
						case 0:
							RenderWidth = 720;
							RenderHeight = 480;
							break;

						case 1:
							RenderWidth = 720;
							RenderHeight = 486;
							break;
						
						case 2:
							RenderWidth = 720;
							RenderHeight = 576;
							break;

						case 3:
							RenderWidth = 768;
							RenderHeight = 576;
							break;

						case 4:
							RenderWidth = 320;
							RenderHeight = 200;
							break;

						case 5:
							RenderWidth = 320;
							RenderHeight = 240;
							break;

						case 6:
							RenderWidth = 352;
							RenderHeight = 240;
							break;

						case 7:
							RenderWidth = 352;
							RenderHeight = 288;
							break;

						case 8:
							RenderWidth = 384;
							RenderHeight = 288;
							break;

						case 9:
							RenderWidth = 640;
							RenderHeight = 480;
							break;

						case 10:
							RenderWidth = 704;
							RenderHeight = 480;
							break;

						case 11:
							RenderWidth = 704;
							RenderHeight = 576;
							break;

						case 12:
							RenderWidth = 736;
							RenderHeight = 398;
							break;
						
						case 13:
							RenderWidth = 1280;
							RenderHeight = 720;
							break;

						case 14:
							RenderWidth = 1920;
							RenderHeight = 1080;
							break;
						}
					}
					else
					{
						RenderWidth = GetDlgItemInt( hDlg, RFILE_RES_WIDTH, &trans, false );
						RenderHeight = GetDlgItemInt( hDlg, RFILE_RES_HEIGHT, &trans, false );
					}

					AspectRatio = GetDlgItemFloat( hDlg, RFILE_ASPECT );
                    
					
					MoBlur = !( IsDlgButtonChecked( hDlg, RFILE_MOBLUR ) == 1 );
					
					/*if ( IsDlgButtonChecked( hDlg, RFILE_RATE_30 ) == 1 )
						FrameRate = 30;						
					else
						FrameRate = 15;
						*/
					int selected = SendDlgItemMessage( hDlg, RFILE_FPS_PRESETS, CB_GETCURSEL, 0, 0);
					switch ( selected )
					{
					case FPS_NTSC:
						FrameRate = 30;
						break;

					case FPS_NTSC_HALF:
						FrameRate = 15;
						break;

					case FPS_PAL:
						FrameRate = 25;
						break;

					case FPS_PAL_HALF:
						FrameRate = 12.5;
						break;

					case FPS_FILM:
						FrameRate = 24;
						break;

					case FPS_FILM_HALF:
						FrameRate = 12;
						break;

					default:
						FrameRate = 30;
					};

				}
			    break;
			}
		}
		break;
    }
    return FALSE;  //allow further processing
}



void CVirtuaoutApp::RenderToFile()
{
	HWND mainWnd = ::GetActiveWindow();

		
    bool bCancel = false;
	CString filename = "";

    dlgRenderAll = false;
	dlgRenderSingle = false;

	// if filename is empty, pop up a selector
    // temporarily changed to always pop up selector
	//if ((filename.GetLength() <= 0) && (bCancel == false))
    if (bCancel == false)
	{
		CString csExt(".png");
		TCHAR strInitFilename[512] = "untitled";

		CString csFilter;
		csFilter.Format("PNG Files (*.png)\\*.png\\JPEG Files (*.jpg)\\*.jpg\\BMP Files (*.bmp)\\*.bmp\\HDRI Files (*.hdr)\\*.hdr\\Targa Files (*.tga)\\*.tga\\Photoshop Files (*.psd)\\*.psd\\AVI Files (*.avi)\\*.avi\\All Files (*.*)\\*.*\\\\");
		csFilter.Replace('\\', '\0');

		OPENFILENAME ofn;
		ZeroMemory(&ofn, sizeof(OPENFILENAME));

		ofn.lStructSize = sizeof(OPENFILENAME);
		ofn.hwndOwner = mainWnd;
        HINSTANCE hInstance = _AtlBaseModule.GetModuleInstance();
		ofn.hInstance = hInstance; 
		ofn.lpstrFilter = csFilter;
		ofn.lpstrCustomFilter = (LPSTR)NULL;
		ofn.nFilterIndex = 1;
		ofn.lpstrFile = strInitFilename;
		ofn.nMaxFile = sizeof(strInitFilename);
		ofn.lpstrFileTitle = NULL; 
		ofn.nMaxFileTitle = 0; 
		ofn.lpstrInitialDir = (LPSTR)NULL; 
		ofn.lpstrTitle = _T("Render To File"); 
		ofn.nFileOffset = 0; 
		ofn.nFileExtension = 1; 
		int iPos = csExt.ReverseFind('.');
		ofn.lpstrDefExt = &csExt.GetBuffer()[iPos == -1 ? 0 : (iPos + 1)];
		ofn.lCustData = 0; 
		// 64-bit change
		//LPOFNHOOKPROC proc = MakeProcInstance(RFileDialogProcedure, hInst);
		LPOFNHOOKPROC proc = (LPOFNHOOKPROC)RFileDialogProcedure;
        ofn.lpfnHook = proc;
        ofn.Flags = OFN_ENABLEHOOK | OFN_HIDEREADONLY | OFN_LONGNAMES | OFN_EXPLORER | OFN_ENABLETEMPLATE | OFN_OVERWRITEPROMPT;
		ofn.lpTemplateName = "rfiledlg";
		//ofn.FlagsEx = 1;
		
		
		
		BOOL bReturn = GetSaveFileName( &ofn );

		if(bReturn)
		{
			filename = ofn.lpstrFile;

			g_Exporter.FormatWidth = RenderWidth;
			g_Exporter.FormatHeight = RenderHeight;
			g_Exporter.FormatAspect = AspectRatio;

			g_Exporter.m_useMotionBlur = MoBlur;
			
		}
        else
            bCancel = true;
	}

	// store base filename (output filename - extension)
	CString basefilename;        
	CString filenameextension;        
    bool IsAVI = false;
    
	CAVIFile AVIFile;
    
	if ((filename.GetLength() > 0) && (bCancel == false))
	{
		char drive[_MAX_PATH];
		char dir[_MAX_PATH];
		char fname[_MAX_PATH];
		char ext[_MAX_PATH];

		
		_splitpath( filename, drive, dir, fname, ext );
		
		g_Exporter.OutputDirectory.Format( "%s%s", drive, dir );
		g_Exporter.RawImageName = filename;

		basefilename = (filename.Left(filename.GetLength()-4));
		filenameextension = (filename.Right(3));
        
        if (filenameextension.MakeLower() == L"avi")
        {
            IsAVI = true;
            
            
			if (SUCCEEDED(AVIFile.ChooseCodec(mainWnd)))
            {
                AVIFile.CreateFile(filename, FrameRate);  
            }
            else
                bCancel = true;
             
        }
	}

    if (bCancel == false)
    {
	    // if there's no animation or no filename, make some sensible
	    // changes
	    if ( (filename.GetLength() <= 0) || (dlgRenderSingle) )
	    {
		    starttime = 0;
		    endtime = 0;
	    }

		
	    // loop through all frames and render out each one
	    for ( int curtime = starttime; curtime <= endtime; curtime++ )
	    {
			// break out if esc pressed
			if ( tsxCheckAbort() == e_tsxTRUE )
				curtime = endtime+999;
			
			if ((filename.GetLength() > 0) && (IsAVI == false) && (dlgRenderSingle == false ))
			    filename.Format("%s%04d.%s", basefilename, (int)curtime, filenameextension);

			// the filename sent to the exporter will always be the same because we're rendering to
			// a temp dir anyway
			
			// chop off '.rib' from Filename
			CString BaseRIBFilename = g_Exporter.Filename.Left(g_Exporter.Filename.GetLength() - 4);
			CString fname;
			fname.Format("%s\\%s.rib", g_Exporter.RIBDirectory, BaseRIBFilename );
					

			if( filename.Right(3).MakeLower() == L"psd" )
			{
				g_Exporter.PSDOutput = true;
				
			}

			g_Exporter.ExportFrame( fname, curtime );

			if ( g_Exporter.PSDOutput == false )
			{
				if ( filename.GetLength() > 0 )
				{   
					// get the rendered image
					char bmpname[255];
					sprintf( bmpname, "%s%s.tif.tga", g_Exporter.RIBDirectory, g_Exporter.ImageName );

					
					
					BTCImageObject ImageObject;
					if ( ImageObject.Load( bmpname ) )
					{
						
						//ILint width = ilGetInteger( IL_IMAGE_WIDTH );
						//ILint height = ilGetInteger( IL_IMAGE_HEIGHT );
						//ILint bpp = ilGetInteger( IL_IMAGE_BITS_PER_PIXEL );
						
						
						if ( IsAVI == false )
						{
							//ImageObject.GetObjectData().ConvertTo24BPP();
							


							long format;
							if(filename.Right(3).MakeLower() == L"png")
								format = BTFILETYPE_PNG;
							else if(filename.Right(3).MakeLower() == L"jpg")
								format = BTFILETYPE_JPEG;
							else if(filename.Right(3).MakeLower() == L"bmp")
								format = BTFILETYPE_BMP;
							//else if(filename.Right(3).MakeLower() == L"hdr")
							//	format = IL_HDR;
							else if(filename.Right(3).MakeLower() == L"tga")
								format = BTFILETYPE_TGA;
							else 
								format = BTFILETYPE_PNG;

							
							ImageObject.Save( filename, format );
						}
						else
						{
							ImageObject.GetObjectData().ConvertTo32BPP();
						
							long width = ImageObject.GetObjectData().GetWidth();
							long height = ImageObject.GetObjectData().GetHeight();
							
							// convert to BGRA
							/*BTCImageData red, green, blue, alpha;
							red.Create( width, height, 8 );
							green.Create( width, height, 8 );
							blue.Create( width, height, 8 );
							alpha.Create( width, height, 8 );
							ImageObject.GetObjectData().SplitChannels( &red, &green, &blue, &alpha );
							//ImageObject.GetObjectData().CombineChannels( &blue, &green, &red, &alpha );*/

							// add a new frame to the AVI from the rendered image's bitmap bits
							ImageObject.GetObjectData().Flip();
							DWORD *flippedBuffer = (DWORD*)ImageObject.GetObjectData().GetBits();	                    

							

							// dump the frame
							HRESULT hr;
							if (FAILED(hr = AVIFile.AddFrame(width, height, flippedBuffer, 32)))
							{
								/*red.DeleteObject();
								green.DeleteObject();
								blue.DeleteObject();
								alpha.DeleteObject();*/
								return;
							}
							/*red.DeleteObject();
							green.DeleteObject();
							blue.DeleteObject();
							alpha.DeleteObject();*/
						}
						
						
					}
					else
					{
						return;
					}
			        
	                
				}
			} // not psd output

	    }

    }
}
