#ifndef XMLSETTINGS_H
#define XMLSETTINGS_H

#import "msxml6.dll" named_guids raw_interfaces_only

/////////////////////////////////////////////////////////////////////////////
// CXMLSettings window

#include <atlbase.h>

class CXMLSettings
{
// Construction
public:
	CXMLSettings()
	{
		XmlDocPtr = NULL;
		cstrConfigFile = "";
	}

// Implementation
public:
	void SetSettingsFile(CString cstrFile) { cstrConfigFile = cstrFile; };

	void read( CString cstrBaseKeyName, CString cstrValueName, float& outval, float fDefaultValue );
	void write( CString cstrBaseKeyName, CString cstrValueName, float fValue );

	void read( CString cstrBaseKeyName, CString cstrValueName, int& outval, int iDefaultValue );
	void write( CString cstrBaseKeyName, CString cstrValueName, int iValue );

	void read( CString cstrBaseKeyName, CString cstrValueName, bool& outval, bool bDefaultValue );
	void write( CString cstrBaseKeyName, CString cstrValueName, bool bValue );
	
	void read( CString cstrBaseKeyName, CString cstrValueName, CString& outval, CString strDefaultValue );
	void write( CString cstrBaseKeyName, CString cstrValueName, CString strValue );

	long GetSettingLong(CString cstrBaseKeyName, CString cstrValueName, long lDefaultValue);
	long SetSettingLong(CString cstrBaseKeyName, CString cstrValueName, long lValue);

	CString GetSettingString(CString cstrBaseKeyName, CString cstrValueName, CString cstrDefaultValue);
	long SetSettingString(CString cstrBaseKeyName, CString cstrValueName, CString cstrValue);

	BOOL DeleteSetting(CString cstrBaseKeyName, CString cstrValueName);

protected:
	MSXML2::IXMLDOMDocument2Ptr XmlDocPtr;
	CString cstrConfigFile;

	CString* ParseKeys(CString cstrFullKeyPath, int &iNumKeys);
	BOOL LoadXML();
	BOOL SaveXML();
	void UnloadXML() { XmlDocPtr = NULL; };
	MSXML2::IXMLDOMNodePtr FindNode(MSXML2::IXMLDOMNodePtr parentNode, CString* pCStrKeys, int iNumKeys, BOOL bAddNodes = FALSE);

};

#endif
