float bias (float x, val){
         return (val > 0) ? pow(x,log(val) / log(0.5)) : 0;
         }
         
surface tShair (float Ka = 0, Kd = .6, Ks = .35, roughness = .15;
	      color rootcolor = color (.109, .037, .007);
	      color tipcolor = color (.519, .325, .125);
	      color specularcolor = (color(1) + tipcolor) / 2;
float texureps = 1;
float texvreps = 1;
float texuoffset = 0;
float texvoffset = 0;
float tipfade = 0.001;
string texmap = "";
	     )
{
	color Ct = Cs;
	if ( texmap != "" )
	{
		float ss = (s + texuoffset) * texureps;
		float tt = (t + texvoffset) * texvreps;
		
		Ct = texture( texmap, ss, tt, "filter", "gaussian" );
	}
	
    vector T = normalize (dPdv); /* tangent along length of hair */
    vector V = -normalize(I);    /* V is the view vector */
    color Cspec = 0, Cdiff = 0;  /* collect specular & diffuse light */
    float cosang;

    /* Loop over lights, catch highlights as if this was a thin cylinder */
    illuminance (P) {
    
    float nonspecular = 0;
    float nondiffuse = 0;
	lightsource( "__nondiffuse", nondiffuse );
	lightsource( "__nonspecular", nonspecular );
		
	if( nonspecular == 0 )
	{		
		cosang = cos (abs (acos (T.normalize(L)) - acos (-T.V)));
		Cspec += Cl * v * pow (cosang, 1/roughness);
	}
	
	if( nondiffuse == 0 )
	{
		Cdiff += Cl * v;
		//normal Nf = faceforward( normalize(N), I );
		//normal Nn = normalize( normal( rotate( point(Nf), (u - 0.5) * PI, point(0), point(T) ) ) );
		//Cdiff += Cl * diffuse(Nn);
	}
		
	/* We multipled by v to make it darker at the roots.  This
	 * assumes v=0 at the root, v=1 at the tip.
	 */
    }

    Oi = Os * (1-(bias(tipfade, v)));
    Ci = Oi * ( (Ct * mix(rootcolor, tipcolor, v)) * (Ka*ambient() + Kd*Cdiff)
                 + (Ks * Cspec * specularcolor));
}
