light tSpointlight( 
	float intensity = 1;
	color lightcolor = 1;
	point from = point "shader" (0,0,0);
	float decay = 2.0;
	float falloffcoeff = 0.050047796;
	float doshadow = 0;
	uniform string shadowmap = "";
	uniform float blur = 0;
	output float __foglight = 1;
	float __nondiffuse=0, __nonspecular=0;
)
{
	illuminate( from )
	{
		Cl = intensity;
		
		float dist = length( L );
		if ( decay == 1.0 )
		{
			Cl /= (falloffcoeff * dist + 1.0);
		}
		else if ( decay == 2.0 )
		{
			Cl /= (falloffcoeff * dist*dist + 1.0);
		}
				
		if ( doshadow == 1.0 )
			Cl *= transmission( from, Ps );
			
		color shad = shadow( shadowmap, Ps, "blur", blur );
		
		Cl *= lightcolor;
		
		Cl *= (1 - shad);
	}
}
