#define eps 0.000001

light
tSprojectorlight(
	float intensity = 1;
	color lightcolor = 1;
	uniform string shadowmap = "";
	uniform float blur = 0;
	point from = point "shader" (0,0,0);
	point to = point "shader" (0,0,1);
	point up = point "eye" (0,0,1);
	float coneangle = radians(30);
	float decay = 2.0; 
	float falloffcoeff = 0.050047796;
	float __nondiffuse = 0, __nonspecular = 0;
	float doshadow = 0;
	uniform string texturemap = "";
	output float __foglight = 1;
)
{
	
	uniform point	relT, 	/* normalized direction vector */
			relU, 	/* "vertical" perspective of surface point */
			relV;	/* "horizontal" perspective of surface point */
	uniform float spread = 1/tan(coneangle/2); /* spread of "beam" */
	float	Pt, 		/* projection of Ps on relT (distance of 
				   surface point along light direction)	*/
		Pu, 		/* projection of Ps on relU */
 		Pv, 		/* projection of Ps on relU */
 		sloc, tloc;	/* perspected surface point */

	/* Initialize uniform variables for perspective */
	relT = normalize(to - from);
	relU = relT ^ up;
	relV = normalize(relT ^ relU);
	relU = relV^relT;

	
	illuminate(from, relT, atan(sqrt(2)/spread)) {
		L =  Ps - from;	/* direction of light source from surf. point */
		Pt = L.relT;	/* coordinates of Ps along relT, relU, relV */
		Pu = L.relU;
		Pv = L.relV;
		sloc = spread*Pu/Pt;	/* perspective divide	*/
		tloc = spread*Pv/Pt;
		sloc = sloc*.5 + .5;	/* correction from [-1,1] to [0,1] */
		tloc  = tloc*.5 + .5;
		
		color slidecol = lightcolor;

		color shad = shadow( shadowmap, Ps, "blur", blur );
		
		if ( texturemap != "" )
		{
			slidecol *= color texture (texturemap, sloc, tloc);
		}
		
		Cl = (1 - shad) * (intensity * slidecol);
		
		float dist = length( L );
					
		if ( decay == 1.0 )
		{
			Cl /= (falloffcoeff * dist + 1.0);
		}
		else if ( decay == 2.0 )
		{
			Cl /= (falloffcoeff * dist*dist + 1.0);
		}
		
		if ( doshadow == 1.0 )
			Cl *= transmission( from, Ps );
		
	}
	
	
	
}
