/******************************************************************************/
/*                                                                            */
/*    Copyright (c)The 3Delight Team.                                         */
/*    All Rights Reserved.                                                    */
/*                                                                            */
/******************************************************************************/

#define eps 0.000001

light
tSspotlight(
	float intensity = 1;
	color lightcolor = 1;
	uniform string shadowmap = "";
	uniform float blur = 0;
	point from = point "shader" (0,0,0);
	point to = point "shader" (0,0,1);
	float coneangle = radians(30);
	float conedeltaangle = radians(5);
	float beamdistribution = 2;
	float decay = 2.0; 
	float falloffcoeff = 0.050047796;
	float __nondiffuse = 0, __nonspecular = 0;
	float doshadow = 0;
	output float __foglight = 1;
)
{
	uniform vector A = (to - from) / length(to - from);
	uniform float cosa = cos(coneangle*0.5);
	uniform float cosh = cos(conedeltaangle*0.5);
	uniform float invert = 0.0;
	if(abs(cosh-cosa) > eps)
		invert = 1.0/(cosh-cosa);

	
	illuminate( from, A, coneangle ) 
	{
		color shad = shadow( shadowmap, Ps, "blur", blur );

		Cl = (1 - shad) * (intensity * lightcolor);
		
		float dist = length( L );
		
		
		if( dist > eps)
		{
			float c = L.A / dist;		// cosine of the actual angle
			if (c<cosa) 
				Cl = 0;
			if (c<cosh)
				Cl *= (c-cosa)*invert;
		}
	
		if ( decay == 1.0 )
		{
			Cl /= (falloffcoeff * dist + 1.0);
		}
		else if ( decay == 2.0 )
		{
			Cl /= (falloffcoeff * dist*dist + 1.0);
		}
		
		if ( doshadow == 1.0 )
			Cl *= transmission( from, Ps );
	}
}
