surface tSsss(
float Ks = 0.5; 
float Kd = 1;
float Ka = 1;
float roughness = 0.1;
float Kr = 0;
float reflectsamples = 1;
float reflectblur = 0.0001;
color specularcolor = 1;
float ureps = 1;
float vreps = 1;
float uoffset = 0;
float voffset = 0;
string texturename = "";
float IOR = 1.3;
string envmap = "raytrace";
float envexposure = 0.0;
color bg_color = 0;
float translucency = 1.0;

	output varying color __ambient = color(0);
	output varying color __diffuse = color(0);
	output varying color __specular = color(0);
	output varying color __reflect = color(0);
	output varying color __subsurface = color(0);
 )
{	
	normal Nf = faceforward( normalize(N), I );
	normal NI = normalize( I );
	vector V = normalize(-I);

    Oi = Os;

	float ss = (s + uoffset) * ureps;
	float tt = (t + voffset) * vreps;
	
	color Ct = 0;
	Ct = ( texturename != "" ) ?
		texture( texturename, ss, tt, "filter", "gaussian" ) : Cs;
		
    string raytype = "";
    rayinfo( "type", raytype );

    if ( raytype == "subsurface" )
    {
      __subsurface = 0;
      __ambient = Ka * Ct * ambient();
      __diffuse = Kd * Ct * diffuse(Nf);
      __specular = 0;
      __reflect = 0;

    } else {

	  __subsurface = subsurface(P);
      __ambient = 0;
      __diffuse = Oi * (translucency * __subsurface);
      //__specular = Oi * specularcolor * Ks * specularstd( Nf, V, roughness );
      __specular = Oi * specularcolor * Ks * phong( Nf, V, roughness );
      
		color Cr = 0;
		
		if ( Kr > 0.0 )
		{
			float Kr_geom, Kt_geom;
			vector Rdir, Tdir;
			fresnel( NI, Nf, ( I.N < 0 ) ? 1.0 / IOR : IOR, Kr_geom, Kt_geom, Rdir, Tdir );
			Rdir = normalize( Rdir );
			color envcolor = 0;
			if ( envmap != "" )
			{
				envcolor = environment( envmap, vtransform( "world", Rdir ) );
				envcolor *= pow( 2, envexposure );
			}
			else
				envcolor = bg_color;

			/*float dist;
			Cr = trace( P, Rdir, dist );
			if ( dist > 1e30 )
				Cr = environment( envmap, Rdir );
			Cr *= Kr * Kr_geom;*/
			
			color hitcolor = 0;			
			gather("illuminance", P, Rdir, reflectblur, reflectsamples, "surface:Ci", hitcolor)
			{
				   __reflect += hitcolor;
			}
			else
			{
					__reflect += envcolor;
			}
			__reflect /= reflectsamples;
												
			__reflect *= Kr;
			
			__reflect *= Oi;
		}
      //__reflect = Oi * Ct * Cr;
    }

    Ci = __ambient + __diffuse + __specular + __reflect;
	
}
