surface tSstandard(

float Ka = .1;
string Ka_map = "";

float Kd = .6;
string Kd_map = "";

float Ks = .7; 
string Ks_map = "";

float roughness = .04;
string roughness_map = "";

color specularcolor = 1;

float Kr = 0; 
string Kr_map = "";

float Kt = 0; 
string Kt_map = "";

float ior = 1.3;
string ior_map = "";

float metal = 0;

float maskureps = 1;
float maskvreps = 1;
float maskuoffset = 0;
float maskvoffset = 0;
string maskmap = ""; 
float maskfilter = 0;

float texureps = 1;
float texvreps = 1;
float texuoffset = 0;
float texvoffset = 0;
string texmap = ""; 

float raytracing = 0;
string envmap = "";
float envexposure = 0.0;
color bg_color = 0;
float reflectsamples = 1;
float reflectblur = 0.0001;

float usephong = 1;

output varying color __diffuse = color(0);
output varying color __ambient = color(0);
output varying color __specular = color(0);
output varying color __reflect = color(0);
output varying color __refract = color(0);
 )
{


	float calcKa = Ka;
	float calcKd = Kd;
	float calcKs = Ks;
	float calcroughness = roughness;
	float calcKr = Kr;
	float calcKt = Kt;
	float calcior = ior;
	
	normal Nn = normalize(N);
    normal Nf = faceforward(Nn, I);
    vector V = normalize(-I);
        
	
	Oi = Os;
	
	if ( maskmap != "" )
	{
		float ss = (s + maskuoffset) * maskureps;
		float tt = (t + maskvoffset) * maskvreps;
		
		if ( maskfilter > 0 )
		{
			Oi = 1 - texture( maskmap, ss, tt, "filter", "gaussian" );
		}
		else
		{
			float bpp;
			textureinfo( maskmap, "channels", bpp );
			if ( bpp == 4 )
			{
				float alpha = texture( maskmap[3], ss, tt, "filter", "gaussian", "fill", 1.0 );
				Oi = color(alpha, alpha, alpha);
			}
			else
			{
				color pixel = texture( maskmap, ss, tt, "filter", "gaussian" );
				//float val = (0.3*comp(pixel,0) + 0.59*comp(pixel,1) + 0.11*comp(pixel,2));
				float val = (comp(pixel,0) + comp(pixel,1) + comp(pixel,2)) / 3;
				Oi = color( val, val, val );
			}
		}
		
	}
	
	color Ct = Cs;
	if ( texmap != "" )
	{
		float ss = (s + texuoffset) * texureps;
		float tt = (t + texvoffset) * texvreps;
		
		Ct = texture( texmap, ss, tt, "filter", "gaussian" );
	}
		
	color speccol = specularcolor;
    if ( metal > 0.0 )
		speccol = Ct;
		
	// now filter the channels by the maps if needed
	if ( Ka_map != "" )
	{
		color pixel = texture( Ka_map, "filter", "gaussian" );
		float val = (comp(pixel,0) + comp(pixel,1) + comp(pixel,2)) / 3;
		calcKa *= val;
	}
	if ( Kd_map != "" )
	{
		color pixel = texture( Kd_map, "filter", "gaussian" );
		float val = (comp(pixel,0) + comp(pixel,1) + comp(pixel,2)) / 3;
		calcKd *= val;
	}
	if ( Ks_map != "" )
	{
		color pixel = texture( Ks_map, "filter", "gaussian" );
		float val = (comp(pixel,0) + comp(pixel,1) + comp(pixel,2)) / 3;
		calcKs *= val;
	}
	if ( roughness_map != "" )
	{
		color pixel = texture( roughness_map, "filter", "gaussian" );
		float val = (comp(pixel,0) + comp(pixel,1) + comp(pixel,2)) / 3;
		calcroughness *= val;
	}
	if ( Kr_map != "" )
	{
		color pixel = texture( Kr_map, "filter", "gaussian" );
		float val = (comp(pixel,0) + comp(pixel,1) + comp(pixel,2)) / 3;
		calcKr *= val;
	}
	if ( Kt_map != "" )
	{
		color pixel = texture( Kt_map, "filter", "gaussian" );
		float val = (comp(pixel,0) + comp(pixel,1) + comp(pixel,2)) / 3;
		calcKt *= val;
	}
		
	if ( ( calcKr > 0 ) || ( calcKt > 0 ) )	
	{
		vector Rdir = reflect( I, Nf );
		color envcolor = 0;
		if ( envmap != "" )
		{
			envcolor = environment( envmap, vtransform( "world", Rdir ) );
			envcolor *= pow( 2, envexposure );
		}
		else
			envcolor = bg_color;
			
		if ( calcKr > 0 )
		{
			/*if ( raytracing > 0 )
			{
				float dist;
				__reflect = trace( P, Rdir, dist, "samples", reflectsamples );
				//if ( ( dist > 1e30 ) )
				//	__reflect = envcolor;
			}
			else
				__reflect = envcolor;*/
			
			
				
			color hitcolor = 0;			
			gather("illuminance", P, Rdir, reflectblur, reflectsamples, "surface:Ci", hitcolor)
			{
				   __reflect += hitcolor;
			}
			else
			{
					__reflect += envcolor;
			}
			__reflect /= reflectsamples;
			
				
			if ( metal > 0 )
				__reflect *= Ct;
					
			__reflect *= calcKr;
			
			__reflect *= Oi;
		}
		
		if ( calcKt > 0 )
		{
			vector Tdir = refract( I, Nf, 1.0 / calcior );
			
			if ( raytracing > 0 )
			{
				float dist;
				//__refract = trace( P, Tdir, dist );
				//if ( ( dist > 1e30 ) && ( envmap != "" ) )
				//	__refract = environment( envmap, Tdir );
				__refract = trace( P, Tdir );
			}
			else
				__refract = environment( envmap, Tdir );
				
			if ( metal > 0 )
				__refract *= Ct;
				
			__refract *= calcKt;
			__refract *= Oi;
		}		
	}
	
	__ambient = Oi * Ct * calcKa * ambient();
	__diffuse = Oi * Ct * calcKd * diffuse(Nn);
	
	color spec;
	if ( usephong == 1.0 )		
		spec = phong( Nf, V, calcroughness );
	else		
		//spec = specularstd( Nf, V, calcroughness );
		spec = specular( Nf, V, calcroughness );
		
	__specular = Oi * speccol * calcKs * spec;
	
	Ci = __ambient + __diffuse + __specular + __reflect + __refract;
	
}
