// tsdd.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "tsdd.h"

#include <assert.h>
#include <stdio.h>
#include <float.h>
#include <string.h>
#include <limits.h>

static HANDLE hInst;

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
	hInst = hModule;

	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
	case DLL_THREAD_ATTACH:
	case DLL_THREAD_DETACH:
	case DLL_PROCESS_DETACH:
		break;
	}
    return TRUE;
}

// This is an example of an exported variable
DEDD_API int ndedd=0;

// This is an example of an exported function.
DEDD_API int fndedd(void)
{
	return 42;
}

// This is the constructor of a class that has been exported.
// see tsdd.h for the class definition
Cdedd::Cdedd()
{ 
	return; 
}


///////////////////////////////////////////////////////////////////////////////

#define WM_APP       0x8000
#define UM_RAYPROGRESS			(WM_APP + 1)
#define UM_UPDATERENDERBMP		(WM_APP + 24)

static bool m_Abort;

struct CtsxColor
{
    unsigned char red;	 // 0 - 255
    unsigned char green;
    unsigned char blue;
    unsigned char alpha; // 0 - 255
};

///////////////////////////////////////////////////////////////////////////////

void  SaveBitmap(char *szFilename,HBITMAP hBitmap)

{

      HDC        hdc=NULL;

      FILE*      fp=NULL;

      LPVOID     pBuf=NULL;

      BITMAPINFO bmpInfo;

      BITMAPFILEHEADER  bmpFileHeader; 

      do{ 

            hdc=GetDC(NULL);

            ZeroMemory(&bmpInfo,sizeof(BITMAPINFO));

            bmpInfo.bmiHeader.biSize=sizeof(BITMAPINFOHEADER);

            GetDIBits(hdc,hBitmap,0,0,NULL,&bmpInfo,DIB_RGB_COLORS); 

            if(bmpInfo.bmiHeader.biSizeImage<=0)

            bmpInfo.bmiHeader.biSizeImage=bmpInfo.bmiHeader.biWidth*abs(bmpInfo.bmiHeader.biHeight)*(bmpInfo.bmiHeader.biBitCount+7)/8;

            if((pBuf = malloc(bmpInfo.bmiHeader.biSizeImage))==NULL)

            {

                  fprintf( stderr, "Unable to Allocate Bitmap Memory\n" );

                  break;

            }           

            bmpInfo.bmiHeader.biCompression=BI_RGB;

            GetDIBits(hdc,hBitmap,0,bmpInfo.bmiHeader.biHeight,pBuf, &bmpInfo, DIB_RGB_COLORS);       

            if((fp = fopen(szFilename,"wb"))==NULL)

            {

                  fprintf( stderr, "Unable to Create Bitmap File\n" );

                  break;

            } 

            bmpFileHeader.bfReserved1=0;

            bmpFileHeader.bfReserved2=0;

            bmpFileHeader.bfSize=sizeof(BITMAPFILEHEADER)+sizeof(BITMAPINFOHEADER)+bmpInfo.bmiHeader.biSizeImage;

            bmpFileHeader.bfType='MB';

            bmpFileHeader.bfOffBits=sizeof(BITMAPFILEHEADER)+sizeof(BITMAPINFOHEADER); 

            fwrite(&bmpFileHeader,sizeof(BITMAPFILEHEADER),1,fp);

            fwrite(&bmpInfo.bmiHeader,sizeof(BITMAPINFOHEADER),1,fp);

            fwrite(pBuf,bmpInfo.bmiHeader.biSizeImage,1,fp); 

      }while(false); 

            if(hdc)     ReleaseDC(NULL,hdc); 

            if(pBuf)    free(pBuf); 

            if(fp)      fclose(fp);

}

void FillChar(char* pChar, int length, int data)
{
	for (int n = 0; n < length; n++)
	{
		pChar[n] = data;
	}
}


void WriteTGAImage(char* filename, CtsxColor *pBuffer, int width, int height)
{
	FILE* f = NULL;
	
	if( (f = fopen(filename, "wb")) != NULL )
	{
		char Field1;
		char Field2;
		char Field3;
		char Field4[5];
		char Field5[10];
		char Footer[26];
		
		Field1 = __toascii(0);
		Field2 = __toascii(0);
		Field3 = __toascii(2);

		FillChar(&Field4[0], 5, 0);

		FillChar(&Footer[0], 8, 0);
		strcpy(&Footer[8], "TRUEVISION-XFILE.");


		Field5[0] = char(0 % 256);
		Field5[1] = char(0 / 256);
		Field5[2] = char(0 % 256);
		Field5[3] = char(0 / 256);
		Field5[4] = char(width % 256);
		Field5[5] = char(width / 256);
		Field5[6] = char(height % 256);
		Field5[7] = char(height / 256);
		Field5[8] = char(32);
		Field5[9] = char(8);

		fwrite(&Field1, 1, 1, f);
		fwrite(&Field2, 1, 1, f);
		fwrite(&Field3, 1, 1, f);
		fwrite(&Field4, 5, 1, f);
		fwrite(&Field5, 10, 1, f);

		
		fwrite( pBuffer, width * height * sizeof(CtsxColor), 1, f );

		
		fwrite(&Footer, 26, 1, f);
		fclose( f );

		
	}
	

}

/* ZFile Display Driver Implementation */
const unsigned kDefaultZFileSize = 512;
/*
zfile format:
zFile format is (matrices and image are row-major):
magic # (0x2f0867ab) (4 bytes)
width (short) (2 bytes)
height (short) (2 bytes)
shadow matrices (32 floats, 16 for NP and 16 for Nl) (128 bytes)
image data (floats) (width*height*4 bytes)
NOTE
Matrices are stored in row major format.
*/
class zFile
{
public:
	zFile(
	unsigned short width, unsigned short height, HWND mainhwnd, HWND renhwnd, int cropped, int cropx1, int cropy1, int matprev, char *pFilename, int windowwidth, int windowheight ): m_width(width), m_height(height), m_currentLine(0), m_pixelsLeftOnLine(width)
	{
		pBitmapBits = NULL;
		hBitmap = NULL;
		pTGABuffer = NULL;

		hMainWnd = mainhwnd;
		hRenWnd = renhwnd;

		m_Cropped = cropped;
		m_CropX1 = cropx1;
		m_CropY1 = cropy1;

		m_MatPreview = matprev;

		ZeroMemory ( &BitmapInfo, sizeof (BITMAPINFO) );

		BitmapInfo.bmiHeader.biSize = sizeof (BITMAPINFOHEADER);
		BitmapInfo.bmiHeader.biWidth = m_width;
		BitmapInfo.bmiHeader.biHeight = m_height;
		BitmapInfo.bmiHeader.biPlanes =1;
		BitmapInfo.bmiHeader.biBitCount = 32; 
		BitmapInfo.bmiHeader.biCompression = BI_RGB;
		BitmapInfo.bmiHeader.biSizeImage = m_width*m_height*4;
		
		hBitmap = CreateDIBSection ( NULL, &BitmapInfo, DIB_RGB_COLORS, (void **)&pBitmapBits, NULL, NULL ); 

		strcpy( m_filename, pFilename );

		m_windowwidth = windowwidth;
		m_windowheight = windowheight;

		pTGABuffer = new CtsxColor[m_width * m_height];
		
	}

	~zFile()
	{		
		/*if (hBitmap)
		{
			char file[255];
			sprintf( file, "%s.bmp", m_filename );
			SaveBitmap( file, hBitmap );

			//DeleteObject(hBitmap);
			//hBitmap = NULL;
		}*/

		char file[255];
		sprintf( file, "%s.tga", m_filename );
		WriteTGAImage( file, pTGABuffer, m_width, m_height );
		delete []pTGABuffer;

	}

	bool IsMatPreview() { return ( m_MatPreview == 1 ); }
	bool IsCropped() { return ( m_Cropped == 1 ); }
	bool Valid() const { return ( pBitmapBits != NULL ); }
	unsigned GetWidth() const {return m_width;}
	unsigned GetHeight() const {return m_height;}
	int GetWindowWidth() {return m_windowwidth;}
	int GetWindowHeight()  {return m_windowheight;}
	HWND GetMainHwnd() { return hMainWnd; }
	HWND GetRenHwnd() { return hRenWnd; }
	HBITMAP GetBitmap() { return hBitmap; }
	int GetCropX1() { return m_CropX1; }
	int GetCropY1() { return m_CropY1; }
	bool WriteScanline( unsigned short y, unsigned short size, const unsigned char* data )
	{
		if( y != m_currentLine || size > m_pixelsLeftOnLine )
		{
			return false;
		}

		m_pixelsLeftOnLine -= size;
		if( m_pixelsLeftOnLine == 0 )
		{
			++m_currentLine;
			m_pixelsLeftOnLine = m_width;

		}

		const unsigned char* pData = data;
		for (int x = 0; x < m_width; x++)
		{
			char r = pData[0];
			char g = pData[1];
			char b = pData[2];
			pBitmapBits[(m_width * (m_height - y - 1)) + x] = RGB(b, g, r);

			pData += 4;
		}
		return true;
	}
	
	bool WriteBucket( unsigned short inx, unsigned short iny, unsigned short inwidth, unsigned short inheight, const unsigned char* data )
	{
		const unsigned char* pData = data;
		for ( int y = 0; y < inheight; y++ )
		{
			for ( int x = 0; x < inwidth; x++ )
			{
				char r = pData[0];
				char g = pData[1];
				char b = pData[2];
				char a = pData[3];

				pBitmapBits[(m_width * (m_height - (iny + y) - 1)) + (inx + x)] = RGB(b, g, r);

				pTGABuffer[(m_width * (m_height - (iny + y) - 1)) + (inx + x)].red = b;
				pTGABuffer[(m_width * (m_height - (iny + y) - 1)) + (inx + x)].green = g;
				pTGABuffer[(m_width * (m_height - (iny + y) - 1)) + (inx + x)].blue = r;
				pTGABuffer[(m_width * (m_height - (iny + y) - 1)) + (inx + x)].alpha = a;
				
				
				pData += 4;
				
			}
		}
		return true;
	}


private:
	unsigned short m_width;
	unsigned short m_height;
	unsigned short m_currentLine;
	unsigned short m_pixelsLeftOnLine;
	int m_Cropped;
	int m_CropX1;
	int m_CropY1;
	int	m_MatPreview;
	int m_windowwidth;
	int m_windowheight;

	BITMAPINFO BitmapInfo;
	COLORREF BackColor;
	COLORREF* pBitmapBits;
	HBITMAP hBitmap;

	HWND	hMainWnd;
	HWND	hRenWnd;

	char	m_filename[255];

	CtsxColor *pTGABuffer;


};

/*
A utility function to get user parameters ...
*/
const void* GetParameter( const char *name, unsigned n, const UserParameter parms[] )
{
	for( unsigned i=0; i<n; i++ )
	{
		if(0 == strcmp(name, parms[i].name))
		{
			return parms[i].value;
		}
	}
	return 0x0;
}

DEDD_API PtDspyError DspyImageQuery ( PtDspyImageHandle i_hImage, PtDspyQueryType i_type, size_t i_datalen, void *i_data )
{
	zFile *aZFile = (zFile*) i_hImage;
	if( !i_data )
	{
		return PkDspyErrorBadParams;
	}
	switch( i_type )
	{
		case PkSizeQuery:
		{
			PtDspySizeInfo sizeQ;
			if( aZFile )
			{
				sizeQ.width = aZFile->GetWidth();
				sizeQ.height = aZFile->GetHeight();
				sizeQ.aspectRatio = 1;
			}
			else
			{
				sizeQ.width = kDefaultZFileSize;
				sizeQ.height = kDefaultZFileSize;
				sizeQ.aspectRatio = 1;
			}
			memcpy( i_data, &sizeQ, 	i_datalen>sizeof(sizeQ) ? sizeof(sizeQ) : i_datalen );
			break;
		}
		case PkOverwriteQuery:
		{
			PtDspyOverwriteInfo overwQ;
			overwQ.overwrite = 1;
			memcpy( i_data, &overwQ, i_datalen>sizeof(overwQ) ? sizeof(overwQ) : i_datalen );
			break;
		}
		default:
		return PkDspyErrorUnsupported;
	}
	return PkDspyErrorNone;
}


/*BOOL CALLBACK renderwinproc( HWND hwnd, LPARAM lParam )
{
	char wndname[255];
	GetWindowText( hwnd, &wndname[0], 255 );

	if ( strcmp( wndname, (const char*)lParam ) == 0 )
	{
		renhwnd = hwnd;
		return FALSE;
	}
	else
		return TRUE;
	
}

BOOL CALLBACK screenwinproc( HWND hwnd, LPARAM lParam )
{
	char classname[255];
	GetClassName( hwnd, &classname[0], 255 );

	if ( strcmp( classname, (const char*)lParam ) == 0 )
	{
		renhwnd = hwnd;
		return FALSE;
	}
	else
		return TRUE;
	
}
*/

DEDD_API PtDspyError DspyImageOpen ( PtDspyImageHandle * i_phImage, const char *drivername, const char *i_filename, int i_width, int i_height, int i_parametercount, const UserParameter *i_parameters, int i_numFormat, PtDspyDevFormat *i_format, PtFlagStuff *flagstuff)
{
	m_Abort = false;

	int i;

	for( i=0; i<i_numFormat; i++ )
	{
		i_format[i].type = PkDspyUnsigned8;		
	}

	if (i_width > USHRT_MAX || i_height > USHRT_MAX)
	{
		fprintf( stderr, "dspy_z : image too large for zfile format (use shadowmap ddriver).\n" );
		return PkDspyErrorUndefined;
	}	

	// find classname param
	char *mainclassname;	
	char *renclassname;
	HWND renhwnd;
	HWND mainhwnd;
	int toscreen = 0;
	int cropped = 0;
	int cropx1 = 0;
	int cropy1 = 0;
	int matpreview = 0;
	int windowwidth = 0;
	int windowheight = 0;
	for ( int n = 0; n < i_parametercount; n++ )
	{
		if ( strcmp( i_parameters[n].name, "mainclassname" ) == 0 )
		{
			mainclassname = *(char **)i_parameters[n].value;
		}
		if ( strcmp( i_parameters[n].name, "renclassname" ) == 0 )
		{
			renclassname = *(char **)i_parameters[n].value;
		}
		if ( strcmp( i_parameters[n].name, "toscreen" ) == 0 )
		{
			toscreen = *(int*)i_parameters[n].value;
		}
		if ( strcmp( i_parameters[n].name, "cropped" ) == 0 )
		{
			cropped = *(int*)i_parameters[n].value;
		}
		if ( strcmp( i_parameters[n].name, "cropx1" ) == 0 )
		{
			cropx1 = *(int*)i_parameters[n].value;
		}
		if ( strcmp( i_parameters[n].name, "cropy1" ) == 0 )
		{
			cropy1 = *(int*)i_parameters[n].value;
		}
		if ( strcmp( i_parameters[n].name, "matpreview" ) == 0 )
		{
			matpreview = *(int*)i_parameters[n].value;
		}
		if ( strcmp( i_parameters[n].name, "renhwnd" ) == 0 )
		{
			renhwnd = *(HWND*)i_parameters[n].value;
		}
		if ( strcmp( i_parameters[n].name, "mainhwnd" ) == 0 )
		{
			mainhwnd = *(HWND*)i_parameters[n].value;
		}
		if ( strcmp( i_parameters[n].name, "windowwidth" ) == 0 )
		{
			windowwidth = *(int*)i_parameters[n].value;
		}
		if ( strcmp( i_parameters[n].name, "windowheight" ) == 0 )
		{
			windowheight = *(int*)i_parameters[n].value;
		}
	}	
	
	/*HWND mainhwnd = FindWindow( mainclassname, NULL );
	
	// look to see if it's rendering to the render window or to screen
	if ( toscreen )
		EnumChildWindows( mainhwnd, screenwinproc, (LPARAM)renclassname );
	else
	{
		if ( matpreview == 0 )
		{
			renhwnd = FindWindow( NULL, "Render Output" );
			if ( renhwnd )
				EnumChildWindows( renhwnd, renderwinproc, (LPARAM)"P3DRENDERWINDOW" );
		}
		else
		{
			renhwnd = FindWindow( NULL, "Material Editor" );
			if ( renhwnd )
				EnumChildWindows( renhwnd, renderwinproc, (LPARAM)"P3DMATPREVWINDOW" );		
		}
	}
	renhwnd = testwnd;*/

	zFile* aZFile = new zFile( i_width, i_height, mainhwnd, renhwnd, cropped, cropx1, cropy1, matpreview, (char*)i_filename, windowwidth, windowheight );
	if( !aZFile || !aZFile->Valid() )
	{
		fprintf( stderr, "dspy_z : cannot create file (permissions ? free disk space ?).\n" );
		delete aZFile;
		return PkDspyErrorNoResource;
	}
	*i_phImage = (void*) aZFile;
	/* Ask display manager to provide data scanline by scanline
	*/
	//flagstuff->flags |= PkDspyFlagsWantsScanLineOrder;
	return PkDspyErrorNone;
}

DEDD_API PtDspyError DspyImageData ( PtDspyImageHandle i_hImage, int i_xmin, int i_xmax_plusone, int i_ymin, int i_ymax_plusone, int i_entrySize, const unsigned char *i_data )
{	
	MSG msg;
	while( PeekMessage( &msg, NULL, 0, 0, PM_NOREMOVE ) )
	{
		GetMessage( &msg, NULL, 0, 0 );
		TranslateMessage( &msg );

		switch( msg.message )
		{
			case WM_CHAR :	if( (msg.wParam == 0x1b) )
								m_Abort = true;
							break;
			default:		DispatchMessage( &msg );	break;
		}
	}

	if ( m_Abort )
		return PkDspyErrorStop;

	zFile* aZFile = (zFile*) i_hImage;
	const unsigned char* fdata = (const unsigned char*) i_data;
	if( !aZFile || !fdata )
	{
		return PkDspyErrorBadParams;
	}
	

	if( !aZFile->WriteBucket( i_xmin, i_ymin, i_xmax_plusone - i_xmin, i_ymax_plusone - i_ymin, fdata) )
	{
		return PkDspyErrorNoResource;
	}

	if ( aZFile->GetRenHwnd() != NULL )
	{
		BITMAP bm;
		HBITMAP hbmp = aZFile->GetBitmap();
		HDC hdc = GetDC( aZFile->GetRenHwnd() );
		HDC hdcMem = CreateCompatibleDC(hdc);
		HGDIOBJ hbmOld = SelectObject(hdcMem, hbmp);
	    
		int cropx = aZFile->GetCropX1();
		int cropy = aZFile->GetCropY1();
		GetObject( hbmp, sizeof(bm), &bm );
        BitBlt( hdc, i_xmin+cropx, i_ymin+cropy, i_xmax_plusone - i_xmin, i_ymax_plusone - i_ymin, hdcMem, i_xmin, i_ymin, SRCCOPY );

        

		SelectObject(hdcMem, hbmOld);
		DeleteDC(hdcMem);
		ReleaseDC( aZFile->GetRenHwnd(), hdc );

		// this appears to cause a problem after a lot of refreshes
		//RECT rect;
		//GetClientRect( aZFile->GetRenHwnd(), &rect );
		//HRGN rgn = CreateRectRgn( rect.left, rect.top, rect.left, rect.right );
		//InvalidateRgn( aZFile->GetRenHwnd(), rgn, true );
	}
	


	return PkDspyErrorNone;
}

DEDD_API PtDspyError DspyImageClose ( PtDspyImageHandle i_hImage )
{
	zFile* aZFile = (zFile*) i_hImage;
	if( !aZFile )
	{
		return PkDspyErrorUndefined;
	}

	if ( !aZFile->IsCropped() )
	{
		SendMessage( aZFile->GetMainHwnd(), UM_UPDATERENDERBMP, (WPARAM)aZFile->GetBitmap(), (LPARAM)aZFile->IsMatPreview() );

		if ( aZFile->GetRenHwnd() != NULL )
		{
			BITMAP bm;
			HBITMAP hbmp = aZFile->GetBitmap();
			HDC hdc = GetDC( aZFile->GetRenHwnd() );
			HDC hdcMem = CreateCompatibleDC(hdc);
			HGDIOBJ hbmOld = SelectObject(hdcMem, hbmp);
			RECT rect;
			GetClientRect( aZFile->GetRenHwnd(), &rect );
		    
			int cropx = aZFile->GetCropX1();
			int cropy = aZFile->GetCropY1();
			GetObject( hbmp, sizeof(bm), &bm );
			//BitBlt( hdc, i_xmin+cropx, i_ymin+cropy, i_xmax_plusone - i_xmin, i_ymax_plusone - i_ymin, hdcMem, i_xmin, i_ymin, SRCCOPY );

			if ( ( aZFile->GetWindowWidth() == aZFile->GetWidth() ) && ( aZFile->GetWindowHeight() == aZFile->GetHeight() ) )
			{
				BitBlt( hdc, 0, 0, aZFile->GetWindowWidth(), aZFile->GetWindowHeight(), hdcMem, 0, 0, SRCCOPY );
			}
			else
			{
				// TODO - properly center smaller images
				if ( ( aZFile->GetWindowWidth() > aZFile->GetWidth() ) && ( aZFile->GetWindowHeight() > aZFile->GetHeight() ) )
					BitBlt( hdc, (aZFile->GetWindowWidth() / 2) - (aZFile->GetWidth() / 2), (aZFile->GetWindowHeight() / 2) - (aZFile->GetHeight() / 2), aZFile->GetWidth(), aZFile->GetHeight(),  hdcMem, 0, 0, SRCCOPY );
				else			
				{
					SetStretchBltMode( hdc, COLORONCOLOR );
					StretchBlt( hdc, 0, 0, aZFile->GetWindowWidth(), aZFile->GetWindowHeight(),  hdcMem, 0, 0, aZFile->GetWidth(), aZFile->GetHeight(), SRCCOPY );
				}
			}

			SelectObject(hdcMem, hbmOld);
			DeleteDC(hdcMem);
			ReleaseDC( aZFile->GetRenHwnd(), hdc );

			// this appears to cause a problem after a lot of refreshes
			//RECT rect;
			//GetClientRect( aZFile->GetRenHwnd(), &rect );
			//HRGN rgn = CreateRectRgn( rect.left, rect.top, rect.left, rect.right );
			//InvalidateRgn( aZFile->GetRenHwnd(), rgn, true );
		}
	}
	
	delete aZFile;
	return PkDspyErrorNone;
}

///////////////////////////////////////////////////////////////////////////////
