// MainDlg.cpp : implementation file
//

#include "stdafx.h"
#include "drbHair.h"
#include "MainDlg.h"
#include "colorbtn.h"
#include "wfmmshaders.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CString CaptionText = "drbHair";

/////////////////////////////////////////////////////////////////////////////
// CMainDlg dialog


CMainDlg::CMainDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMainDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMainDlg)
	//}}AFX_DATA_INIT
}


void CMainDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMainDlg)
	DDX_Control(pDX, IDC_SPECULARCOLOR, m_specularcolor);
	DDX_Control(pDX, IDC_KS, m_ks);
	DDX_Control(pDX, IDC_KD, m_kd);
	DDX_Control(pDX, IDC_KA, m_ka);
	DDX_Control(pDX, IDC_ROUGHNESS, m_roughness);
	DDX_Control(pDX, IDC_CLOSEBTN, m_CloseButton);
	DDX_Control(pDX, IDC_DENSITY, m_Density);
	DDX_Control(pDX, IDC_DENSITYVAR, m_DensityVariance);
	DDX_Control(pDX, IDC_LENGTH, m_Length);
	DDX_Control(pDX, IDC_LENGTHVAR, m_LengthVariance);
	DDX_Control(pDX, IDC_ROOTTHICKNESS, m_RootThickness);
	DDX_Control(pDX, IDC_TIPTHICKNESS, m_TipThickness);
	DDX_Control(pDX, IDC_THICKNESSVAR, m_ThicknessVariance);
	DDX_Control(pDX, IDC_ROOTCOLOR, m_RootColor);
	DDX_Control(pDX, IDC_TIPCOLOR, m_TipColor);
	DDX_Control(pDX, IDC_COLORVAR, m_ColorVariance);
	DDX_Control(pDX, IDC_STIFFNESS, m_Stiffness);
	DDX_Control(pDX, IDC_STIFFNESSVAR, m_StiffnessVariance);
	DDX_Control(pDX, IDC_CURL, m_Curl);
	DDX_Control(pDX, IDC_CURLVAR, m_CurlVariance);
	DDX_Control(pDX, IDC_KINK, m_Kink);
	DDX_Control(pDX, IDC_KINKVAR, m_KinkVariance);
	DDX_Control(pDX, IDC_RIBBON, m_Ribbon);
	DDX_Control(pDX, IDC_TIPFADE, m_TipFade);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMainDlg, CDialog)
	//{{AFX_MSG_MAP(CMainDlg)
	ON_WM_PAINT()
	ON_WM_NCHITTEST()
	ON_WM_CLOSE()
	ON_WM_SHOWWINDOW()
	ON_BN_CLICKED(IDC_CLOSEBTN, OnCloseBtn)
	ON_MESSAGE( WM_CHECKBOXCHANGED, OnCheckBoxChanged )
	ON_MESSAGE( WM_NUMBERSPINNERCHANGED, OnNumberSpinnerChanged )
	ON_MESSAGE( WM_COLORBUTTONCHANGED, OnColorButtonChanged )
	ON_MESSAGE( WM_TSEDITCHANGED, OnTSEditChanged )
	ON_MESSAGE( WM_TSBUTTONRIGHTCLICKED, OnTSButtonRightClicked )
	ON_MESSAGE( WM_CTLCOLORDLG, OnDlgBGColor )
	ON_MESSAGE( WM_CTLCOLORSTATIC, OnDlgBGColor )
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMainDlg message handlers


// this is called when the dialog needs to be destroyed
void CMainDlg::PostNcDestroy() 
{
	m_pMainDialog = NULL;
	delete this;
}

// this is called when the dialog is to be closed
void CMainDlg::OnClose() 
{
	this->DestroyWindow();
}

void CMainDlg::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here

	CRect myRect;
	GetClientRect(myRect);
	
	CPen myPen;

	// fill the background
	dc.FillSolidRect(myRect, RGB(192,192,192));

	// draw the caption bar
	CRect CaptionRect;
	CaptionRect.left = 0;
	CaptionRect.top = 1;
	CaptionRect.right = myRect.right-1;
	CaptionRect.bottom = 12;
	CFont CaptionFont;
	CaptionFont.CreateFont(-9,0,0,0,FW_NORMAL,FALSE,FALSE,
		0,ANSI_CHARSET,OUT_TT_PRECIS,
		CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,
		FF_SWISS,"Arial");
	CFont* oldfont = dc.SelectObject(&CaptionFont);
	dc.FillSolidRect(CaptionRect, GetSysColor(COLOR_ACTIVECAPTION));
	dc.SetTextColor(GetSysColor(COLOR_CAPTIONTEXT));
	dc.DrawText(CaptionText, -1, CaptionRect, DT_CENTER);
	dc.SelectObject(oldfont);
	CaptionFont.DeleteObject();

	
	
	// draw the black line
	myPen.CreatePen(PS_SOLID, 1, RGB(0,0,0));
	CPen* oldpen = dc.SelectObject(&myPen);
	dc.MoveTo(0, 12);
	dc.LineTo(myRect.right-1, 12);
	dc.SelectObject(oldpen);
	myPen.DeleteObject();

	// draw the outside border
	myPen.CreatePen(PS_SOLID, 1, RGB(255,255,255));
	oldpen = dc.SelectObject(&myPen);
	dc.MoveTo(0, myRect.bottom-1);
	dc.LineTo(0,0);
	dc.LineTo(myRect.right-1, 0);
	dc.SelectObject(oldpen);
	myPen.DeleteObject();
	myPen.CreatePen(PS_SOLID, 1, RGB(0,0,0));
	oldpen = dc.SelectObject(&myPen);
	dc.LineTo(myRect.right-1,myRect.bottom-1);
	dc.LineTo(0, myRect.bottom-1);
	dc.SelectObject(oldpen);
	myPen.DeleteObject();

}


// Override the hittest to allow dragging from anywhere on the dialog
LRESULT CMainDlg::OnNcHitTest(CPoint point) 
{
	return HTCAPTION;
}


// this is called when the dialog is to be closed
void CMainDlg::OnCloseBtn() 
{
	this->DestroyWindow();
}



BOOL CMainDlg::DestroyWindow() 
{
	CRect TheRect;
	GetWindowRect(TheRect);
	// write window position to the system registry
	AfxGetApp()->WriteProfileInt("MainPanel","PanelX", TheRect.left);
	AfxGetApp()->WriteProfileInt("MainPanel","PanelY", TheRect.top);

	return CDialog::DestroyWindow();
}


/////////////////////////////////////////////////////////////////////////////



// update the dialog controls with the parameter values
void CMainDlg::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);
	
	// set the control values if we're being shown
	if (bShow)
	{
		UpdateInterface();
	}
}

void CMainDlg::UpdateInterface()
{
	m_specularcolor.SettssColor(SpecularColor);
	
		
	m_ks.SetMin(0.0f);
	m_ks.SetMax(1.0f);
	m_ks.Step = 0.01f;
	m_ks.SetPosition(Ks);
	
	m_kd.SetMin(0.0f);
	m_kd.SetMax(1.0f);
	m_kd.Step = 0.01f;
	m_kd.SetPosition(Kd);
	
	m_ka.SetMin(0.0f);
	m_ka.SetMax(1.0f);
	m_ka.Step = 0.01f;
	m_ka.SetPosition(Ka);
	
	m_roughness.SetMin(0.0f);
	m_roughness.SetMax(1.0f);
	m_roughness.Step = 0.01f;
	m_roughness.SetPosition(roughness);

	m_Density.SetMin(0.0f);
	m_Density.SetMax(1024.0f);
	m_Density.Step = 1.0f;
	m_Density.SetPosition(Density);
	m_Density.SetEditWidth( 40 );
	
	m_DensityVariance.SetMin(0.0f);
	m_DensityVariance.SetMax(100.0f);
	m_DensityVariance.Step = 0.1f;
	m_DensityVariance.SetPosition(DensityVariance);
	
	m_Length.SetMin(0.0f);
	m_Length.SetMax(1024.0f);
	m_Length.Step = 0.01f;
	m_Length.SetPosition(Length);
	
	m_LengthVariance.SetMin(0.0f);
	m_LengthVariance.SetMax(100.0f);
	m_LengthVariance.Step = 0.1f;
	m_LengthVariance.SetPosition(LengthVariance);

	m_RootThickness.SetMin(0.0f);
	m_RootThickness.SetMax(1024.0f);
	m_RootThickness.Step = 0.001f;
	m_RootThickness.SetPosition(RootThickness);
	m_RootThickness.SetEditWidth( 40 );

	m_TipThickness.SetMin(0.0f);
	m_TipThickness.SetMax(1024.0f);
	m_TipThickness.Step = 0.001f;
	m_TipThickness.SetPosition(TipThickness);
	m_TipThickness.SetEditWidth( 40 );
	
	m_ThicknessVariance.SetMin(0.0f);
	m_ThicknessVariance.SetMax(100.0f);
	m_ThicknessVariance.Step = 0.1f;
	m_ThicknessVariance.SetPosition(ThicknessVariance);
	
	m_RootColor.SettssColor(RootColor);
	m_TipColor.SettssColor(TipColor);
	
	m_ColorVariance.SetMin(0.0f);
	m_ColorVariance.SetMax(100.0f);
	m_ColorVariance.Step = 0.1f;
	m_ColorVariance.SetPosition(ColorVariance);

	m_Stiffness.SetMin(0.0f);
	m_Stiffness.SetMax(100.0f);
	m_Stiffness.Step = 1.0f;
	m_Stiffness.SetPosition(Stiffness);
	
	m_StiffnessVariance.SetMin(0.0f);
	m_StiffnessVariance.SetMax(100.0f);
	m_StiffnessVariance.Step = 1.0f;
	m_StiffnessVariance.SetPosition(StiffnessVariance);

	m_Curl.SetMin(0.0f);
	m_Curl.SetMax(100.0f);
	m_Curl.Step = 0.1f;
	m_Curl.SetPosition(Curl);
	
	m_CurlVariance.SetMin(0.0f);
	m_CurlVariance.SetMax(100.0f);
	m_CurlVariance.Step = 0.1f;
	m_CurlVariance.SetPosition(CurlVariance);

	m_Kink.SetMin(0.0f);
	m_Kink.SetMax(100.0f);
	m_Kink.Step = 1.0f;
	m_Kink.SetPosition(Kink);
	
	m_KinkVariance.SetMin(0.0f);
	m_KinkVariance.SetMax(100.0f);
	m_KinkVariance.Step = 1.0f;
	m_KinkVariance.SetPosition(KinkVariance);

	m_Ribbon.SetChecked( m_Ribbon );	

	m_TipFade.SetMin(0.0f);
	m_TipFade.SetMax(1.0);
	m_TipFade.Step = 0.001f;
	m_TipFade.SetPosition(TipFade);
	m_TipFade.SetEditWidth( 40 );

}

// Called when the value of a spinner is changed
LRESULT CMainDlg::OnNumberSpinnerChanged(WPARAM wParam, LPARAM lParam)
{
	
	Ks = m_ks.Position;
	
	Kd = m_kd.Position;
	
	Ka = m_ka.Position;

	roughness = m_roughness.Position;

	Density = m_Density.Position;
	
	DensityVariance = m_DensityVariance.Position;

	Length = m_Length.Position;
	
	LengthVariance = m_LengthVariance.Position;
	
	RootThickness = m_RootThickness.Position;

	TipThickness = m_TipThickness.Position;

	ThicknessVariance = m_ThicknessVariance.Position;

	ColorVariance = m_ColorVariance.Position;

	Stiffness = m_Stiffness.Position;

	StiffnessVariance = m_StiffnessVariance.Position;

	Curl = m_Curl.Position;
	
	CurlVariance = m_CurlVariance.Position;

	Kink = m_Kink.Position;

	KinkVariance = m_KinkVariance.Position;

	TipFade = m_TipFade.Position;

	UpdateShader();
	return 0L;
}

// Called when the value of a spinner is changed
LRESULT CMainDlg::OnColorButtonChanged(WPARAM wParam, LPARAM lParam)
{
	if (wParam == m_specularcolor.GetDlgCtrlID() )
		m_specularcolor.GettssColor(SpecularColor);

	if (wParam == m_RootColor.GetDlgCtrlID() )
		m_RootColor.GettssColor(RootColor);

	if (wParam == m_TipColor.GetDlgCtrlID() )
		m_TipColor.GettssColor(TipColor);



	UpdateShader();
	return 0L;
}

// Called when the value of an editbox is changed
LRESULT CMainDlg::OnTSEditChanged(WPARAM wParam, LPARAM lParam)
{

	UpdateShader();
	return 0L;
}

// Called when the value of a checkbox is changed
LRESULT CMainDlg::OnCheckBoxChanged(WPARAM wParam, LPARAM lParam)
{
	// We know that *one* of the controls triggered this message,
	// let's see if it's the one we want
	Ribbon = m_Ribbon.Checked;

	UpdateShader();

	return 0L;
}


LRESULT CMainDlg::OnTSButtonRightClicked(WPARAM wParam, LPARAM lParam)
{
	UpdateShader();

	return 0L;
}



BOOL CMainDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	//retrieve the window size and position settings from the system registry
	int iHoriz = AfxGetApp()->GetProfileInt("MainPanel","PanelX",170);
	int iVert = AfxGetApp()->GetProfileInt("MainPanel","PanelY",50);


	// if this is the first run, write the key to auto update numberspinners
	// on focus change
	if (AfxGetApp()->GetProfileInt("Spinners","UpdateOnFocus",-1) == -1)
		AfxGetApp()->WriteProfileInt("Spinners","UpdateOnFocus", 1);
		
	// adjust the window position
	SetWindowPos(NULL,iHoriz,iVert,120,380, 0); // notice that the height is set to hide the disabled controls

	m_CloseButton.m_hUpBitmap = LoadBitmap(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDB_CLOSE));
	m_CloseButton.m_hDownBitmap = LoadBitmap(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDB_DOCLOSE));
	m_CloseButton.DrawBorders = FALSE;


	CRect myRect;
	GetClientRect(myRect);
	m_CloseButton.MoveWindow(myRect.right-12, 1, 11, 11, TRUE);

	Rolled = FALSE;

	

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}




void CMainDlg::UpdateShader(bool forcesample)
{
	//tsxSHADER* pShd = tsxShaderGetActive(tsxSHCLASS_REFLECTANCE);
	tsxShaderUpdate(ReflectanceShaderID);

	/*tsxMATERIAL* pMat;
	tsxMaterialCreateCopyActive(&pMat);

	tsxSHINFO* pShinfo = tsxMaterialGetShaderInfo(pMat, tsxSHCLASS_REFLECTANCE);

	tsxShaderInfoFreeCustomData(pShinfo);

	char* data=tsxShaderInfoAllocCustomData(pShinfo, m_shadertext.String.GetLength());
	
	strcpy(data, m_shadertext.String);

	tsxShaderUpdate(ReflectanceShaderID);*/

	//if ( (m_dorendersample.Checked) || (forcesample) )
	//	RenderMaterialSample();
}


LRESULT CMainDlg::OnDlgBGColor( WPARAM wParam, LPARAM lParam )
{
	HDC hdcStatic = (HDC)wParam;
    SetTextColor(hdcStatic, RGB(0, 0, 0));
    SetBkMode(hdcStatic, TRANSPARENT);
	return (LONG)theApp.g_hbrBackground;
}
