// ColorBtn.cpp : implementation file
//

#include "stdafx.h"
#include "drbSimpleFur.h"
#include "ColorBtn.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CColorBtn

CColorBtn::CColorBtn()
{
	m_color = RGB(255,255,255);
}

CColorBtn::~CColorBtn()
{
}


BEGIN_MESSAGE_MAP(CColorBtn, CButton)
	//{{AFX_MSG_MAP(CColorBtn)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CColorBtn message handlers

void CColorBtn::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct) 
{
	CDC* pDC = CDC::FromHandle(lpDrawItemStruct->hDC);
	
	CBrush brush(GetColor());
	CBrush* pbrushOld = pDC->SelectObject(&brush);
	CPen* ppenOld = (CPen*)pDC->SelectStockObject(NULL_PEN);
	
	pDC->Rectangle(&(lpDrawItemStruct->rcItem));

	pDC->SelectObject(pbrushOld);
	pDC->SelectObject(ppenOld);
}

void CColorBtn::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// Get the control rectangle
	CRect MyRect;
	this->GetWindowRect(&MyRect);

	// Let's convert the dialog point coords to screen coords
	POINT TranPoint;
	TranPoint.x = point.x;
	TranPoint.y = point.y;
	ClientToScreen(&TranPoint);

	if (MyRect.PtInRect(TranPoint))
	{
		SetCapture();
	}
	
	CButton::OnLButtonDown(nFlags, point);
}

void CColorBtn::OnLButtonUp(UINT nFlags, CPoint point) 
{
	if (GetCapture() == this)
	{
		ReleaseCapture();
		
		CColorDialog dlg(GetColor(), 0, this);
		dlg.DoModal();
		SetColor(dlg.GetColor());
	}
	
	CButton::OnLButtonUp(nFlags, point);
}


COLORREF CColorBtn::GetColor()
{
	return m_color;
}

void CColorBtn::SetColor(COLORREF NewCol)
{
	if (m_color != NewCol)
	{
		m_color = NewCol;
		RedrawWindow();
	}
}

void CColorBtn::PreSubclassWindow() 
{
	ModifyStyle(0, BS_OWNERDRAW);
	CButton::PreSubclassWindow();		
}

