// drbSimpleFur.h : main header file for the drbSimpleFur DLL
//

#if !defined(AFX_BLANKTSX_H__169FC6F1_143C_4AE1_823D_A606A7766DC7__INCLUDED_)
#define AFX_BLANKTSX_H__169FC6F1_143C_4AE1_823D_A606A7766DC7__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"		// main symbols

// include the tSX headers
#include "tsx.h"

// we will use this pointer to keep track of the dialog interface
#include "MainDlg.h"
extern CMainDlg* m_pMainDialog;

// declaration of our shader functions
void OnShowInterface(tssISTATE);
void* GetParameterValue(char*);
void SetParameterValue(char*, void*);
void Execute(tsxSHINFO*, tssSurface*, tssACTION);
void OnSave(tsxSHINFO* pShinfo, tssFILE_DESC* pDesc);
void OnLoad(tsxSHINFO* pShinfo, tssFILE_DESC* pDesc);
long OnCompare(long v1, void* p1, long v2, void* p2);

extern int ReflectanceShaderID;
extern int DisplacementShaderID;

#define MAXPARAMLENGTH 255
// our shader parameters
extern char ShaderText[4096];

extern float Ka;
extern float Kd;
extern float Ks;
extern float roughness;
extern tssColor SpecularColor;
extern float Density;
extern float DensityVariance;
extern float Length;
extern float LengthVariance;
extern float RootThickness;
extern float TipThickness;
extern float ThicknessVariance;
extern tssColor RootColor;
extern tssColor TipColor;
extern float ColorVariance;
extern float Stiffness;
extern float StiffnessVariance;
extern float Curl;
extern float CurlVariance;
extern float Kink;
extern float KinkVariance;
extern bool Ribbon;
extern float TipFade;


/////////////////////////////////////////////////////////////////////////////
// CdrbSimpleFurApp
// See drbSimpleFur.cpp for the implementation of this class
//

class CdrbSimpleFurApp : public CWinApp
{
public:
	CdrbSimpleFurApp();
	
	bool RenderingSample;
	HBRUSH g_hbrBackground;

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CdrbSimpleFurApp)
	public:
	virtual BOOL InitInstance();
	//}}AFX_VIRTUAL

	//{{AFX_MSG(CdrbSimpleFurApp)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

extern CdrbSimpleFurApp theApp;

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_BLANKTSX_H__169FC6F1_143C_4AE1_823D_A606A7766DC7__INCLUDED_)
