// MainDlg.cpp : implementation file
//

#include "stdafx.h"
#include "blankshader.h"
#include "MainDlg.h"
#include "colorbtn.h"
#include "wfmmshaders.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CString CaptionText = "drbSimpleSSS";

/////////////////////////////////////////////////////////////////////////////
// CMainDlg dialog


CMainDlg::CMainDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMainDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMainDlg)
	//}}AFX_DATA_INIT
}


void CMainDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMainDlg)
	DDX_Control(pDX, IDC_SPECULARCOLOR, m_specularcolor);
	DDX_Control(pDX, IDC_KS, m_ks);
	DDX_Control(pDX, IDC_KR, m_kr);
	DDX_Control(pDX, IDC_KD, m_kd);
	DDX_Control(pDX, IDC_KA, m_ka);
	DDX_Control(pDX, IDC_IOR, m_ior);
	DDX_Control(pDX, IDC_ROUGHNESS, m_roughness);
	DDX_Control(pDX, IDC_SHADINGRATE, m_shadingrate);
	DDX_Control(pDX, IDC_SCALE, m_scale);
	DDX_Control(pDX, IDC_SCATTERING_RED, m_scattering_red);
	DDX_Control(pDX, IDC_SCATTERING_GREEN, m_scattering_green);
	DDX_Control(pDX, IDC_SCATTERING_BLUE, m_scattering_blue);
	DDX_Control(pDX, IDC_ABSORPTION_RED, m_absorption_red);
	DDX_Control(pDX, IDC_ABSORPTION_GREEN, m_absorption_green);
	DDX_Control(pDX, IDC_ABSORPTION_BLUE, m_absorption_blue);
	DDX_Control(pDX, IDC_CLOSEBTN, m_CloseButton);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMainDlg, CDialog)
	//{{AFX_MSG_MAP(CMainDlg)
	ON_WM_PAINT()
	ON_WM_NCHITTEST()
	ON_WM_CLOSE()
	ON_WM_SHOWWINDOW()
	ON_BN_CLICKED(IDC_CLOSEBTN, OnCloseBtn)
	ON_MESSAGE( WM_CHECKBOXCHANGED, OnCheckBoxChanged )
	ON_MESSAGE( WM_NUMBERSPINNERCHANGED, OnNumberSpinnerChanged )
	ON_MESSAGE( WM_COLORBUTTONCHANGED, OnColorButtonChanged )
	ON_MESSAGE( WM_TSEDITCHANGED, OnTSEditChanged )
	ON_MESSAGE( WM_TSBUTTONRIGHTCLICKED, OnTSButtonRightClicked )
	ON_MESSAGE( WM_CTLCOLORDLG, OnDlgBGColor )
	ON_MESSAGE( WM_CTLCOLORSTATIC, OnDlgBGColor )
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMainDlg message handlers


// this is called when the dialog needs to be destroyed
void CMainDlg::PostNcDestroy() 
{
	m_pMainDialog = NULL;
	delete this;
}

// this is called when the dialog is to be closed
void CMainDlg::OnClose() 
{
	this->DestroyWindow();
}

void CMainDlg::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here

	CRect myRect;
	GetClientRect(myRect);
	
	CPen myPen;

	// fill the background
	dc.FillSolidRect(myRect, RGB(192,192,192));

	// draw the caption bar
	CRect CaptionRect;
	CaptionRect.left = 0;
	CaptionRect.top = 1;
	CaptionRect.right = myRect.right-1;
	CaptionRect.bottom = 12;
	CFont CaptionFont;
	CaptionFont.CreateFont(-9,0,0,0,FW_NORMAL,FALSE,FALSE,
		0,ANSI_CHARSET,OUT_TT_PRECIS,
		CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,
		FF_SWISS,"Arial");
	CFont* oldfont = dc.SelectObject(&CaptionFont);
	dc.FillSolidRect(CaptionRect, GetSysColor(COLOR_ACTIVECAPTION));
	dc.SetTextColor(GetSysColor(COLOR_CAPTIONTEXT));
	dc.DrawText(CaptionText, -1, CaptionRect, DT_CENTER);
	dc.SelectObject(oldfont);
	CaptionFont.DeleteObject();

	
	
	// draw the black line
	myPen.CreatePen(PS_SOLID, 1, RGB(0,0,0));
	CPen* oldpen = dc.SelectObject(&myPen);
	dc.MoveTo(0, 12);
	dc.LineTo(myRect.right-1, 12);
	dc.SelectObject(oldpen);
	myPen.DeleteObject();

	// draw the outside border
	myPen.CreatePen(PS_SOLID, 1, RGB(255,255,255));
	oldpen = dc.SelectObject(&myPen);
	dc.MoveTo(0, myRect.bottom-1);
	dc.LineTo(0,0);
	dc.LineTo(myRect.right-1, 0);
	dc.SelectObject(oldpen);
	myPen.DeleteObject();
	myPen.CreatePen(PS_SOLID, 1, RGB(0,0,0));
	oldpen = dc.SelectObject(&myPen);
	dc.LineTo(myRect.right-1,myRect.bottom-1);
	dc.LineTo(0, myRect.bottom-1);
	dc.SelectObject(oldpen);
	myPen.DeleteObject();

}


// Override the hittest to allow dragging from anywhere on the dialog
LRESULT CMainDlg::OnNcHitTest(CPoint point) 
{
	return HTCAPTION;
}


// this is called when the dialog is to be closed
void CMainDlg::OnCloseBtn() 
{
	this->DestroyWindow();
}



BOOL CMainDlg::DestroyWindow() 
{
	CRect TheRect;
	GetWindowRect(TheRect);
	// write window position to the system registry
	AfxGetApp()->WriteProfileInt("MainPanel","PanelX", TheRect.left);
	AfxGetApp()->WriteProfileInt("MainPanel","PanelY", TheRect.top);

	return CDialog::DestroyWindow();
}


/////////////////////////////////////////////////////////////////////////////



// update the dialog controls with the parameter values
void CMainDlg::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);
	
	// set the control values if we're being shown
	if (bShow)
	{
		UpdateInterface();
	}
}

void CMainDlg::UpdateInterface()
{
	m_specularcolor.SettssColor(SpecularColor);
	
		
	m_ks.SetMin(0.0f);
	m_ks.SetMax(1.0f);
	m_ks.Step = 0.01f;
	m_ks.SetPosition(Ks);
	
	m_kr.SetMin(0.0f);
	m_kr.SetMax(1.0f);
	m_kr.Step = 0.01f;
	m_kr.SetPosition(Kr);

	m_kd.SetMin(0.0f);
	m_kd.SetMax(1.0f);
	m_kd.Step = 0.01f;
	m_kd.SetPosition(Kd);
	
	m_ka.SetMin(0.0f);
	m_ka.SetMax(1.0f);
	m_ka.Step = 0.01f;
	m_ka.SetPosition(Ka);
	
	m_ior.SetMin(1.0f);
	m_ior.SetMax(10.0f);
	m_ior.Step = 0.01f;
	m_ior.SetPosition(ior);

	m_roughness.SetMin(0.0f);
	m_roughness.SetMax(1.0f);
	m_roughness.Step = 0.01f;
	m_roughness.SetPosition(roughness);

	m_shadingrate.SetMin(0.0f);
	m_shadingrate.SetMax(1024.0f);
	m_shadingrate.Step = 0.01f;
	m_shadingrate.SetPosition(shadingrate);

	m_scale.SetMin(0.0f);
	m_scale.SetMax(1000.0f);
	m_scale.Step = 0.01f;
	m_scale.SetPosition(scale);

	m_scattering_red.SetMin(0.0f);
	m_scattering_red.SetMax(32.0f);
	m_scattering_red.Step = 0.0001f;
	m_scattering_red.SetPosition(scattering[0]);
	m_scattering_red.SetEditWidth( 50 );

	m_scattering_green.SetMin(0.0f);
	m_scattering_green.SetMax(32.0f);
	m_scattering_green.Step = 0.0001f;
	m_scattering_green.SetPosition(scattering[1]);
	m_scattering_green.SetEditWidth( 50 );

	m_scattering_blue.SetMin(0.0f);
	m_scattering_blue.SetMax(32.0f);
	m_scattering_blue.Step = 0.0001f;
	m_scattering_blue.SetPosition(scattering[2]);
	m_scattering_blue.SetEditWidth( 50 );

	m_absorption_red.SetMin(0.0f);
	m_absorption_red.SetMax(32.0f);
	m_absorption_red.Step = 0.0001f;
	m_absorption_red.SetPosition(absorption[0]);
	m_absorption_red.SetEditWidth( 50 );

	m_absorption_green.SetMin(0.0f);
	m_absorption_green.SetMax(32.0f);
	m_absorption_green.Step = 0.0001f;
	m_absorption_green.SetPosition(absorption[1]);
	m_absorption_green.SetEditWidth( 50 );

	m_absorption_blue.SetMin(0.0f);
	m_absorption_blue.SetMax(32.0f);
	m_absorption_blue.Step = 0.0001f;
	m_absorption_blue.SetPosition(absorption[2]);
	m_absorption_blue.SetEditWidth( 50 );

}

// Called when the value of a spinner is changed
LRESULT CMainDlg::OnNumberSpinnerChanged(WPARAM wParam, LPARAM lParam)
{
	
	Ks = m_ks.Position;
	
	Kr = m_kr.Position;

	Kd = m_kd.Position;
	
	Ka = m_ka.Position;

	ior = m_ior.Position;

	roughness = m_roughness.Position;

	shadingrate = m_shadingrate.Position;

	scale = m_scale.Position;

	scattering[0] = m_scattering_red.Position;
	scattering[1] = m_scattering_green.Position;
	scattering[2] = m_scattering_blue.Position;

	absorption[0] = m_absorption_red.Position;
	absorption[1] = m_absorption_green.Position;
	absorption[2] = m_absorption_blue.Position;

	UpdateShader();
	return 0L;
}

// Called when the value of a spinner is changed
LRESULT CMainDlg::OnColorButtonChanged(WPARAM wParam, LPARAM lParam)
{
	if (wParam == m_specularcolor.GetDlgCtrlID() )
		m_specularcolor.GettssColor(SpecularColor);

	UpdateShader();
	return 0L;
}

// Called when the value of an editbox is changed
LRESULT CMainDlg::OnTSEditChanged(WPARAM wParam, LPARAM lParam)
{

	UpdateShader();
	return 0L;
}

// Called when the value of a checkbox is changed
LRESULT CMainDlg::OnCheckBoxChanged(WPARAM wParam, LPARAM lParam)
{
	// We know that *one* of the controls triggered this message,
	// let's see if it's the one we want
	
	UpdateShader();

	return 0L;
}


LRESULT CMainDlg::OnTSButtonRightClicked(WPARAM wParam, LPARAM lParam)
{
	UpdateShader();

	return 0L;
}



BOOL CMainDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	//retrieve the window size and position settings from the system registry
	int iHoriz = AfxGetApp()->GetProfileInt("MainPanel","PanelX",170);
	int iVert = AfxGetApp()->GetProfileInt("MainPanel","PanelY",50);


	// if this is the first run, write the key to auto update numberspinners
	// on focus change
	if (AfxGetApp()->GetProfileInt("Spinners","UpdateOnFocus",-1) == -1)
		AfxGetApp()->WriteProfileInt("Spinners","UpdateOnFocus", 1);
		
	// adjust the window position
	SetWindowPos(NULL,iHoriz,iVert,NULL,NULL, SWP_NOSIZE);

	m_CloseButton.m_hUpBitmap = LoadBitmap(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDB_CLOSE));
	m_CloseButton.m_hDownBitmap = LoadBitmap(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDB_DOCLOSE));
	m_CloseButton.DrawBorders = FALSE;


	CRect myRect;
	GetClientRect(myRect);
	m_CloseButton.MoveWindow(myRect.right-12, 1, 11, 11, TRUE);

	Rolled = FALSE;

	

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}




void CMainDlg::UpdateShader(bool forcesample)
{
	//tsxSHADER* pShd = tsxShaderGetActive(tsxSHCLASS_REFLECTANCE);
	tsxShaderUpdate(ReflectanceShaderID);

	/*tsxMATERIAL* pMat;
	tsxMaterialCreateCopyActive(&pMat);

	tsxSHINFO* pShinfo = tsxMaterialGetShaderInfo(pMat, tsxSHCLASS_REFLECTANCE);

	tsxShaderInfoFreeCustomData(pShinfo);

	char* data=tsxShaderInfoAllocCustomData(pShinfo, m_shadertext.String.GetLength());
	
	strcpy(data, m_shadertext.String);

	tsxShaderUpdate(ReflectanceShaderID);*/

	//if ( (m_dorendersample.Checked) || (forcesample) )
	//	RenderMaterialSample();
}


LRESULT CMainDlg::OnDlgBGColor( WPARAM wParam, LPARAM lParam )
{
	HDC hdcStatic = (HDC)wParam;
    SetTextColor(hdcStatic, RGB(0, 0, 0));
    SetBkMode(hdcStatic, TRANSPARENT);
	return (LONG)theApp.g_hbrBackground;
}
