// blankshader.cpp : Defines the initialization routines for the DLL.
//

// TODO:
// Delete the sample tga on shader unload
// This should make sure it will always render the material sample
// when switching between materials in a library for example


#include "stdafx.h"
#include "blankshader.h"
#include "wfmmshaders.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// include the dialog interface header
#include "MainDlg.h"
CMainDlg* m_pMainDialog;

// now the shader parameters
#define NumParams 11

int ReflectanceShaderID;

char Name[] = "drbSimpleSSS";
char* Params[NumParams] = { 
	"Ka",
	"Kd",
	"Ks",
	"roughness",
	"SpecularColor",
	"Kr",
	"ior",
	"scattering",
	"absorption",
	"shadingrate",
	"scale"
};


tsxSHPARAM_TYPE Types[NumParams] = { 
	tsxSHPARAM_FLOAT,
	tsxSHPARAM_FLOAT,
	tsxSHPARAM_FLOAT,
	tsxSHPARAM_FLOAT,
	tsxSHPARAM_COLOR,
	tsxSHPARAM_FLOAT,
	tsxSHPARAM_FLOAT,
	tsxSHPARAM_COLOR,
	tsxSHPARAM_COLOR,
	tsxSHPARAM_FLOAT,
	tsxSHPARAM_FLOAT
};


float Ka = 0.0f;
float Kd = 1.0f;
float Ks = 0.5f;
float roughness = 0.9f;
tssColor SpecularColor = { 1, 1, 1 };
float Kr = 0.0f;
float ior = 1.5f;
tssColor scattering = { 2.19f, 2.62f, 3.00f };
tssColor absorption = { 0.0021f, 0.0041f, 0.0071f };
float shadingrate = 1.0f;
float scale = 0.01f;

// these will help us cache our shader settings to speed up execution
tsxSHINFO *oldreflinfo;

/////////////////////////////////////////////////////////////////////////////
// CBlankshaderApp

BEGIN_MESSAGE_MAP(CBlankshaderApp, CWinApp)
	//{{AFX_MSG_MAP(CBlankshaderApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBlankshaderApp construction

CBlankshaderApp::CBlankshaderApp()
{
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CBlankshaderApp object

CBlankshaderApp theApp;


// this is where we setup our shader - it is the only function exported in the
// shader DLL
void tsxShaderInitialize(tssData* data, int ID)
{
	// call this function at the start of any exported function
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	ReflectanceShaderID = ID;	// Store for later use
	tssCustomShaderSetBitmapID(ID, IDB_REFICON);
	data->nClass = tsxSHCLASS_REFLECTANCE;
	
	data->sName = Name;
	data->nDispNameID = IDS_NAME;
	data->nHelpID = IDS_HELP;
	data->nNumParam = NumParams;
	data->pParamName = Params;
	data->pParamType = Types;

	data->pfnShowInterface = OnShowInterface;
	data->pfnGetParameterValue = GetParameterValue;
	data->pfnSetParameterValue = SetParameterValue;
	data->pfnExecute = Execute;
	/*data->pfnSave = OnSave;
	data->pfnLoad = OnLoad;
	data->pfnCompare = OnCompare;*/

	
}

/*
void OnSave(tsxSHINFO* pShinfo, tssFILE_DESC* pDesc)
{
	tsxSHADER* pShd = tsxShaderInfoGetShader(pShinfo);

	long size;
	char* data = tsxShaderGetCustomData(pShd,&size);
	if (size > 0)
	{
		tsxFILEprintf((tsxFILE*)pDesc->file,"Declarations %s\n", data);
	}

	return;
}

void OnLoad(tsxSHINFO* pShinfo, tssFILE_DESC* pDesc)
{
	char tempbuf[1024];

	tsxSHADER* pShd = tsxShaderInfoGetShader(pShinfo);

	tsxShaderFreeCustomData(pShd);

	char* data=tsxShaderAllocCustomData(pShd, 4096);
	
	if (data)
	{
		tsxFILEscanf((tsxFILE*)pDesc->file,"%s %s\n", tempbuf, data);
	}


	return;
}

long OnCompare(long v1, void* p1, long v2, void* p2)
{
	if (p1)
	{
		if (strcmp((char*)p1,(char*)p2) == 0)
			return 1;

		return 0;
	}
	
	return 1;
}
*/


// this is where we respond to interface messages trueSpace sends
void OnShowInterface(tssISTATE state)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	switch (state)
	{
		case tssISTATE_STAY:
		{
			TRACE("*** Stay\n");
		}
		break;
		case tssISTATE_SHOW:
		{
			TRACE("*** Show\n");
			if(m_pMainDialog == NULL)
			{
				m_pMainDialog = new CMainDlg();
				m_pMainDialog->Create(IDD_MAINDLG);
			}		

			m_pMainDialog->ShowWindow(SW_SHOW);

		}
		break;
		case tssISTATE_HIDE:
		{
			TRACE("*** Hide\n");
			if(m_pMainDialog != NULL)
				m_pMainDialog->DestroyWindow();
		}
		break;
		case tssISTATE_DESTROY:
		{
			TRACE("*** Destroy\n");
			if(m_pMainDialog != NULL)
				m_pMainDialog->DestroyWindow();

		}
		break;
		case tssISTATE_UPDATE:
		{
			TRACE("*** Update\n");
			if (m_pMainDialog != NULL)
				m_pMainDialog->UpdateInterface();
		}
		break;
		
	}

}

// in this function we look to see what parameter is being requested by name,
// then return the correct parameter value
void* GetParameterValue(char* name)
{
	if (strcmp("Ka", name) == 0)
	{
		return (void*)(&Ka);
	}
	
	if (strcmp("Kd", name) == 0)
	{
		return (void*)(&Kd);
	}

	if (strcmp("Ks", name) == 0)
	{
		return (void*)(&Ks);
	}
	
	if (strcmp("SpecularColor", name) == 0)
	{
		return (void*)(&SpecularColor);
	}
		
	if (strcmp("Kr", name) == 0)
	{
		return (void*)(&Kr);
	}
		
	if (strcmp("ior", name) == 0)
	{
		return (void*)(&ior);
	}

	if (strcmp("roughness", name) == 0)
	{
		return (void*)(&roughness);
	}

	if (strcmp("shadingrate", name) == 0)
	{
		return (void*)(&shadingrate);
	}

	if (strcmp("scale", name) == 0)
	{
		return (void*)(&scale);
	}

	if (strcmp("scattering", name) == 0)
	{
		return (void*)(&scattering);
	}

	if (strcmp("absorption", name) == 0)
	{
		return (void*)(&absorption);
	}
	

	return NULL;
}

// in this function, we have to set the correct value for a parameter being
// passed by name
void SetParameterValue(char* name, void* value)
{
	// if we are being called without a valid value, exit
	if (!value)
		return;

	if (strcmp("Ka", name) == 0)
	{
		Ka = *((float*)value);
		return;
	}
	
	
	if (strcmp("Kd", name) == 0)
	{
		Kd = *((float*)value);
		return;
	}
	
	if (strcmp("Ks", name) == 0)
	{
		Ks = *((float*)value);
		return;
	}
	
	if (strcmp("SpecularColor", name) == 0)
	{
		tssColor* pColor = (tssColor*)value;
		SpecularColor[0] = (*pColor)[0];
		SpecularColor[1] = (*pColor)[1];
		SpecularColor[2] = (*pColor)[2];
		return;
	}
	
	if (strcmp("Kr", name) == 0)
	{
		Kr = *((float*)value);
		return;
	}
	
	if (strcmp("ior", name) == 0)
	{
		ior = *((float*)value);
		return;
	}

	if (strcmp("roughness", name) == 0)
	{
		roughness = *((float*)value);
		return;
	}

	if (strcmp("shadingrate", name) == 0)
	{
		shadingrate = *((float*)value);
		return;
	}

	if (strcmp("scale", name) == 0)
	{
		scale = *((float*)value);
		return;
	}

	if (strcmp("scattering", name) == 0)
	{
		tssColor* pColor = (tssColor*)value;
		scattering[0] = (*pColor)[0];
		scattering[1] = (*pColor)[1];
		scattering[2] = (*pColor)[2];
		return;
	}

	if (strcmp("absorption", name) == 0)
	{
		tssColor* pColor = (tssColor*)value;
		absorption[0] = (*pColor)[0];
		absorption[1] = (*pColor)[1];
		absorption[2] = (*pColor)[2];
		return;
	}
	
}


// this is our main function, that manages parameters and calculates the shader code
void Execute(tsxSHINFO* shinfo, tssSurface* surface, tssACTION action)
{
	// look to see what action is being requested
	switch(action)
	{
		// called when the shader is being loaded by trueSpace
		case tssACTION_LOAD:
			TRACE("Shader being loaded (%s)\n", Name);
			break;
		
		// destroy the sample image and delete the image file
		case tssACTION_UNLOAD:
			TRACE("Shader being unloaded (%s)\n", Name);
			break;

		// called once before rendering
		case tssACTION_INIT:
		{
			TRACE("Shader being initialized (%s)\n", Name);
		}
		break;

		// this is the meat, executed for every shading point
		case tssACTION_PREVIEW:
		case tssACTION_FULL:
		{
			// look to see if we need to pass new parameters
			bool Cached = FALSE;
			if (shinfo == oldreflinfo)
				Cached = TRUE;

			// if we do need to get new parameters, this is how we do so
			// this is a generic loop that can work for other shaders
			// regardless of parameter type
			if( ((shinfo != NULL) && (Cached == FALSE))  )
			{
				
				for(int i = 0; i < NumParams; i++)
				{
					char name[32];
					tsxShaderInfoGetParameterName(shinfo, i, name);
					tsxSHPARAMVAL* pVal = tsxShaderInfoGetParameterValue(shinfo, i);
					
					tsxSHPARAM_TYPE thetype = tsxParameterValueGetType(pVal);
					
					
					switch(thetype)
					{
						case tsxSHPARAM_BOOL:
						{
							bool b;
							tsxParameterValueGetTypedValue(pVal, tsxSHPARAM_BOOL, (void*)&b);
							SetParameterValue(name, (void*)&b);
						}
						break;
						
						case tsxSHPARAM_FLOAT:
						{
							float f;
							tsxParameterValueGetTypedValue(pVal, tsxSHPARAM_FLOAT, (void*)&f);
							SetParameterValue(name, (void*)&f);
						}
						break;
						
						case tsxSHPARAM_SHORT:
						{
							short s;
							tsxParameterValueGetTypedValue(pVal, tsxSHPARAM_SHORT, (void*)&s);
							SetParameterValue(name, (void*)&s);
						}
						break;
						
						case tsxSHPARAM_STRING:
						{
							char* pC;
							tsxParameterValueGetTypedValue(pVal, tsxSHPARAM_STRING, (void*)&pC);
							SetParameterValue(name, (void*)pC);
						}
						break;

						case tsxSHPARAM_COLOR:
						{
							tssColor c;
							tsxParameterValueGetTypedValue(pVal, tsxSHPARAM_COLOR, (void*)&c);
							SetParameterValue(name, (void*)&c);
						}
						break;
					}


				}

				

			}


			// now save the shader info for caching
			oldreflinfo = shinfo;
			
			tssColor OutColor, DiffuseTerm, AmbientTerm, SpecularTerm, Reflect, Refract;
			tssColor Color;
			tssColorAssign( Color, surface->Co );
				
			tssDiffuseTerm(DiffuseTerm);
			tssAmbientTerm(AmbientTerm);
			tssPhongTerm(SpecularTerm, 1/(1-(0.5+(roughness*0.5))) );
			

			OutColor[0] = (Color[0] * (Ka * AmbientTerm[0] + Kd * DiffuseTerm[0]) +
				SpecularColor[0] * (Ks*SpecularTerm[0]));
			OutColor[1] = (Color[1] * (Ka * AmbientTerm[1] + Kd * DiffuseTerm[1]) +
				SpecularColor[1] * (Ks*SpecularTerm[1]));
			OutColor[2] = (Color[2] * (Ka * AmbientTerm[2] + Kd * DiffuseTerm[2]) +
				SpecularColor[2] * (Ks*SpecularTerm[2]));

			tssVector Rdir, Tdir;
			float RefFrac;

			if ( Kr > 0.0f )
				tssFresnelSolidReflect(&RefFrac, Rdir, Tdir, ior);
			
			if (Kr > 0.0f)
			{
				tssRayTrace(Reflect, surface->Pw, Rdir, Kr);
				tssColorIncrement(OutColor, Reflect);
			}
			
			// calculate the reflectance
			tssColorAssign(surface->Co, OutColor);

		}	
	}
}

BOOL CBlankshaderApp::InitInstance() 
{
	SetRegistryKey("cool powers");

	SetDialogBkColor( RGB(192, 192, 192), RGB(0, 0, 0) );
	g_hbrBackground = CreateSolidBrush(RGB(192, 192, 192));

	return CWinApp::InitInstance();
}
