// blankshader.cpp : Defines the initialization routines for the DLL.
//

// TODO:
// Delete the sample tga on shader unload
// This should make sure it will always render the material sample
// when switching between materials in a library for example


#include "stdafx.h"
#include "blankshader.h"
#include "wfmmshaders.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// include the dialog interface header
#include "MainDlg.h"
CMainDlg* m_pMainDialog;

// now the shader parameters
#define NumParams 63

int ReflectanceShaderID;

char Name[] = "vomatshader";
char* Params[NumParams] = { 
	"ShaderText", 
	"SurfaceType",
	"Color",
	"CustomColor",
	"ColorText",
	"Ka",
	"CustomKa",
	"KaText",
	
	"UseAmbientColor",
	"AmbientColor",
	"CustomAmbientColor",
	"AmbientColorText",
	
	"Kd",
	"CustomKd",
	"KdText",
	
	"Kb",
	"CustomKb",
	"KbText",
	
	"Ks",
	"CustomKs",
	"KsText",
	
	"UseSpecularColor",
	"SpecularColor",
	"CustomSpecularColor",
	"SpecularColorText",
	
	"BRDF",
	"CustomBRDF",
	"BRDFText",
	
	"BRDFType",
	
	"Kr",
	"CustomKr",
	"KrText",
	"KrBlur",
	
	"UseReflectionColor",
	"ReflectionColor",
	"CustomReflectionColor",
	"ReflectionColorText",
	
	"MetalAttribute",
	"CustomMetalAttribute",
	"MetalAttributeText",
	
	"Kt",
	"CustomKt",
	"KtText",
	
	"ior",

	"UseRefractionColor",
	"RefractionColor",
	"CustomRefractionColor",
	"RefractionColorText",

	
	"UseCaustics",
	"CausticsDensity",
	"CausticsInternal",
	
	"IridescenceAmount",
	"IridescenceFilm",
	"IridescenceTurb",
	
	"IrradianceSamples",

	"UseNormalModifier",
	"NormalModifier",
	"UseDisplacementMapping",
	"DisplacementMapping",

	"DeclarationFile",

	"Absorption",

	"DispersionAmount",
	"DispersionSamples"
};


tsxSHPARAM_TYPE Types[NumParams] = { 
	tsxSHPARAM_STRING, 
	tsxSHPARAM_SHORT,
	tsxSHPARAM_COLOR,
	tsxSHPARAM_BOOL,
	tsxSHPARAM_STRING,
	tsxSHPARAM_FLOAT,
	tsxSHPARAM_BOOL,
	tsxSHPARAM_STRING,

	tsxSHPARAM_BOOL,
	tsxSHPARAM_COLOR,
	tsxSHPARAM_BOOL,
	tsxSHPARAM_STRING,

	tsxSHPARAM_FLOAT,
	tsxSHPARAM_BOOL,
	tsxSHPARAM_STRING,

	tsxSHPARAM_FLOAT,
	tsxSHPARAM_BOOL,
	tsxSHPARAM_STRING,

	tsxSHPARAM_FLOAT,
	tsxSHPARAM_BOOL,
	tsxSHPARAM_STRING,

	tsxSHPARAM_BOOL,
	tsxSHPARAM_COLOR,
	tsxSHPARAM_BOOL,
	tsxSHPARAM_STRING,

	tsxSHPARAM_FLOAT,
	tsxSHPARAM_BOOL,
	tsxSHPARAM_STRING,

	tsxSHPARAM_SHORT,

	tsxSHPARAM_FLOAT,
	tsxSHPARAM_BOOL,
	tsxSHPARAM_STRING,
	tsxSHPARAM_FLOAT,

	tsxSHPARAM_BOOL,
	tsxSHPARAM_COLOR,
	tsxSHPARAM_BOOL,
	tsxSHPARAM_STRING,

	tsxSHPARAM_FLOAT,
	tsxSHPARAM_BOOL,
	tsxSHPARAM_STRING,

	tsxSHPARAM_FLOAT,
	tsxSHPARAM_BOOL,
	tsxSHPARAM_STRING,
	
	tsxSHPARAM_FLOAT,

	tsxSHPARAM_BOOL,
	tsxSHPARAM_COLOR,
	tsxSHPARAM_BOOL,
	tsxSHPARAM_STRING,

	tsxSHPARAM_BOOL,
	tsxSHPARAM_FLOAT,
	tsxSHPARAM_BOOL,

	tsxSHPARAM_FLOAT,
	tsxSHPARAM_FLOAT,
	tsxSHPARAM_FLOAT,

	tsxSHPARAM_SHORT,

	tsxSHPARAM_BOOL,
	tsxSHPARAM_STRING,
	tsxSHPARAM_BOOL,
	tsxSHPARAM_STRING,

	tsxSHPARAM_STRING,

	tsxSHPARAM_FLOAT,

	tsxSHPARAM_FLOAT,
	tsxSHPARAM_SHORT

};


char ShaderText[4096] = "none";
short SurfaceType = VLS_Plain;

tssColor Color = { 1.0f, 1.0f, 1.0f };
bool CustomColor = false;
char ColorText[MAXPARAMLENGTH] = "'1, 1, 1'";


float Ka = 0.0f;
bool CustomKa = false;
char KaText[MAXPARAMLENGTH] = "0.0";

bool UseAmbientColor = false;
tssColor AmbientColor = { 1, 1, 1 };
bool CustomAmbientColor = false;
char AmbientColorText[MAXPARAMLENGTH] = "'1, 1, 1'";

float Kd = 1.0f;
bool CustomKd = false;
char KdText[MAXPARAMLENGTH] = "1.0";

float Kb = 0.0f;
bool CustomKb = false;
char KbText[MAXPARAMLENGTH] = "0.0";

float Ks = 0.5f;
bool CustomKs = false;
char KsText[MAXPARAMLENGTH] = "0.5";

bool UseSpecularColor = false;
tssColor SpecularColor = { 1, 1, 1 };
bool CustomSpecularColor = false;
char SpecularColorText[MAXPARAMLENGTH] = "'1, 1, 1'";

float BRDF = 25.0f;
bool CustomBRDF = false;
char BRDFText[MAXPARAMLENGTH] = "25.0";

short BRDFType = 2;


float Kr = 0.0f;
bool CustomKr = false;
char KrText[MAXPARAMLENGTH] = "0.0";
float KrBlur = 0.0f;

bool UseReflectionColor = false;
tssColor ReflectionColor = { 1, 1, 1 };
bool CustomReflectionColor = false;
char ReflectionColorText[MAXPARAMLENGTH] = "'1, 1, 1'";

float MetalAttribute = 0.0f;
bool CustomMetalAttribute = false;
char MetalAttributeText[MAXPARAMLENGTH] = "0.0";

float Kt = 0.0f;
bool CustomKt = false;
char KtText[MAXPARAMLENGTH] = "0.0";

float ior = 1.6f;

bool UseRefractionColor = true;
tssColor RefractionColor = { 1, 1, 1 };
bool CustomRefractionColor = false;
char RefractionColorText[MAXPARAMLENGTH] = "'1, 1, 1'";

bool		UseCaustics = false;
float	CausticsDensity = 0.0f;
bool		CausticsInternal = false;

float IridescenceAmount = 0.0f;
float IridescenceFilm = 0.0f;
float IridescenceTurb = 0.0f;

short IrradianceSamples = 0;

bool UseNormalModifier = false;
char NormalModifier[MAXPARAMLENGTH] = "none";

bool UseDisplacementMapping;
char DisplacementMapping[MAXPARAMLENGTH] = "none";

char DeclarationFile[_MAX_PATH] = "none";

float Absorption = 0.0f;

float DispersionAmount = 1.0f;
short DispersionSamples = 15;

//char* pDeclarations;

// these will help us cache our shader settings to speed up execution
tsxSHINFO *oldreflinfo;

/////////////////////////////////////////////////////////////////////////////
// CBlankshaderApp

BEGIN_MESSAGE_MAP(CBlankshaderApp, CWinApp)
	//{{AFX_MSG_MAP(CBlankshaderApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBlankshaderApp construction

CBlankshaderApp::CBlankshaderApp()
{
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CBlankshaderApp object

CBlankshaderApp theApp;


// this is where we setup our shader - it is the only function exported in the
// shader DLL
void tsxShaderInitialize(tssData* data, int ID)
{
	// call this function at the start of any exported function
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	ReflectanceShaderID = ID;	// Store for later use
	tssCustomShaderSetBitmapID(ID, IDB_REFICON);
	data->nClass = tsxSHCLASS_REFLECTANCE;
	
	data->sName = Name;
	data->nDispNameID = IDS_NAME;
	data->nHelpID = IDS_HELP;
	data->nNumParam = NumParams;
	data->pParamName = Params;
	data->pParamType = Types;

	data->pfnShowInterface = OnShowInterface;
	data->pfnGetParameterValue = GetParameterValue;
	data->pfnSetParameterValue = SetParameterValue;
	data->pfnExecute = Execute;
	/*data->pfnSave = OnSave;
	data->pfnLoad = OnLoad;
	data->pfnCompare = OnCompare;*/

	
}

/*
void OnSave(tsxSHINFO* pShinfo, tssFILE_DESC* pDesc)
{
	tsxSHADER* pShd = tsxShaderInfoGetShader(pShinfo);

	long size;
	char* data = tsxShaderGetCustomData(pShd,&size);
	if (size > 0)
	{
		tsxFILEprintf((tsxFILE*)pDesc->file,"Declarations %s\n", data);
	}

	return;
}

void OnLoad(tsxSHINFO* pShinfo, tssFILE_DESC* pDesc)
{
	char tempbuf[1024];

	tsxSHADER* pShd = tsxShaderInfoGetShader(pShinfo);

	tsxShaderFreeCustomData(pShd);

	char* data=tsxShaderAllocCustomData(pShd, 4096);
	
	if (data)
	{
		tsxFILEscanf((tsxFILE*)pDesc->file,"%s %s\n", tempbuf, data);
	}


	return;
}

long OnCompare(long v1, void* p1, long v2, void* p2)
{
	if (p1)
	{
		if (strcmp((char*)p1,(char*)p2) == 0)
			return 1;

		return 0;
	}
	
	return 1;
}
*/


// this is where we respond to interface messages trueSpace sends
void OnShowInterface(tssISTATE state)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	switch (state)
	{
		case tssISTATE_STAY:
		{
			TRACE("*** Stay\n");
		}
		break;
		case tssISTATE_SHOW:
		{
			TRACE("*** Show\n");
			if(m_pMainDialog == NULL)
			{
				m_pMainDialog = new CMainDlg();
				m_pMainDialog->Create(IDD_MAINDLG);
			}		

			m_pMainDialog->ShowWindow(SW_SHOW);

		}
		break;
		case tssISTATE_HIDE:
		{
			TRACE("*** Hide\n");
			if(m_pMainDialog != NULL)
				m_pMainDialog->DestroyWindow();
		}
		break;
		case tssISTATE_DESTROY:
		{
			TRACE("*** Destroy\n");
			if(m_pMainDialog != NULL)
				m_pMainDialog->DestroyWindow();

		}
		break;
		case tssISTATE_UPDATE:
		{
			TRACE("*** Update\n");
			if (m_pMainDialog != NULL)
				m_pMainDialog->UpdateInterface();
		}
		break;
		
	}

}

// in this function we look to see what parameter is being requested by name,
// then return the correct parameter value
void* GetParameterValue(char* name)
{
	if (strcmp("ShaderText", name) == 0)
	{
		return (void*)(&ShaderText);
	}

	if (strcmp("SurfaceType", name) == 0)
	{
		return (void*)(&SurfaceType);
	}
	
	if (strcmp("Color", name) == 0)
	{
		return (void*)(&Color);
	}

	if (strcmp("CustomColor", name) == 0)
	{
		return (void*)(&CustomColor);
	}

	if (strcmp("ColorText", name) == 0)
	{
		return (void*)(&ColorText);
	}
	
	
	if (strcmp("Ka", name) == 0)
	{
		return (void*)(&Ka);
	}
	
	if (strcmp("CustomKa", name) == 0)
	{
		return (void*)(&CustomKa);
	}
	
	if (strcmp("KaText", name) == 0)
	{
		return (void*)(&KaText);
	}
	
	if (strcmp("UseAmbientColor", name) == 0)
	{
		return (void*)(&UseAmbientColor);
	}
	
	if (strcmp("AmbientColor", name) == 0)
	{
		return (void*)(&AmbientColor);
	}
	
	if (strcmp("CustomAmbientColor", name) == 0)
	{
		return (void*)(&CustomAmbientColor);
	}
	
	if (strcmp("AmbientColorText", name) == 0)
	{
		return (void*)(&AmbientColorText);
	}
	
	if (strcmp("Kd", name) == 0)
	{
		return (void*)(&Kd);
	}
	
	if (strcmp("CustomKd", name) == 0)
	{
		return (void*)(&CustomKd);
	}
	
	if (strcmp("KdText", name) == 0)
	{
		return (void*)(&KdText);
	}
	
	if (strcmp("Kb", name) == 0)
	{
		return (void*)(&Kb);
	}
	
	if (strcmp("CustomKb", name) == 0)
	{
		return (void*)(&CustomKb);
	}
	
	if (strcmp("KbText", name) == 0)
	{
		return (void*)(&KbText);
	}
	
	if (strcmp("Ks", name) == 0)
	{
		return (void*)(&Ks);
	}
	
	if (strcmp("CustomKs", name) == 0)
	{
		return (void*)(&CustomKs);
	}
	
	if (strcmp("KsText", name) == 0)
	{
		return (void*)(&KsText);
	}
	
	if (strcmp("UseSpecularColor", name) == 0)
	{
		return (void*)(&UseSpecularColor);
	}
	
	if (strcmp("SpecularColor", name) == 0)
	{
		return (void*)(&SpecularColor);
	}
	
	if (strcmp("CustomSpecularColor", name) == 0)
	{
		return (void*)(&CustomSpecularColor);
	}
	
	if (strcmp("SpecularColorText", name) == 0)
	{
		return (void*)(&SpecularColorText);
	}
	
	if (strcmp("BRDF", name) == 0)
	{
		return (void*)(&BRDF);
	}
	
	if (strcmp("CustomBRDF", name) == 0)
	{
		return (void*)(&CustomBRDF);
	}
	
	if (strcmp("BRDFText", name) == 0)
	{
		return (void*)(&BRDFText);
	}
	
	if (strcmp("BRDFType", name) == 0)
	{
		return (void*)(&BRDFType);
	}
	
	if (strcmp("Kr", name) == 0)
	{
		return (void*)(&Kr);
	}
	
	if (strcmp("CustomKr", name) == 0)
	{
		return (void*)(&CustomKr);
	}
	
	if (strcmp("KrText", name) == 0)
	{
		return (void*)(&KrText);
	}
	
	if (strcmp("KrBlur", name) == 0)
	{
		return (void*)(&KrBlur);
	}
	
	if (strcmp("UseReflectionColor", name) == 0)
	{
		return (void*)(&UseReflectionColor);
	}
	
	if (strcmp("ReflectionColor", name) == 0)
	{
		return (void*)(&ReflectionColor);
	}
	
	if (strcmp("CustomReflectionColor", name) == 0)
	{
		return (void*)(&CustomReflectionColor);
	}
	
	if (strcmp("ReflectionColorText", name) == 0)
	{
		return (void*)(&ReflectionColorText);
	}

	if (strcmp("UseRefractionColor", name) == 0)
	{
		return (void*)(&UseRefractionColor);
	}
	
	if (strcmp("RefractionColor", name) == 0)
	{
		return (void*)(&RefractionColor);
	}
	
	if (strcmp("CustomRefractionColor", name) == 0)
	{
		return (void*)(&CustomRefractionColor);
	}
	
	if (strcmp("RefractionColorText", name) == 0)
	{
		return (void*)(&RefractionColorText);
	}
	
	if (strcmp("MetalAttribute", name) == 0)
	{
		return (void*)(&MetalAttribute);
	}
	
	if (strcmp("CustomMetalAttribute", name) == 0)
	{
		return (void*)(&CustomMetalAttribute);
	}
	
	if (strcmp("MetalAttributeText", name) == 0)
	{
		return (void*)(&MetalAttributeText);
	}
	
	if (strcmp("Kt", name) == 0)
	{
		return (void*)(&Kt);
	}
	
	if (strcmp("CustomKt", name) == 0)
	{
		return (void*)(&CustomKt);
	}
	
	if (strcmp("KtText", name) == 0)
	{
		return (void*)(&KtText);
	}
	
	
	if (strcmp("ior", name) == 0)
	{
		return (void*)(&ior);
	}
	
	if (strcmp("UseCaustics", name) == 0)
	{
		return (void*)(&UseCaustics);
	}
	
	if (strcmp("CausticsDensity", name) == 0)
	{
		return (void*)(&CausticsDensity);
	}
	
	if (strcmp("CausticsInternal", name) == 0)
	{
		return (void*)(&CausticsInternal);
	}
	
	if (strcmp("IridescenceAmount", name) == 0)
	{
		return (void*)(&IridescenceAmount);
	}
	
	if (strcmp("IridescenceFilm", name) == 0)
	{
		return (void*)(&IridescenceFilm);
	}
	
	if (strcmp("IridescenceTurb", name) == 0)
	{
		return (void*)(&IridescenceTurb);
	}
	
	if (strcmp("IrradianceSamples", name) == 0)
	{
		return (void*)(&IrradianceSamples);
	}

	if (strcmp("UseNormalModifier", name) == 0)
	{
		return (void*)(&UseNormalModifier);
	}

	if (strcmp("NormalModifier", name) == 0)
	{
		return (void*)(&NormalModifier);
	}

	if (strcmp("UseDisplacementMapping", name) == 0)
	{
		return (void*)(&UseDisplacementMapping);
	}

	if (strcmp("DisplacementMapping", name) == 0)
	{
		return (void*)(&DisplacementMapping);
	}

	if (strcmp("DeclarationFile", name) == 0)
	{
		return (void*)(&DeclarationFile);
	}
	
	if (strcmp("Absorption", name) == 0)
	{
		return (void*)(&Absorption);
	}

	if (strcmp("DispersionAmount", name) == 0)
	{
		return (void*)(&DispersionAmount);
	}

	if (strcmp("DispersionSamples", name) == 0)
	{
		return (void*)(&DispersionSamples);
	}
	

	return NULL;
}

// in this function, we have to set the correct value for a parameter being
// passed by name
void SetParameterValue(char* name, void* value)
{
	// if we are being called without a valid value, exit
	if (!value)
		return;

	if (strcmp("ShaderText", name) == 0)
	{
		strcpy( ShaderText, (char*)value );
		return;
	}

	if (strcmp("SurfaceType", name) == 0)
	{
		SurfaceType = *((short*)value);
		return;
	}

	if (strcmp("Color", name) == 0)
	{
		tssColor* pColor = (tssColor*)value;
		Color[0] = (*pColor)[0];
		Color[1] = (*pColor)[1];
		Color[2] = (*pColor)[2];
		return;
	}

	if (strcmp("CustomColor", name) == 0)
	{
		CustomColor = *((bool*)value);
		return;
	}

	if (strcmp("ColorText", name) == 0)
	{
		strcpy( ColorText, (char*)value );
		return;
	}
	
	if (strcmp("Ka", name) == 0)
	{
		Ka = *((float*)value);
		return;
	}
	
	if (strcmp("CustomKa", name) == 0)
	{
		CustomKa = *((bool*)value);
		return;
	}
	
	if (strcmp("KaText", name) == 0)
	{
		strcpy( KaText, (char*)value );
		return;
	}
	
	if (strcmp("UseAmbientColor", name) == 0)
	{
		UseAmbientColor = *((bool*)value);
		return;
	}

	if (strcmp("AmbientColor", name) == 0)
	{
		tssColor* pColor = (tssColor*)value;
		AmbientColor[0] = (*pColor)[0];
		AmbientColor[1] = (*pColor)[1];
		AmbientColor[2] = (*pColor)[2];
		return;
	}
	
	if (strcmp("CustomAmbientColor", name) == 0)
	{
		CustomAmbientColor = *((bool*)value);
		return;
	}
	
	if (strcmp("AmbientColorText", name) == 0)
	{
		strcpy( AmbientColorText, (char*)value );
		return;
	}
	
	if (strcmp("Kd", name) == 0)
	{
		Kd = *((float*)value);
		return;
	}
	
	if (strcmp("CustomKd", name) == 0)
	{
		CustomKd = *((bool*)value);
		return;
	}
	
	if (strcmp("KdText", name) == 0)
	{
		strcpy( KdText, (char*)value );
		return;
	}
	
	if (strcmp("Kb", name) == 0)
	{
		Kb = *((float*)value);
		return;
	}
	
	if (strcmp("CustomKb", name) == 0)
	{
		CustomKb = *((bool*)value);
		return;
	}
	
	if (strcmp("KbText", name) == 0)
	{
		strcpy( KbText, (char*)value );
		return;
	}
	
	if (strcmp("Ks", name) == 0)
	{
		Ks = *((float*)value);
		return;
	}
	
	if (strcmp("CustomKs", name) == 0)
	{
		CustomKs = *((bool*)value);
		return;
	}
	
	if (strcmp("KsText", name) == 0)
	{
		strcpy( KsText, (char*)value );
		return;
	}
	
	if (strcmp("UseSpecularColor", name) == 0)
	{
		UseSpecularColor = *((bool*)value);
		return;
	}
	
	if (strcmp("SpecularColor", name) == 0)
	{
		tssColor* pColor = (tssColor*)value;
		SpecularColor[0] = (*pColor)[0];
		SpecularColor[1] = (*pColor)[1];
		SpecularColor[2] = (*pColor)[2];
		return;
	}
	
	if (strcmp("CustomSpecularColor", name) == 0)
	{
		CustomSpecularColor = *((bool*)value);
		return;
	}
	
	if (strcmp("SpecularColorText", name) == 0)
	{
		strcpy( SpecularColorText, (char*)value );
		return;
	}
	
	if (strcmp("BRDF", name) == 0)
	{
		BRDF = *((float*)value);
		return;
	}
	
	if (strcmp("CustomBRDF", name) == 0)
	{
		CustomBRDF = *((bool*)value);
		return;
	}
	
	if (strcmp("BRDFText", name) == 0)
	{
		strcpy( BRDFText, (char*)value );
		return;
	}
	
	if (strcmp("BRDFType", name) == 0)
	{
		BRDFType = *((short*)value);
		return;
	}
	
	if (strcmp("Kr", name) == 0)
	{
		Kr = *((float*)value);
		return;
	}
	
	if (strcmp("CustomKr", name) == 0)
	{
		CustomKr = *((bool*)value);
		return;
	}
	
	if (strcmp("KrText", name) == 0)
	{
		strcpy( KrText, (char*)value );
		return;
	}
	
	if (strcmp("KrBlur", name) == 0)
	{
		KrBlur = *((float*)value);
		return;
	}
	
	if (strcmp("UseReflectionColor", name) == 0)
	{
		UseReflectionColor = *((bool*)value);
		return;
	}
	
	if (strcmp("ReflectionColor", name) == 0)
	{
		tssColor* pColor = (tssColor*)value;
		ReflectionColor[0] = (*pColor)[0];
		ReflectionColor[1] = (*pColor)[1];
		ReflectionColor[2] = (*pColor)[2];
		return;
	}
	
	if (strcmp("CustomReflectionColor", name) == 0)
	{
		CustomReflectionColor = *((bool*)value);
		return;
	}
	
	if (strcmp("ReflectionColorText", name) == 0)
	{
		strcpy( ReflectionColorText, (char*)value );
		return;
	}


	if (strcmp("UseRefractionColor", name) == 0)
	{
		UseRefractionColor = *((bool*)value);
		return;
	}
	
	if (strcmp("RefractionColor", name) == 0)
	{
		tssColor* pColor = (tssColor*)value;
		RefractionColor[0] = (*pColor)[0];
		RefractionColor[1] = (*pColor)[1];
		RefractionColor[2] = (*pColor)[2];
		return;
	}
	
	if (strcmp("CustomRefractionColor", name) == 0)
	{
		CustomRefractionColor = *((bool*)value);
		return;
	}
	
	if (strcmp("RefractionColorText", name) == 0)
	{
		strcpy( RefractionColorText, (char*)value );
		return;
	}
	
	if (strcmp("MetalAttribute", name) == 0)
	{
		MetalAttribute = *((float*)value);
		return;
	}
	
	if (strcmp("CustomMetalAttribute", name) == 0)
	{
		CustomMetalAttribute = *((bool*)value);
		return;
	}
	
	if (strcmp("MetalAttributeText", name) == 0)
	{
		strcpy( MetalAttributeText, (char*)value );
		return;
	}
	
	if (strcmp("Kt", name) == 0)
	{
		Kt = *((float*)value);
		return;
	}
	
	if (strcmp("CustomKt", name) == 0)
	{
		CustomKt = *((bool*)value);
		return;
	}
	
	if (strcmp("KtText", name) == 0)
	{
		strcpy( KtText, (char*)value );
		return;
	}
	
	
	if (strcmp("ior", name) == 0)
	{
		ior = *((float*)value);
		return;
	}
	
	if (strcmp("UseCaustics", name) == 0)
	{
		UseCaustics = *((bool*)value);
		return;
	}
	
	if (strcmp("CausticsDensity", name) == 0)
	{
		CausticsDensity = *((float*)value);
		return;
	}
	
	if (strcmp("CausticsInternal", name) == 0)
	{
		CausticsInternal = *((bool*)value);
		return;
	}
	
	if (strcmp("IridescenceAmount", name) == 0)
	{
		IridescenceAmount = *((float*)value);
		return;
	}
	
	if (strcmp("IridescenceFilm", name) == 0)
	{
		IridescenceFilm = *((float*)value);
		return;
	}
	
	if (strcmp("IridescenceTurb", name) == 0)
	{
		IridescenceTurb = *((float*)value);
		return;
	}
	
	if (strcmp("IrradianceSamples", name) == 0)
	{
		IrradianceSamples = *((short*)value);
		return;
	}

	if (strcmp("UseNormalModifier", name) == 0)
	{
		UseNormalModifier = *((bool*)value);
		return;
	}
	
	if (strcmp("NormalModifier", name) == 0)
	{
		strcpy( NormalModifier, (char*)value );
		return;
	}

	if (strcmp("UseDisplacementMapping", name) == 0)
	{
		UseDisplacementMapping = *((bool*)value);
		return;
	}
	
	if (strcmp("DisplacementMapping", name) == 0)
	{
		strcpy( DisplacementMapping, (char*)value );
		return;
	}

	if (strcmp("DeclarationFile", name) == 0)
	{
		strcpy( DeclarationFile, (char*)value );
		return;
	}

	if (strcmp("Absorption", name) == 0)
	{
		Absorption = *((float*)value);
		return;
	}

	if (strcmp("DispersionAmount", name) == 0)
	{
		DispersionAmount = *((float*)value);
		return;
	}

	if (strcmp("DispersionSamples", name) == 0)
	{
		DispersionSamples = *((short*)value);
		return;
	}
}


tsxImage SampleTGA;

// this is our main function, that manages parameters and calculates the shader code
void Execute(tsxSHINFO* shinfo, tssSurface* surface, tssACTION action)
{
	// look to see what action is being requested
	switch(action)
	{
		// called when the shader is being loaded by trueSpace
		case tssACTION_LOAD:
			TRACE("Shader being loaded (%s)\n", Name);
			break;
		
		// destroy the sample image and delete the image file
		case tssACTION_UNLOAD:
			TRACE("Shader being unloaded (%s)\n", Name);
			tsxImageDestroyData(&SampleTGA);
			char tempdir[_MAX_PATH];
			GetTempPath(_MAX_PATH, tempdir);
			char samplename[_MAX_PATH];
			sprintf(samplename, "%s\\vomatsample.tga", tempdir);
			DeleteFile(samplename);
			break;

		// called once before rendering
		case tssACTION_INIT:
		{
			TRACE("Shader being initialized (%s)\n", Name);
			// load the sample TGA if needed
			char tempdir[_MAX_PATH];
			GetTempPath(_MAX_PATH, tempdir);
			char samplename[_MAX_PATH];
			sprintf(samplename, "%s\\vomatsample.tga", tempdir);

			if (FileExists(samplename))
			{
				tsxImageLoadData(&SampleTGA, samplename);
			}
			else
			{
				// we need to render it, so:
				if (m_pMainDialog)
				{
					if (m_pMainDialog->m_dorendersample.Checked)
						m_pMainDialog->RenderMaterialSample();
				}
				tsxImageLoadData(&SampleTGA, samplename);
			}
		}
		break;

		// this is the meat, executed for every shading point
		case tssACTION_PREVIEW:
		case tssACTION_FULL:
		{
			// look to see if we need to pass new parameters
			bool Cached = FALSE;
			if (shinfo == oldreflinfo)
				Cached = TRUE;

			// if we do need to get new parameters, this is how we do so
			// this is a generic loop that can work for other shaders
			// regardless of parameter type
			if( ((shinfo != NULL) && (Cached == FALSE))  )
			{
				
				for(int i = 0; i < NumParams; i++)
				{
					char name[32];
					tsxShaderInfoGetParameterName(shinfo, i, name);
					tsxSHPARAMVAL* pVal = tsxShaderInfoGetParameterValue(shinfo, i);
					
					tsxSHPARAM_TYPE thetype = tsxParameterValueGetType(pVal);
					
					
					switch(thetype)
					{
						case tsxSHPARAM_BOOL:
						{
							bool b;
							tsxParameterValueGetTypedValue(pVal, tsxSHPARAM_BOOL, (void*)&b);
							SetParameterValue(name, (void*)&b);
						}
						break;
						
						case tsxSHPARAM_FLOAT:
						{
							float f;
							tsxParameterValueGetTypedValue(pVal, tsxSHPARAM_FLOAT, (void*)&f);
							SetParameterValue(name, (void*)&f);
						}
						break;
						
						case tsxSHPARAM_SHORT:
						{
							short s;
							tsxParameterValueGetTypedValue(pVal, tsxSHPARAM_SHORT, (void*)&s);
							SetParameterValue(name, (void*)&s);
						}
						break;
						
						case tsxSHPARAM_STRING:
						{
							char* pC;
							tsxParameterValueGetTypedValue(pVal, tsxSHPARAM_STRING, (void*)&pC);
							SetParameterValue(name, (void*)pC);
						}
						break;

						case tsxSHPARAM_COLOR:
						{
							tssColor c;
							tsxParameterValueGetTypedValue(pVal, tsxSHPARAM_COLOR, (void*)&c);
							SetParameterValue(name, (void*)&c);
						}
						break;
					}


				}

				

			}


			// now save the shader info for caching
			oldreflinfo = shinfo;
			
			tssColor OutColor, DiffuseTerm, AmbientTerm, SpecularTerm, Reflect, Refract;
				
			if (SampleTGA.data == NULL)
			{
				

				tssDiffuseTerm(DiffuseTerm);
				tssAmbientTerm(AmbientTerm);
				tssPhongTerm(SpecularTerm, 1.0f / (BRDF / 45.0f));
				

				OutColor[0] = (Color[0] * (Ka * AmbientTerm[0] + Kd * DiffuseTerm[0]) +
					SpecularColor[0] * (Ks*SpecularTerm[0]));
				OutColor[1] = (Color[1] * (Ka * AmbientTerm[1] + Kd * DiffuseTerm[1]) +
					SpecularColor[1] * (Ks*SpecularTerm[1]));
				OutColor[2] = (Color[2] * (Ka * AmbientTerm[2] + Kd * DiffuseTerm[2]) +
					SpecularColor[2] * (Ks*SpecularTerm[2]));

				tssVector Rdir, Tdir;
				float RefFrac;

				if ( (Kt > 0.0f) || (Kr > 0.0f) )
					tssFresnelSolidReflect(&RefFrac, Rdir, Tdir, ior);

				if (Kt > 0.0f)
				{
					tssColor filter;
					tssColorScale(filter, Kt, Color);	

					tssRayTrace(Refract, surface->Pw, Tdir, MAX3(filter[0], filter[1], filter[2]) );
					tssColorFilter(Refract, filter, Refract);
					tssColorIncrement(OutColor, Refract);
					
				}

				if (Kr > 0.0f)
				{
					tssRayTrace(Reflect, surface->Pw, Rdir, Kr);
					tssColorIncrement(OutColor, Reflect);
				}
			}
			else
			{
				unsigned long x, y;
				tssTile(surface->u, surface->v, 1.0, 1.0, 0.0, 0.0,
						SampleTGA.width, SampleTGA.height, x, y);

				CtsxColor pixel = GetFilteredPixel(x, y, SampleTGA);

				tssColorInitialise(OutColor, pixel.red / 255.0f, pixel.green / 255.0f, pixel.blue / 255.0f);

			}

			
			// calculate the reflectance
			tssColorAssign(surface->Co, OutColor);

		}	
	}
}

BOOL CBlankshaderApp::InitInstance() 
{
	SetRegistryKey("cool powers");

	SetDialogBkColor( RGB(192, 192, 192), RGB(0, 0, 0) );

	return CWinApp::InitInstance();
}
