// blankshader.h : main header file for the BLANKSHADER DLL
//

#if !defined(AFX_BLANKTSX_H__169FC6F1_143C_4AE1_823D_A606A7766DC7__INCLUDED_)
#define AFX_BLANKTSX_H__169FC6F1_143C_4AE1_823D_A606A7766DC7__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"		// main symbols

// include the tSX headers
#include "tsx.h"

// we will use this pointer to keep track of the dialog interface
#include "MainDlg.h"
extern CMainDlg* m_pMainDialog;

// declaration of our shader functions
void OnShowInterface(tssISTATE);
void* GetParameterValue(char*);
void SetParameterValue(char*, void*);
void Execute(tsxSHINFO*, tssSurface*, tssACTION);
void OnSave(tsxSHINFO* pShinfo, tssFILE_DESC* pDesc);
void OnLoad(tsxSHINFO* pShinfo, tssFILE_DESC* pDesc);
long OnCompare(long v1, void* p1, long v2, void* p2);

extern int ReflectanceShaderID;

#define MAXPARAMLENGTH 255
// our shader parameters
extern char ShaderText[4096];

extern short SurfaceType;

extern tssColor Color;
extern bool CustomColor;
extern char ColorText[MAXPARAMLENGTH];


extern float Ka;
extern bool CustomKa;
extern char KaText[MAXPARAMLENGTH];

extern bool UseAmbientColor;
extern tssColor AmbientColor;
extern bool CustomAmbientColor;
extern char AmbientColorText[MAXPARAMLENGTH];

extern float Kd;
extern bool CustomKd;
extern char KdText[MAXPARAMLENGTH];

extern float Kb;
extern bool CustomKb;
extern char KbText[MAXPARAMLENGTH];

extern float Ks;
extern bool CustomKs;
extern char KsText[MAXPARAMLENGTH];

extern bool UseSpecularColor;
extern tssColor SpecularColor;
extern bool CustomSpecularColor;
extern char SpecularColorText[MAXPARAMLENGTH];

extern float BRDF;
extern bool CustomBRDF;
extern char BRDFText[MAXPARAMLENGTH];

extern short BRDFType;


extern float Kr;
extern bool CustomKr;
extern char KrText[MAXPARAMLENGTH];
extern float KrBlur;

extern bool UseReflectionColor;
extern tssColor ReflectionColor;
extern bool CustomReflectionColor;
extern char ReflectionColorText[MAXPARAMLENGTH];

extern float MetalAttribute;
extern bool CustomMetalAttribute;
extern char MetalAttributeText[MAXPARAMLENGTH];

extern float Kt;
extern bool CustomKt;
extern char KtText[MAXPARAMLENGTH];

extern float ior;

extern bool UseRefractionColor;
extern tssColor RefractionColor;
extern bool CustomRefractionColor;
extern char RefractionColorText[MAXPARAMLENGTH];

extern bool		UseCaustics;
extern float	CausticsDensity;
extern bool		CausticsInternal;

extern float IridescenceAmount;
extern float IridescenceFilm;
extern float IridescenceTurb;

extern short IrradianceSamples;


extern bool UseNormalModifier;
extern char NormalModifier[MAXPARAMLENGTH];

extern bool UseDisplacementMapping;
extern char DisplacementMapping[MAXPARAMLENGTH];

extern char DeclarationFile[_MAX_PATH];

extern float Absorption;

extern float DispersionAmount;
extern short DispersionSamples;

/*extern char* pDeclarations;
#define DeclarationsSize 4096*/

#define	VLS_Plain		0
#define VLS_Pattern		1
#define	VLS_Functional	2

/////////////////////////////////////////////////////////////////////////////
// CBlankshaderApp
// See blankshader.cpp for the implementation of this class
//

class CBlankshaderApp : public CWinApp
{
public:
	CBlankshaderApp();
	
	bool RenderingSample;

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBlankshaderApp)
	public:
	virtual BOOL InitInstance();
	//}}AFX_VIRTUAL

	//{{AFX_MSG(CBlankshaderApp)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

extern CBlankshaderApp theApp;

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_BLANKTSX_H__169FC6F1_143C_4AE1_823D_A606A7766DC7__INCLUDED_)
